#include "ClusterUtils.h"

ClusterUtils::ClusterUtils(void)
{
}

ClusterUtils::~ClusterUtils(void)
{
}


jcluster* ClusterUtils::create_cluster( char *image, jcluster *prev,
                                        int *count,int height, int width)
{
   //int result;
   jcluster *new_cluster;
   char *cluster_image;
   int i;
   //char instring[80];
   int image_size;
   char *cresult;

   image_size = height*width;

   //   cluster_image = (char *) calloc(image_size, 1);
   cluster_image = new char [image_size];
 
   cresult = (char*)memcpy(cluster_image, image, image_size);
   /*printf("memcpy result: %d\n",result); */
   for (i=0;i< image_size;i++)
      cluster_image[i] = image[i]; 
   
   //new_cluster  = (jcluster *) calloc(1,sizeof(jcluster));

   new_cluster  = new jcluster();
   memset(new_cluster, 0, sizeof(jcluster));
    

   new_cluster->first_image = cluster_image;
   // new_cluster->centroid = (int *) calloc(sizeof(int) ,
   //     image_size);

   new_cluster->centroid = new int[image_size];
   memset(new_cluster->centroid, 0, sizeof(int)*image_size);

   for (i=0;i< image_size;i++)
   {
      /* orgininally 1 is -1 */
      if (image[i] != 0)
         new_cluster->centroid[i] = 1;
   }
   new_cluster->prev =  (jcluster_ptr ) prev;
   new_cluster->next =  NULL;
   new_cluster->count = 1;
   if (prev != NULL)
      prev->next= new_cluster;
   *count = *count+1;
   return (new_cluster);
}


int ClusterUtils::add_to_cluster(jcluster *cluster, char *image,
                                 int height, int width)
{
   int i;
   int image_size;

   image_size = height*width;

   cluster->count++;

   /* do a pixel by pixel add for the centroid.  After
      all clusters have bee computed then centroid will
      be divided by the number in the cluster */

   for (i=0;i<image_size;i++)
   {
      if (image[i] != 0)
      {
         cluster->centroid[i]++;
      }
   }
   return 1; // TBD
}

jcluster *ClusterUtils::filter_small_clusters(jcluster *first_cluster,
                                              int threshold,int *count)
{
   jcluster *cluster_ptr,*cluster_ptr1;
   jcluster *next_cluster;
   jcluster *prev_cluster;


   /* get rid of all clusters whose count is less
      then the threshold */

   cluster_ptr = first_cluster;

   while (cluster_ptr != NULL)
   {
      if (cluster_ptr->count < threshold)
      {

         cluster_ptr1 = cluster_ptr;
         /* free image */

         delete[] (cluster_ptr->first_image);
         delete (cluster_ptr->centroid);
         if (cluster_ptr->next != NULL)
         {
            next_cluster = (jcluster *) cluster_ptr->next;
            next_cluster->prev = cluster_ptr->prev;
         }
         else
            next_cluster = NULL;
         prev_cluster = (jcluster *) cluster_ptr->prev;
         if (prev_cluster != NULL)
            prev_cluster->next = cluster_ptr->next;
         if (cluster_ptr == first_cluster)
            first_cluster = next_cluster;
         cluster_ptr = next_cluster;
         delete (cluster_ptr1);
         *count = *count-1;
      }
      else
         cluster_ptr = (jcluster *) cluster_ptr->next;
   }

   return (first_cluster);
}


int ClusterUtils::match_to_clusters(char *image,jcluster *first_cluster,
                                    int hamming_number,int height,int width) 
{
   int match_count;
   jcluster *cluster_ptr;
   int i;
   jcluster *closest_cluster;
   int max_match_count;
   int result;
   int pixels;
   //int rescale_height;
   //int rescale_width;
   int min_hamming;
   //int bit;
   //int x;


   pixels = height*width;
   result = 0;
   max_match_count = 0;  /* set out of range */
   cluster_ptr = first_cluster;

   i = 0;
   min_hamming = pixels-hamming_number;
   closest_cluster = NULL;
   while (cluster_ptr != NULL)  {
      i++;
      match_count = JHamming::bytewise_hamming(cluster_ptr->first_image,
                                               image,pixels);
      if ((match_count > max_match_count) &&
          (match_count > min_hamming))  {
         /* add to cluster */
         closest_cluster = cluster_ptr;	
         max_match_count = match_count;
      }
      cluster_ptr = (jcluster *) cluster_ptr->next;
   }
   if (closest_cluster != NULL) {
      /*    printf("%%%% MATCH %%%%  Pixels alike %d %f\n", */
      /* 	   match_count,(float)match_count/(float)pixels);   */
      add_to_cluster(closest_cluster, image,height, width); 

 
   }
   else {
      /*     printf("NO MATCH\n"); */
      result = -1;
   };
   return (result);
}


