#ifndef _JHAMMING_H_
#define _JHAMMING_H_

/// Utilities to facilitate calculation of the hamming distance

/** The JHamming class contains several routines that are aimed at facilitating
 * calculation of the hamming distance between two arrays.
 */

class JHamming {
   //friend class JScript;

   public:
   /** Creates a lookup table that is used to speed up the calculation of
    * the hamming distance
    */
   static void CreateHammingLUT32(int* hamming_lookup,int bits_needed);
   /** Calculates the hamming distance 
    */
   static int bytewise_hamming(char *img1,  char *img2 ,int size);

};


#endif //_JHAMMING_H_
