#include "JMorphology.h"
#include "JStatistics.h"
#include "DLLogger.h"

void JMorphology::compress_to_bit(unsigned char *byte_array, unsigned char *destination,
                                  int bits_needed, int bytes_needed)
{
   unsigned char *ptr;
//unsigned char and_value;
   int i;
   unsigned char *ptr1;
   unsigned char or_val;
   int j;

/* it is assumed that the destination has already
   been zeroed out (use of calloc in calling routine */

   ptr = destination;
   ptr1 = byte_array;
   for (i=0;i< bytes_needed;i++)
   {
      or_val = 128;
      for (j=0; j <8 ; j++)
      {
         if (ptr1[i*8 + j] != 0)
            ptr[0] = ptr[0] | or_val;
         or_val = or_val >> 1;
      }
      ptr = ptr+1;

   }

}

int JMorphology::ConvertData32Bit(language_profile* first_lang,
                                  int iPixelRow, int iPixelCol,
                                  unsigned int** uippNewData) {
   /* convert all the information to 32 bit ints, to index each image
    * jump 50 chars
    */
   int iClusterCount;
   int iCount = 0;
   int iBytesNeeded;
   char* cpClusterData;
   int iRemainder;
   //int x,bit,i,j;
//  int iLUT[8] = {128,64,32,16,8,4,2,1};
   unsigned int* uipNewData;
  
   /* find out how many bytes you need */
   iBytesNeeded = (iPixelRow*iPixelCol)/(sizeof(int)*8);

   /* bytes remaining after main loop */
   iRemainder = ((iPixelRow*iPixelCol)%(sizeof(int)*8))/8;

   /* do we have stragglers */
   if (iRemainder > 0)
      iBytesNeeded++;

   /* how many clusters does this lang have */
   iClusterCount = first_lang->cluster_count;
  
   /* allocate enough space for new ints */
   //(*uippNewData) = (unsigned int*)calloc(iClusterCount*iBytesNeeded,
   //			sizeof(unsigned int));

   // (*uippNewData) = (unsigned int*)calloc(iClusterCount*iBytesNeeded,
//					sizeof(unsigned int));

   (*uippNewData) =  new unsigned int[iClusterCount*iBytesNeeded];

   /* point to the data in first lang */
   cpClusterData = first_lang->cluster_data;
   uipNewData = (*uippNewData);
  
   /* go through the cluster */
   for(iCount = 0; iCount < iClusterCount; iCount++) {
   
      ConvertUSCInt((*uippNewData),(unsigned char*)cpClusterData);
        
      /* change the pointers */
      cpClusterData = cpClusterData + 50;
      (*uippNewData) = (*uippNewData) + iBytesNeeded;    
   };

#ifdef DBG32BIT1
   /* reassign pointers */
   cpClusterData = first_lang->cluster_data;
   (*uippNewData) = uipNewData;

   /* print out the chars for debugging */
   for (j =0 ; j < first_lang->cluster_count; j++) {
      /* print out original */
      printf("---------------------------------\n");
      bit = 0;
      for(i=0; i < 50 ;i++) {
         for (x = 0; x < 8; x++) {
            if ((cpClusterData[i] & iLUT[x%8]) > 0 )
               printf("X");
            else
               printf(".");
            if (bit == 19) {
               printf("\n");
               bit=0;
            }
            else
               bit++;
         }
      };
      printf("\n");

      /* print out new */
      bit = 0;
      for(i=0; i < 12 ;i++) {
         for (x = 0; x < 32; x++) {
            if (((*uippNewData)[i] & (unsigned int)pow(2,31-x)) > 0 )
               printf("X");
            else
               printf(".");
            if (bit == 19) {
               printf("\n");
               bit=0;
            }
            else
               bit++;
         }
      };
      printf("\n");
      printf("---------------------------------\n");
      cpClusterData = cpClusterData + 50;
      (*uippNewData) = (*uippNewData) + iBytesNeeded;    
   };
#endif

   /* point to the beginning of the data */
   (*uippNewData) = uipNewData;
  
   /* lame return value */
   return( 0 );
}

int JMorphology::identify_and_orient(
   int hamming_number,
   int min_component_size, int max_height, int
   max_width, int min_height, int min_width,
   int min_symbol_count,
   float *blob_percent, 
   int symbolcount,
   int rescale_height, int rescale_width,
   int upper_offset,
   int lower_offset, int left_offset, int right_offset,
   float *reliability_threshold, 
   DLImage & strDocImage,   //	TBdocument * strDocument,
   int language_count, language_profile * first_lang,
   char *script, int *used_symbol_count,
   int *file_symbol_count,
   int *filtered_symbol_count,
   float *randoms, int max_random_index,
   float *separation_threshold, char *best_fit_script,
   char *second_best_script,
   float *stddev, float *separation, int collect_data_flag,
   float *symbol_distribution,
   unsigned int *hamming_lookup, int *prob,
   float *mlp_thresh,
   char *orientation, int *directions,
   int orient_det_threshold)

{
   int             index;
   float           mean_array[4];
   float           stddev_array[4];
   int             val;
   int             finished;
   int             j;
   jcluster       *cluster_ptr;
   jcluster       *japanese_no_cluster = NULL;
   int             i;
   int             bytes_needed;
   int             bits_needed;
   int             iCurrentComponent;
   language_profile *best_fit_language;
   language_profile *second_language;
   language_profile *first_language;
   language_profile *language_ptr;
   float           float_result;
   int             best_cluster_no;
   float           std_dev;
   float           first_count, second_count;
   int             random_index;
   char           *used_symbol_array = NULL;
   int             current_index;
   int             on_pixels;
   float          *scores[4];
   float          *score_ptr;
   unsigned char  *ptr;
   int             local_directions[4];
   int             k;
   float           high_stddev;
   float           second_stddev;
   int             top;
   int             rrotation;
   int             second = 0;
   int             iCount;

   unsigned char  *uscResized = NULL;
   unsigned char  *uscRotated = NULL;
   unsigned char  *uscCompressed = NULL;
   int             iLineDir = 0;
   /* doing both */
   int             DDD = 0;
   int             filtBottomRow;
   int             filtRightCol;
   int             errorTwoBit;
   bool            errorFinish = false;      // false for okay; or true for Error
   int             quad_mass[4];             // has one element for each direction
   int            *densities = &quad_mass[0]; 
   unsigned int    compressed_ary[13];        // fixed size compressed array
   unsigned int   *usiCompressed = &compressed_ary[0];
   bool            two_best_lang_j_c;    // best and second_best lang. Jap.& Chin.


   val= 0;   // indicate Don't need to calculate mean and stddev  07/12/04

   // default orientation to upright 
   // sprintf(orientation, "0");
   sprintf(orientation, "%d", 0);   // 06/28/04
 
   // put No Data indication into script, used for errors (e.g. allocation failure).
   sprintf(script, "%s", "nodata");

   for (i = 0; i < 4; i++)
      local_directions[i] = directions[i];

   bits_needed = rescale_height * rescale_width;	 /* pixels in image */
 
   // bytes_needed= ceil((double) bits_needed/8.0); 
   bytes_needed = (bits_needed+7) / 8;  /* bytes needed to store bit image */

   for (i = 0; i < 4; i++)
   {
      stddev_array[i] = 0.0;
      scores[i] = new float [language_count];
      if (scores[i] == NULL)
      {
         dlLogger.dlLog(DL_CRITICAL,"ERROR !! allocation failure for scores\n");
         return (-1);
      }
      score_ptr=scores[i];
      for (j=0; j<language_count; j++)
         score_ptr[j]= 0.0;
   }

   /* for this routine the language profile field correctly matched is used to
    * store a count of the number of symbols matched to the script.  for this
    * reason it is initialized to zero */

   language_ptr = first_lang;
   for (i = 0; i < language_count; i++)
   {
      language_ptr->matched_sum = 0.0;
      language_ptr->correctly_matched = 0;

      /* set the count of mapping symbols to zero for the japanese script.  At
       * this time Japanese is the only script for which we look at this count
       * so, to save some time it is the only one which is zeroed */

      if (strcmp(language_ptr->identification, "japanese") == 0)
      {
         cluster_ptr = language_ptr->first_cluster;

         for (j = 0; j < language_ptr->cluster_count; j++)
         {
            if (j == 20)
               japanese_no_cluster = cluster_ptr;
            cluster_ptr->matches_per_image = 0;
            cluster_ptr++;
         }
      }
      language_ptr++;
   }

   // Create a DLConnectedComponents object  and call dlCreateConnectedComponents 
   //   previously used tbCalcConnectedComponents(strDocument, 0, 0);
   try {
      DLConnectedComponents identifyCC;
      identifyCC.dlCreateConnectedComponents(strDocImage);

      //  Get the CC's for doclib  (previously used tbCreateComponentList)
      //  Note, Doclib will skip the first component
      vector <DLComponent> ccList = identifyCC.dlGetConnectedComponents();

      iCount = ccList.size(); 

      if (iCount < min_symbol_count)  
      {
         if (iCount < 1)    
            dlLogger.dlLog(DL_CRITICAL,"ERROR !! Too few symbols upon dlGetConnectedComponents\n");
       
         for (i = 0; i < 4; i++)
            delete[] scores[i];
         return (-1);
      }

 
      /* filter out the components before you start looking at them  */
 
      iCount = identifyCC.dlFilterCCHeightBetween(min_height, max_height);

      iCount = identifyCC.dlFilterCCWidthBetween(min_width, max_width);

      filtBottomRow=( strDocImage).dlGetHeight() - lower_offset;   //iRows - ofst
      iCount = identifyCC.dlFilterCCRemoveTopBottom(upper_offset, filtBottomRow);
 
      filtRightCol= ( strDocImage).dlGetWidth()  - right_offset;   // iCols - ofst
      iCount = identifyCC.dlFilterCCRemoveLeftRight(left_offset, filtRightCol);

      iCount = identifyCC.dlFilterCCDensityLess(*blob_percent); //06/18/04


      if (iCount < min_symbol_count)
      {
         dlLogger.dlLog(DL_INFO, " Too few symbols after filtering");
         for (i = 0; i < 4; i++)
            delete[] scores[i];
         return (-1);
      }

      vector <DLComponent> active_cc = identifyCC.dlGetFilteredCCs();

      /* detect the line orientation */
      iLineDir = JargonTBRoutines::tb_CalcLineOrientation(strDocImage, & active_cc, iCount, 5);


      /* don't turn off the alternate orientations if the directions detected */
      /* are not turned on */

      if ((iLineDir == 1) && (( local_directions[1] != 0) 
                              || (local_directions[3] != 0)))
      {
         local_directions[0] = 0;
         local_directions[2] = 0;
      }

      if ((iLineDir == 0) && ((local_directions[0] != 0) 
                              || (local_directions[2] != 0)))
      {
         local_directions[1] = 0;
         local_directions[3] = 0;
      }

      *file_symbol_count = 0;
      *used_symbol_count = 0;
      *filtered_symbol_count = 0;
      random_index = 0;

      used_symbol_array = new char [iCount];
      if (used_symbol_array == NULL)
      {
         dlLogger.dlLog(DL_CRITICAL, ",ERROR !! allocation failure for used symbol array\n");
         for (i = 0; i < 4; i++)
            delete scores[i];
         return (-1);
      }
      for (i=0; i<iCount; i++)
         used_symbol_array[i] = 0;

      current_index = 0;

      /* Get the first symbol to use */
      iCurrentComponent = JStatistics::GetNextSymbol(used_symbol_array, file_symbol_count,
                                                     randoms, iCount, &random_index, max_random_index, &current_index);
     
      finished = 0;
   

      while ((finished == 0) && (iCurrentComponent != -1) 
             && ((*used_symbol_count < symbolcount) || (symbolcount == 0)))
      {
         // Old logic skipped the first component even after filtering 
         //  so, mimic the old logic and skip the first component
         if (iCurrentComponent > 0) 
         {
            *filtered_symbol_count = *filtered_symbol_count + 1;

            /* extract the component,and resize */

            errorTwoBit=JargonTBRoutines::tb_GetResizedComponent(&active_cc[iCurrentComponent], &uscResized, rescale_width,
                                                                 rescale_height);
            if (errorTwoBit != 0)
            {
               errorFinish = true;
               break;
            }
         
            /* compute the scores in all 4 directions */
            for (rrotation = 0; rrotation < 4; rrotation++)
            {
               if (local_directions[rrotation] > 0)
               {
                  if (rrotation == 0)
                  {
                     ptr = uscResized;
                  } else
                  {
                     /* rotate the resized bitmap by 90/180/270 degrees */
                     errorTwoBit= JargonTBRoutines::tb_RotateComponent(uscResized, &uscRotated, rescale_height, rescale_width,
                                                                       rrotation*90);
                     if (errorTwoBit != 0)
                     {
                        errorFinish = true;
                        break;
                     }
                     ptr= uscRotated;
                  }

                  /* as long as we are using a square this is ok, will need to 
                   *  change row and width, depending on if 90/270 or 180 */

                  on_pixels = JargonTBRoutines::tb_CalcQuadrantMasses(ptr, rescale_height, rescale_width, &densities);    

                

                  errorTwoBit=JargonTBRoutines::tb_PackUCArray(ptr, &uscCompressed, rescale_width, rescale_height);
                  if (errorTwoBit != 0) 
                  {
                     errorFinish = true;
                     break;
                  }

                  /* convert from unsigned char compressed to */
                  /*   unsigned integer array of fixed size   */
		
                  ConvertUSCInt(usiCompressed, uscCompressed);

                  JStatistics::GetBestFitAllWithDens32(first_lang,
                                                       &best_fit_language, &best_cluster_no,
                                                       language_count, usiCompressed, bytes_needed,
                                                       bits_needed, NULL,
                                                       hamming_lookup, on_pixels, densities,&float_result);

                  delete[] densities;

                  if (!strcmp(best_fit_language->identification, "japanese") 
                      && (best_cluster_no == 20))
                  {
                     japanese_no_cluster->matches_per_image++;
                  }
                  index = best_fit_language - first_lang;
                  score_ptr = scores[rrotation];

                  /* add one if vertical */
                  score_ptr[index] = score_ptr[index] + float_result;

                  if (uscRotated != NULL)
                  {
                     delete []uscRotated;
                     uscRotated = NULL;
                  }
                  delete [] uscCompressed;
                  uscCompressed = NULL;
               }
            }	/* for loop on rrotation  */

            if (uscResized != NULL)
               delete []uscResized;

            if (errorFinish)
            {
               if (uscRotated != NULL)
                  delete []uscRotated;
               if (uscCompressed != NULL)
                  delete []uscCompressed;
               break;    // error exit
            }

            *used_symbol_count = *used_symbol_count + 1;

            /* We check to see if we have a unique, strong match in one direction 
             * if so we terminate the loop */

            // val = fmod((double) *used_symbol_count, (double) 50);
            val = *used_symbol_count % 50;

            // if ((val == 0) && (*used_symbol_count > 10))
            if (val == 0)
            {
               top = get_mean_and_stddev (local_directions, 
                                          scores,
                                          prob,
                                          language_count,
                                          *used_symbol_count,
                                          mean_array,
                                          stddev_array,
                                          &high_stddev,
                                          &second_stddev,
                                          &second);
               //  at 50/100 symbols attempt to chose the orientation
               // if (*used_symbol_count <= 100) 
               if (*used_symbol_count == orient_det_threshold)   // 07/12/04 
               {
                  /* if the upright direction is turned off chose the direction with the
                   * highest standard deviation */

                  if (local_directions[0] == 0)
                  {
                     for (k = 0; k <= 3; k++)
                        if (k != top)
                           local_directions[k] = 0;
                  } else
                  {
                     /* the upright dirction is on.  See if any of the other directions
                      * have a stddev > FLIP_IMAGE_THRESHOLD */

                     /* put FLIP_IMAGE_THRESHOLD back in here */
                     if ((high_stddev - second_stddev) > FLIP_IMAGE_THRESHOLD)
                     {
                        /* turn off all but top scorer */
                        for (k = 0; k <= 3; k++)
                           if (k != top)
                              local_directions[k] = 0;

                     } else		/* assume upright  turn off other directions */
                     {
                        for (k = 1; k <= 3; k++)
                           local_directions[k] = 0;
                        top = 0;
                     }
                  }
               }
               /* at this point orientation should be selected.  Evaluate scores at
                * this orientation and see if script can be determined */
               JStatistics::compute_distribution_filter_new(first_lang, &mean_array[top],
                                                            &stddev_array[top], &first_count,
                                                            &second_count, &first_language,
                                                            &second_language, collect_data_flag,
                                                            symbol_distribution, language_count,
                                                            &best_fit_language, prob,
                                                            scores[top]);

               *separation = first_count - second_count;
               std_dev = stddev_array[top];
 
               if ((std_dev > 1.0) && (*separation > 2.0 * std_dev) 
                   && (!strcmp(second_language->identification, "japanese")))
               {
                  finished = 1;
               }
            }    // if val == 0 &&
         }       // if iCurrentComponent > 0

         /* Get the next symbol to use */
         iCurrentComponent= JStatistics::GetNextSymbol(used_symbol_array, file_symbol_count,
                                                       randoms, iCount, &random_index, max_random_index, &current_index);

      }	/* while loop */
    
      if ((*used_symbol_count < min_symbol_count) || errorFinish)
      {
         sprintf(script, "%s", "nodata");
         sprintf(best_fit_script, "%s", "nodata");
      }
      else   // the used symbol count is >= minimum
      {
         /* calculate mean and stddev again if necessary */
         /* if (*used_symbol_count < 50) */
         if (val != 0)
         {
            top = get_mean_and_stddev (local_directions, 
                                       scores,
                                       prob,
                                       language_count,
                                       *used_symbol_count,
                                       mean_array,
                                       stddev_array,
                                       &high_stddev,
                                       &second_stddev,
                                       &second);
         }

         /* if less than 50 symbols were used determine orientation */
         // if (*used_symbol_count < 50)
         if (*used_symbol_count < orient_det_threshold)
         {
            /* if the upright direction is turned off chose the direction with the
             * highest standard deviation */

            if (local_directions[0] == 0)
            {
               for (k = 0; k <= 3; k++)
                  if (k != top)
                     local_directions[k] = 0;
            } else
            {
               /* the upright dirction is on.  See if any of the other directions 
                * have a stddev > FLIP_IMAGE_THRESHOLD */

               if ((high_stddev - second_stddev) > FLIP_IMAGE_THRESHOLD)
               {
                  /* turn off all but top scorer */
                  for (k = 0; k <= 3; k++)
                     if (k != top)
                        local_directions[k] = 0;
               }
            }
         }   // determine orientation
	   
         JStatistics::compute_distribution_filter_new(first_lang, &mean_array[top],
                                                      &stddev_array[top], &first_count,
                                                      &second_count, &first_language,
                                                      &second_language, collect_data_flag,
                                                      symbol_distribution, language_count,
                                                      &best_fit_language, prob,
                                                      scores[top]);
         sprintf(orientation, "%d", top);

         *separation = first_count - second_count;
         std_dev = stddev_array[top];

         if (best_fit_language != NULL)
         {
            sprintf(best_fit_script, "%s", best_fit_language->identification);
            sprintf(second_best_script, "%s", second_language->identification);
         }
         /* page is classified unknown if: the standard separation is less than 1
          * and the separation between the first and second is less than 2 stddev
          * or the separation between the top two is less than a threshold (and the
          * top two are not japanese and chinese) (passed as a parameter) time the
          * standard deviation */

         two_best_lang_j_c = 
            ( ((strcmp(first_language->identification,  "japanese") == 0) ||
               (strcmp(first_language->identification,  "chinese")  == 0))
              &&
              ((strcmp(second_language->identification, "japanese") == 0) ||
               (strcmp(second_language->identification, "chinese")  == 0)));

         if (best_fit_language == NULL)
         {
            DDD = 1;
            sprintf(script, "%s", "unknown");   // 06/28/04
         }
         else if (two_best_lang_j_c)
         {
            if (japanese_no_cluster->matches_per_image > 0)
            {
               sprintf(script, "%s", "japanese");
               DDD = 1;
            }
         }
         if (((std_dev < 1.0) && (*separation < 2.0 * std_dev)) 
             || (*separation < (*separation_threshold * (float) std_dev)) 
             && (DDD != 1))
         {
            if ( (two_best_lang_j_c)
                 &&  (std_dev > 1.0) && (japanese_no_cluster != NULL))
            {
               /* top two scripts are japanese or chinese - look for presence of the
                * "no" symbol to identify as japanese This is no_tempate_number */
               if (japanese_no_cluster->matches_per_image > 0)
               {
                  sprintf(script, "%s", "japanese");
               }
               else {
                  sprintf(script, "%s", best_fit_language->identification);
               }
            }
            else {
               sprintf(script, "%s", "unknown");
            }
         } else
         {
            if (DDD != 1) {
               sprintf(script, "%s", best_fit_language->identification);
            }
         }
      }	// used symbol count >= minimum

      delete []used_symbol_array;

      /* */
      for (i = 0; i < 4; i++)
         delete []scores[i];

      if (errorFinish)
      {
         dlLogger.dlLog(DL_CRITICAL, "ERROR !! allocation failure\n");
         return (-1);
      }

      return (0);

   }
   catch (DLException &Exce)
   {
      dlLogger.dlLog(DL_CRITICAL, "ERROR !! DL Exception \n%s", Exce.dlGetErrorMsg());
      for (i = 0; i < 4; i++)
         delete scores[i];

      if (used_symbol_array != NULL)
         delete used_symbol_array;
      return (-1);    
   }
}            // identify_and_orient


// local procedure

int JMorphology::get_mean_and_stddev( int     local_directions[4], 
                                      float * scores[4],
                                      int *   prob,
                                      int     language_count,
                                      int     u_symbol_count,
                                      float   mean_array[4],
                                      float   stddev_array[4],
                                      float * high_stddev,
                                      float * second_stddev,
                                      int *   second)
// determine mean and standard deviation values
// returns top direction and values for mean_array, stddev_array, high_stddev, second_stddev and second
{
   int   findtop;
   int   rotsub;

   *high_stddev = 0;
   *second_stddev = 0;
   findtop = 0;
   *second = 0;

   for (rotsub = 0; rotsub < 4; rotsub++)
   {
      if (local_directions[rotsub] > 0)
      {
         JStatistics::compute_mean_stddev(scores[rotsub], prob, language_count, 
                                          &mean_array[rotsub], &stddev_array[rotsub]);
         /* normalize base on number of characters */
         stddev_array[rotsub] = stddev_array[rotsub] / static_cast <float> (u_symbol_count);

         if (stddev_array[rotsub] > (*high_stddev))
         {
            *second_stddev = *high_stddev;
            *second = findtop;
            *high_stddev = stddev_array[rotsub];
            findtop = rotsub;
         }
         else if (stddev_array[rotsub] > (*second_stddev))
         {
            *second_stddev = stddev_array[rotsub];
            *second = rotsub;
         }
      }
   }

   return findtop;
}    // get_mean_and_stddev


void JMorphology::ConvertUSCInt(unsigned int* ui, unsigned char* image) {
   int i;
  
   /* need to loop through 12 times and then add the last 16 bits */
   for (i =0; i < 12; i++) {
      /* fix this: loop through and put 4 bytes in 1 */
      ui[i] =   (int)image[4*i] << 24;
      ui[i] += ((int)image[4*i+1] << 16);
      ui[i] += ((int)image[4*i+2] << 8);
      ui[i] +=  (int)image[4*i+3];
   };
  
   /* put the last 2 on */
   ui[12] = (image[48]<<8) ^ image[49];
};

void JMorphology::freeLanguageProfileStruct(language_profile *langProfile, int langCount)
{
   language_profile *lang_ptr = langProfile;
   int language_count = langCount;
   for (int k=0; k<language_count; k++)
   {
      delete[] lang_ptr->cluster32;
      delete[] lang_ptr->cluster_data;
   
      int iClusterCount = lang_ptr->cluster_count;
      jcluster * cluster = lang_ptr->first_cluster;

      for(int idx = 0; idx < iClusterCount; idx++)
      {
         delete[] cluster->first_image;
         delete[] cluster->centroid;
         cluster++; 
      }
      delete [] lang_ptr->first_cluster;
      lang_ptr++;
   }
}

