#include "JStatistics.h"


void JStatistics::compute_distribution_filter_new (language_profile *first_lang,
                                                   float *avg_hits, float *std_dev, float *first_count,
                                                   float *second_count, language_profile **first_language,
                                                   language_profile **second_language, int collect_data_flag,
                                                   float *symbol_distribution, int language_count,language_profile
                                                   **best_fit_language,int *probs,float *scores)
{
   language_profile *language_ptr;
   int i;
   float f_val;
   int used_language_count;
   float best_fit_score;
   *best_fit_language = NULL;


   language_ptr = first_lang;
   i = 0;
   while (probs[i] == 0)
   {
      language_ptr++;
      i = i+1;
   }

   *first_language = NULL;
   /**best_fit_language = first_language; */
   *second_language = NULL;
   *first_count = scores[i];
   *second_count = 0;
   /*best_fit_score = scores[i]; */
   best_fit_score = 0;


   language_ptr = first_lang;
   used_language_count = 0;
   *avg_hits = scores[0];
   symbol_distribution[0] =  scores[0];

   for (i=0;i<language_count;i++)
   {
      symbol_distribution[i] = scores[i];

      /* only consider langauges which may appear for
         this source */

      if (probs[i] > 0)
      {
         used_language_count++;
         if (scores[i] >= *first_count)
         {
            if (*first_language != NULL)
            {
               *second_language = *first_language;
               *second_count = *first_count;
            }
            *first_language = language_ptr;
            *first_count = scores[i];
         }
         else
            if (scores[i] >= *second_count)
            {
               *second_language = language_ptr;
               *second_count = scores[i];
            }
         *avg_hits = *avg_hits + scores[i];
         if (scores[i]  > best_fit_score)
         {
            *best_fit_language = language_ptr;
            best_fit_score = scores[i];
         }
      }
      language_ptr++;
   }

   /* normalize based on number of languages used  */

   *avg_hits = (float) *avg_hits/(float) used_language_count;

   /* Normalize based on the number of symbols used */

   *std_dev = 0;
   language_ptr = first_lang;
   for (i=0;i<language_count;i++)
   {

      /* scale to number of languages used */

      if (probs[i] > 0)
      {
         f_val = (float) scores[i]-*avg_hits;
         *std_dev = *std_dev + (f_val*f_val);
      }
      language_ptr++;
   }
   *std_dev = sqrt( (float)(*std_dev/(float) used_language_count));
}


//changed API from returning an int to void. 
void JStatistics::generate_random_number_array( float *array,int count)
{
   int i;

   for (i=0;i< count;i++)
   {
      array[i] = ((float) rand())/(float) RAND_MAX;
   }


}//end generate_random_number_array


int JStatistics::GetNextSymbol(char *used_symbol_array, 
                               int *file_symbol_count,
                               float *randoms,int iCount,
                               int *random_index,int max_random_index,
                               int *current_index) 
{
   int index;  
   int component_ptr = -1;

   /* get current index value 
      multiply by total no of components */

   index =(int)( randoms[*random_index]* iCount);

   /* ahve to have the iCount-1 because the 0th element is junk */
   while ( (*file_symbol_count < iCount ) 
           && (component_ptr < 0) ) {

      /* see if symbol has already been examined */
      if (used_symbol_array[index] == 1) {
         /* symbol was already used. Scan forward to find
            the next available */
         if (index < (iCount-1) )
            index++;
         else
            index= 0; 
      }
      else {
         used_symbol_array[index] = 1;
         component_ptr = index;
         *current_index = index;
         *file_symbol_count = *file_symbol_count+1;
      }
   }

   if (*random_index >= (max_random_index-1))
      *random_index = 0;
   else
      *random_index = *random_index + 1;

   return(component_ptr);
}

void JStatistics::GetBestFitAllWithDens32(language_profile *first_language, 
                                          language_profile **best_language,
                                          int *best_cluster_no,int number_of_scripts, 
                                          unsigned int* img2,
                                          int bytes_needed, int pixel_count, 
                                          float *hamming_penalty, 
                                          unsigned int *hamming_lookup, 
                                          int on_pixels,int *densities,float *float_result) 
{
//printf("on pixels = %d\n",  on_pixels);

   language_profile *language_ptr;
   int i,j;
   int hamming;
   int best_hamming;
   jcluster *cluster_ptr = 0, *best_cluster = 0;
   float best_fit_reliability  = 0.0;
   /* int *densities; */
   int diff_sum;
   int k,l;
   int compares; 
   unsigned int uiResult = 0;
   unsigned int* img1;

   /*densities = (int *) cdensities;  */

   compares = 0; 
   bytes_needed = pixel_count/32;
   best_hamming = pixel_count;
   language_ptr = first_language;

   /* loop over scripts */
   for (i=0;i< number_of_scripts;i++) {
      /* printf("debug matching to: %s \n",language_ptr->identification); */
      img1 = language_ptr->cluster32;
      cluster_ptr = (jcluster *) language_ptr->first_cluster;

      /* loop over clusters */
      for (j=0; j< language_ptr->cluster_count;j++) {
         if (cluster_ptr->on_pixels >= MINONPIXELS) {

            /* tried making a difference in speed, it doesn't matter
             * over the latin test set the difference in speed is
             * 0.001974478 per image, not much pick your poison,
             * identical results
             */

            diff_sum = 0;
            for (k = 0; k < 4;k++)
               diff_sum = diff_sum +
                  abs(cluster_ptr->densities[k]-densities[k]);


            /*	diff_sum = abs(cluster_ptr->densities[0]-densities[0]) + 
                abs(cluster_ptr->densities[1]-densities[1]) +
                abs(cluster_ptr->densities[2]-densities[2]) +
                abs(cluster_ptr->densities[3]-densities[3]);
            */

            if (diff_sum > best_hamming)
            {
               hamming = best_hamming + 1;
            }
            else 
            {
               /*
                 compares++;
                 hamming = bitwise_hamming(cluster_data_ptr,bit_image,
                 pixel_count,hamming_lookup,bytes_needed,best_hamming);

               */
               compares++;
               hamming = 0;

               for (l = 0; l < BITWISE_DROPOUT_32; l++) {
                  uiResult = (img1[l]) ^ (img2[l]);
                  hamming+=(hamming_lookup[uiResult>>16] + hamming_lookup[uiResult& 0xffff]);
               }

               if (hamming < best_hamming) {
                  for (l = BITWISE_DROPOUT_32; l < bytes_needed; l++) 
                  {
                     uiResult = (img1[l]) ^ (img2[l]);
                     hamming+=(hamming_lookup[uiResult>>16] + 
                               hamming_lookup[uiResult& 0xffff]);
                  }

                  /* do the last 2 bytes, compress this */
                  uiResult = ((img1[bytes_needed]) ^ (img2[bytes_needed]));
                  hamming += hamming_lookup[uiResult];
               }
            }

            if (hamming < best_hamming) {
               best_hamming = hamming;
               *best_language = language_ptr;
               *best_cluster_no = j;
               best_cluster = cluster_ptr;
               best_fit_reliability = cluster_ptr->reliability;
            }
         }
         /*
           printf("language_ptr: %s cluster_no: %d hamming: %d \n",
           language_ptr->identification, j, hamming); 
         */

         /* progress through the data */
         img1 = img1 + bytes_needed + 1;
         cluster_ptr++;
      }
      language_ptr++;
   }

   /*  best_cluster->correct_matches=best_cluster->correct_matches+1; */
   best_cluster->matches_per_image = best_cluster->matches_per_image +1;
   /*   printf("best hamming %d %f ",best_hamming,best_fit_reliability); */

   *float_result = best_fit_reliability;



   /*
     return( best_fit_reliability ); */

}

void JStatistics::compute_mean_stddev(float *values, int *class_flags,int value_count,
                                      float *mean,
                                      float *stddev)
{
   int i;
   float sum;
   float f_val;
   int used_class_count;

   /* class flags indicates which classes are being considered.  This
      allows this routine to compute mean and stdev across a subset of 
      the classes */


   used_class_count = 0;
   sum = 0;
   for (i=0;i<value_count;i++)
   {
      if (class_flags[i] > 0)
      {
         used_class_count++;
         sum = sum + values[i];
      }
   }
   *mean = sum/used_class_count;
   sum = 0;
   for (i=0;i<value_count;i++)
   {
      f_val = values[i] - *mean;
      sum = sum + (f_val*f_val);
   }
   *stddev = sqrt( (float)(sum/(float) used_class_count));


}



