#ifndef _JSTATISTICS_H_
#define _JSTATISTICS_H_


#include "JMorphology.h"
//
//#include <stdlib.h>
//#include <stdio.h>
//#include <math.h>
//#include <sys/types.h>
//using namespace std;
//
//#ifndef RAND_MAX
//#define RAND_MAX 2147483646
//#endif
//
///* tried 7 and 9 and neither seemed to make a difference */
#define BITWISE_DROPOUT_32 8
#define MINONPIXELS 20

/// Class contains various unrelated utilities.  Should be eliminated eventually
class JStatistics {
   friend class JScript;
   friend class JMorphology;

   public:
   static void GetBestFitAllWithDens32(language_profile *first_language,
                                       language_profile **best_language, int *best_cluster_no,int number_of_scripts, 
                                       unsigned int* img2,			      
                                       int bytes_needed, int pixel_count, 			      
                                       float *hamming_penalty, 			      
                                       unsigned int *hamming_lookup, 			      
                                       int on_pixels,int *densities,float *float_result);


   private:
   static void compute_distribution_filter_new(language_profile *first_lang,
                                               float *avg_hits, float *std_dev, float *first_count,
                                               float *second_count, language_profile **first_language,
                                               language_profile **second_language, int collect_data_flag,
                                               float *symbol_distribution, int language_count,language_profile
                                               **best_fit_language,int *probs,float *scores);

   /** Creates an random number array.  This array is used randomly
    * select connected components from an image to be used in determining
    * the script of the image
    */

   static void generate_random_number_array( float *array,int count);

   /** GetNextSymbol uses a random number array to select the next
    * symbol to be used in performing script identification
    */

   static int GetNextSymbol(char *used_symbol_array, 
                            int *file_symbol_count,
                            float *randoms,int iCount,
                            int *random_index,int max_random_index,
                            int *current_index);

/** Computes the mean and standard deviation of a set of floating point values
 */
   static void compute_mean_stddev(float *values, int *class_flags,int value_count,
                                   float *mean, float *stddev);

};


#endif //_JSTATISTICS_H_
