// objcluster.cpp: implementation of the objcluster class.
//
//////////////////////////////////////////////////////////////////////

#include "objcluster.h"
#include <fstream>

/**
 * Constructor
 **/
objcluster::objcluster()
{
   m_nbObjects = 0; m_weight = 1;
}

/**
 * Destructor
 **/
objcluster::~objcluster()
{

}

/**
 * Probability computes the similarity of an object to the current object
 * \param a the object to be examined
 * \return the similarity value in [0,1]
 **/
double objcluster::Probability(objvector& a)
{
//	if(a.Type != m_centroid.Type)
//		return 1e-10;

   objvector diff = a - m_centroid;

   diff = diff.dotdivide(m_sigma);

   double power = diff.normsquare()/5; //diff.norm()/5;  //diff.norm_2(0.3, 0.3 ,0.15, 0.15,0.1);

   /*
     double power =	(a.FontHeight - b.FontHeight)*(a.FontHeight-b.FontHeight)/m_sigma.FontHeight +					
					
     (a.Length-b.Length)*(a.Length-b.Length)/m_sigma.Length +					
					
     (a.Centroid_X - b.Centroid_X)*(a.Centroid_X - b.Centroid_X)/m_sigma.Centroid_X +					
				
     (a.Centroid_Y - b.Centroid_Y)*(a.Centroid_Y - b.Centroid_Y)/m_sigma.Centroid_Y +
					
     (a.Angle - b.Angle)*(a.Angle - b.Angle)/m_sigma.Angle ;

   */

//	double Const = m_sigma.Angle * m_sigma.Centroid_X * m_sigma.Centroid_Y 
//					* m_sigma.FontHeight * m_sigma.Length;

//	ASSERT(Const != 0);

   return exp(-power/2); // / (1.414*sqrt(3.14159265)*Const);

}

/**
 * write_stream save struct information into disk
 * \param f an ofstream object
 * \param saveweights the flag indicating whether write weights or not; not used anymore
 **/
void objcluster::write_stream(ofstream & f, bool saveweights)
{
   //write the vector
   f << "cenroid:" << endl;
   m_centroid.write_stream(f);
   f << "sigma:" << endl;
   m_sigma.write_stream(f);
	
   f	<< "nbObjects: " << m_nbObjects << endl;
   f	<< "weight: "  << m_weight << endl;
   f	<< "avgNbObj_perdoc: " << m_avgnbObjperdoc << endl;
   f	<< "sigmaObj_perdoc: " << m_sigmaObjperdoc << endl;
}

/**
 * read_stream read file to load information
 * \param f the input filestream object
 **/
void objcluster::read_stream(ifstream & f)
{
   //read the vector
   char buf[80];
   f >> buf;
   m_centroid.read_stream(f);
   f >> buf;
   m_sigma.read_stream(f);
	
   f	>> buf; f >> m_nbObjects;
   f	>> buf; f >> m_weight;
   f	>> buf; f >> m_avgnbObjperdoc;
   f	>> buf; f >> m_sigmaObjperdoc;
}

