
#include <cstdio>
#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <string.h>
#include <vector>
#include <algorithm>
#include <objectInfoClass.h>
#include <DLGetLines.h>
#include <DLBitsPerPixelConverter.h>

//#include <sys/param.h>
#include <cstdlib>

#define	MAX_LINES 50 

/*extern "C" 
{
#include <TB.h>
#include <TBColors.h>
}
*/

#include <JScript.h>

#define	SKEW_THRESH	.0017

static int compare_double(const	void *entry1, 
						  const	void *entry2)
{
	double *i,*j;

	i =	(double	*) entry1;
	j =	(double	*) entry2;
	if (*i > *j)
		return (1);
	if (*i < *j)
		return (-1);
	return (0);


}

/****************************************************/

static int sortLines(const void	*entry1, const void	*entry2)
{

	/* note	this is	a reverse order	sort */


	DLlineInfo *i =	(DLlineInfo	*) entry1;
	DLlineInfo *j =	(DLlineInfo	*) entry2;
	float l1;
	float l2;

	l1 = ((i->loc[1].x - i->loc[0].x)*
		(i->loc[1].x - i->loc[1].x)) -
		((i->loc[1].y -	i->loc[0].y)*
		(i->loc[1].y - i->loc[0].y));


	//l1 = ((i->xMax - i->xMin)*
	//					 (i->xMax -	i->xMin)) -
	//					 ((i->yMax - i->yMin) *
	//(i->yMax - i->yMin));
	//l2 = ((j->xMax - j->xMin)*
	//					 (j->xMax -	j->xMin)) -
	//					 ((j->yMax - j->yMin) *
	//						(j->yMax - j->yMin));
	l2 = ((j->loc[1].x - j->loc[0].x)*
		(j->loc[1].x - j->loc[0].x)) -
		((j->loc[1].y -	j->loc[0].y) *
		(j->loc[1].y - j->loc[0].y));
	if (l1 > l2)
		return(-1);
	if (l1 < l2)
		return(1);
	return (0);



}

/****************************************************/


objectInfoClass::~objectInfoClass()
{
	int	i;


	for	(i=0;i<_objectCount;i++)
	{
		if (imageObjects[i].qualifier != NULL)
		{
			free(imageObjects[i].qualifier);
			imageObjects[i].qualifier=NULL;
		}
	}
	if (_pixelData != NULL)
	{
		free(_pixelData);
		_pixelData == NULL;
	}
	if (_grayPixelData != NULL)
	{
		free(_grayPixelData);
		_grayPixelData=NULL;
	}
	if (imageObjects !=	NULL)
	{
		free (imageObjects);
		imageObjects= NULL;
	}

}

/*********************************************************/
objectInfoClass::objectInfoClass(std::string fname,
								 JScript *scriptInfo, int line_count_limit,
								 char *output_directory,int	pixelDataFlag,int scansoftFlag,
								 int dctFlag)
{

	const char *name_string;
	int	index1;
	char path [FILENAME_MAX+1];
	FILE *fp;
	int	cnt;
	int	result;
	int	i;
	DLImage	*doink;
	int	line_count;
	int	delta;
	int	data_type;
	unsigned char *new_array;

	line_count = 0;
	_objectCount = 0;
	_grayPixelData = NULL;
	_threshold = .5;
	_scansoftFlag =	scansoftFlag;
	_dctFlag = dctFlag;
	name_string	= fname.c_str();
	_scriptInfo	= scriptInfo;
	_pixelData = NULL;
	/* 
	see	if an output file already exist.  If so	read the
	data from the file.	 Otherwise call	method to compute 
	info.
	*/

	index1 = fname.rfind("/");
	if (index1 >= 0)
		sprintf(path,"%s/%s.dat",output_directory,&name_string[index1]);
	else
		sprintf(path,"%s/%s.dat",output_directory,&name_string[0]);

	fp = fopen(path,"r");
	if (fp == NULL)
	{
		imageObjects = computeObjectInfo(fname,pixelDataFlag);
	}
	else
	{
		/* count entries */

		cnt	= 0;
		result = fscanf(fp,"%*s	%d %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s",
			&data_type);
		while (result >= 0)
		{
			if (data_type == textLine)
				line_count++;
			cnt	++;
			result = fscanf(fp,"%*s	%d %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s",
				&data_type);
		}
		if ((line_count_limit >= 0)	&& (line_count > line_count_limit))
			delta =	line_count - line_count_limit;
		else
		{
			delta =	0;
		}
		_objectCount = cnt-delta;
		imageObjects = (objectInfo *) calloc( _objectCount,	sizeof(objectInfo));
		fseek(fp,0,SEEK_SET);
		line_count = 0;
		for	(i=0;i<_objectCount;i++)
		{
			imageObjects[i].qualifier= (char *)	calloc (25,sizeof(char));
			fscanf (fp,"%*s	%d %*s %d %*s %d %*s %d	%*s	%d %*s %d %*s %s",
				(int *)	&imageObjects[i].type,
				&imageObjects[i].location[0].x,
				&imageObjects[i].location[0].y,
				&imageObjects[i].location[1].x,
				&imageObjects[i].location[1].y,
				&imageObjects[i].int_qualifier,
				imageObjects[i].qualifier);

			if (imageObjects[i].type ==	textLine)
				line_count++;

			if ((line_count_limit >= 0)	&& (line_count > line_count_limit) && (imageObjects[i].type	== textLine))

			{
				/* we already have enought lines.  don't include this one */

				free(imageObjects[i].qualifier);
				i =	i-1;
			}	

		}
		fclose(fp);

		/* need	to open	the	image to get the height, width,	
		and	pixel data */

		doink =	new	DLImage(name_string);
		//	result=	tbOpen((char *)	name_string, doink,	1,
		//		DISREPLACENEARESTGOOD, 0, NULL,	0, 0);
		_horRes	= doink->dlGetHorizontalResolution();
		_verRes	= doink->dlGetVerticalResolution();
		_originalHeight	= doink->dlGetHeight();
		_originalWidth = doink->dlGetWidth();
/*
		if (doink->dlGetDepth()	== DL_BITDEPTH_8)
			*doink = DLBitsPerPixelConverter::dlDownscaleGray2Binary_global(*doink);
		else if	(doink->dlGetDepth() ==	DL_BITDEPTH_24)
		{
			*doink = DLBitsPerPixelConverter::dlDownscaleColor2Gray_global(*doink);

		}*/


		//if (doink->ub8BitImage !=	NULL)
		//{
		/* this	is a grayscale.	Copy it	to object instance to
		save data, and binarize	it before proceeding */

		//	int	data_size =	doink->iRows*doink->iCols;
		//	_grayPixelData = (unsigned char	*) calloc(data_size,
		//		sizeof(unsigned	char));

		//	memcpy(_grayPixelData, doink->ub8BitImage,data_size);

		//	tbThresholdGlobal8Bit(doink,&_threshold, (char **) &new_array);
		//	tbCompress8BytesTo1Byte(new_array, doink->iRows, doink->iCols, 
		//		&doink->ub1BitImage);
		//doink->iColBytes =(doink->iCols+7)/8;

		//	doink->iImageLength	= tbiPixelToRunStart(doink->ub1BitImage,
		//doink->iCols,
		//(doink->iCols+7)/8,
		//doink->iRows,
		//&doink->image);
		//doink->dSkewAngle	= tbiGetSkew(doink,doink->image, doink->iImageLength);

		//	free(new_array);
		//}


		//tbCalcConnectedComponents(doink, 1, 0);
		if (pixelDataFlag >	0)
			_pixelData = doink->dlGetImageData();
		//tbGetDocumentColor(doink,&_pixelData,0,0xff);
		else _pixelData	= NULL;
		delete doink;


	}


} /* create	method */


/*********************************************************/
objectInfoClass::objectInfoClass(std::string filename,JScript *scriptInfo,
								 int scansoftFlag,int dctFlag)
{


	_objectCount = 0;
	_grayPixelData = NULL;
	_threshold = .5;
	_scansoftFlag =	scansoftFlag;
	_scriptInfo	= scriptInfo;
	_pixelData = NULL;
	_dctFlag = dctFlag;
	imageObjects = computeObjectInfo(filename,1);
} /* create	method */


/*********************************************************/


struct objectInfo *objectInfoClass::computeObjectInfo(std::string fname,
	int	pixelDataFlag)
	/*vector<objectInfo> *objectPairMatrix::computeObjectInfo(std::string fname) */
{
	objectInfo *imageObjects ;
	DLImage	*doink;
	DLImage	*doink1;
	DLImage	*doink2;
	DLImage	*cur_doink;
	int	result;
	const char *name_string;
	unsigned char *pixels, *pixels1=NULL;
	int				new_rows;
	int				new_cols;
	DLlineInfo	   *textLines=NULL;
	DLlineInfo				*textLinePtr;
	unsigned char			*newr_image=NULL;
	int	line_count;
	int	long_line_count=0;
	float avg_height;
	float avg_width;
	int	*iList=NULL;
	int	iCount;
	int			   *line_segs =	NULL;
	int	i;
	pointLocation *pointPtr;
	int	index;
	char system_command[FILENAME_MAX+1];
	int	big_line_count;
	float abs_skew;
	unsigned char *new_array;


	pixels = NULL;
	_lineCount = 0;
	_lineSlopeVarianceSqr =	0.0;
	_peakValue = 0.0;
	_peakRatio = 0.0;

	/* compute the text	lines and store	info. */

	//doink	= (TBdocument *) calloc(1,sizeof(TBdocument));
	//memset (doink,0, sizeof(doink));
	//name_string =	fname.c_str();
	DLImage	initialImage(fname.c_str());
	//result= tbOpen((char *) name_string, doink, 1, 
	//	DISREPLACENEARESTGOOD, 0, NULL,	0, 0);
	//if (result < 0)
	//{
	//	free(doink);
	//	return(NULL);
	//
	//}

	/* binarize	the	image */

	DLImage	binarizedImage;
	/*if (initialImage.dlGetDepth() == DL_BITDEPTH_8)
		binarizedImage = DLBitsPerPixelConverter::dlDownscaleGray2Binary_global(initialImage);
	else if	(initialImage.dlGetDepth()	== DL_BITDEPTH_24)
	{
		binarizedImage = DLBitsPerPixelConverter::dlDownscaleColor2binary_global(initialImage);
	}
	else binarizedImage	= initialImage;

	//			}
	//doink1 = (TBdocument *) calloc(1,sizeof(TBdocument));
	//doink2 = (TBdocument *) calloc(1,sizeof(TBdocument));
	//_horRes =	doink->fHorizontalRes;
	//_verRes =	doink->fVerticalRes;
	//
	_originalHeight	= initialImage->dlGetHeight();
	_originalWidth = initialImage->dlGetWidth();
	//if (doink->ub8BitImage !=	NULL)
	//{
	//	/* this	is a grayscale.	Copy it	to object instance to
	//save data, and binarize it before	proceeding */

	// int data_size = doink->iRows*doink->iCols;
	// _grayPixelData =	(unsigned char *) calloc(data_size,
	//		 sizeof(unsigned char));
	// memcpy(_grayPixelData, doink->ub8BitImage,data_size);
	// tbThresholdGlobal8Bit(doink,&_threshold,	(char **) &new_array);
	// tbCompress8BytesTo1Byte(new_array, doink->iRows,	doink->iCols, 
	//	&doink->ub1BitImage);
	//doink->iColBytes =(doink->iCols+7)/8;
	//	doink->iImageLength	= tbiPixelToRunStart(doink->ub1BitImage,
	//	doink->iCols,
	//(doink->iCols+7)/8,
	//	doink->iRows,
	// &doink->image);
	// doink->dSkewAngle = tbiGetSkew(doink,doink->image, doink->iImageLength);

	//	free(new_array);
//}



//cur_doink =	doink;
//tbCalcConnectedComponents(cur_doink, 1,	0);

/* store off original pixel	data */

if (pixelDataFlag >	0)
_pixelData = binarizedImage.dlGetImageData();
else _pixelData	= NULL;


_originalImageSkew = binarizedImage.dlDetectSkew(;
if (_originalImageSkew >	0)
abs_skew = _originalImageSkew ;
else
abs_skew = 0.0 - _originalImageskew ;

DLImage deskewedImage;
if (abs_skew > SKEW_THRESH)	
{
	deskewedImage = binarizedImage.dlRotateImage(_originalImageSkew);
	/* deskew based	on .. */

	result = tbGetDocument(cur_doink, &pixels1);
	if (pixels1	== NULL)
		printf("could not tbGetDocument(cur_doink, &pixels1) \n");
	tbRotateUCArray(pixels1, cur_doink->iCols,
		cur_doink->iRows, (double) cur_doink->dSkewAngle, &new_rows, &new_cols,	&newr_image,
		5);


	if (newr_image == NULL)
		printf("error: null	newr_image\n");

	/* generate	new	document based on deskewed pixmap */
	tbDocumentFromBitMap(cur_doink,	doink1,	newr_image,	new_rows, new_cols);
	if (newr_image != NULL)
	{
		free(newr_image);
		newr_image = NULL;
	}

	if (pixels1	!= NULL)
	{
		free(pixels1);
		pixels1	= NULL;
	}
	tbClose(doink);
	cur_doink =	doink1;
	tbCalcConnectedComponents(cur_doink, 0,	0);
}
if (tbCreateComponentList(cur_doink, &iList) ==	0)
{

	/* filter components based on position (get	rid	of borders), size, and
	* density */

	iCount = tbFilterComponents(cur_doink, iList, HEIGHTBETWEEN, 
		(double) 3.0, (double) 400.0);
	iCount = tbFilterComponents(cur_doink, iList, WIDTHBETWEEN,	
		(double) 3.0, (double) 400.0);
	iCount = tbFilterComponents(cur_doink, iList, DENSITYGREATER,
		(double) .75, 0.0);
}

_lineDirection=	tbCalcLineOrientation(cur_doink, iList,	iCount,
									  5, &line_segs);
if (_lineDirection < 0)
{
	/* not enought filtered	components to get direction	assume upright */

	_lineDirection = 0;
}
if (line_segs != NULL)
{
	free(line_segs);
	line_segs =	NULL;
}
if (_lineDirection== 1)
{	 /*	image text runs	up and down	rotate it by
	 * 90 degrees */

	result = tbGetDocument(cur_doink, &pixels1);

	tbRotateUCArray(pixels1, cur_doink->iCols, cur_doink->iRows,
		270	* M_PI/180,	&new_rows, &new_cols, &newr_image, 5);

	/* free	old	stuff */

	if (pixels1	!= NULL)
		free(pixels1);
	if (pixels != NULL)
		free(pixels);
	if (iList != NULL)
		free(iList);
	iList =	NULL;
	pixels = NULL;
	pixels1	= NULL;

	/* generate	new	document based on deskewed pixmap */

	tbDocumentFromBitMap(cur_doink,	doink2,	newr_image,	new_rows, new_cols);
	if (newr_image == NULL)
		printf("null newr_image\n");
	else
		free(newr_image);


	/*** debug 
	tbWriteTiffBinary(doink2,"test_rotated90.tif",doink2->iRows, doink2->iCols,
	doink2->ub1BitImage,(long) COMPRESSION_CCITTFAX4, NULL,0);
	**/


	tbClose(cur_doink);
	cur_doink =	doink2;
	tbCalcConnectedComponents(cur_doink, 0,	0);
	if (tbCreateComponentList(cur_doink, &iList) ==	0)
	{
		/* iCount =	tbFilterComponents(cur_doink, iList, REMOVETOPBOTTOM, (double)
		* 20.0,	(double) 10.0);	iCount = tbFilterComponents(cur_doink, iList,
		* REMOVELEFTRIGHT, (double)	10.0, (double) 10.0); */


		iCount = tbFilterComponents(cur_doink, iList, HEIGHTBETWEEN, 
			(double) 3.0, (double) 400.0);
		iCount = tbFilterComponents(cur_doink, iList, WIDTHBETWEEN,	
			(double) 3.0, (double) 400.0);
		iCount = tbFilterComponents(cur_doink, iList, DENSITYGREATER,
			(double) .75, 0.0);
	}
}
if (iCount < 10)
{
	if (iList != NULL)
	{
		free(iList);
		iList =	NULL;
	}
	long_line_count	= 0;
	big_line_count = 0;
}
else
{



	tbComputeLines(cur_doink, &textLines, 20, iList,
		iCount,	(char *) pixels, &long_line_count, &avg_height,	&avg_width);

	computeLineStatistics(textLines, long_line_count);

	if (_dctFlag)
		computeInterlineSpacingFeatures(cur_doink,
		textLines, long_line_count,
		&_peakValue, &_peakRatio);

	_lineCount = long_line_count;

	/* sort	the	lines by their length so the longest 50	lines can be 
	be selected	*/

	qsort(textLines,long_line_count,sizeof (textLines[0]),
		sortLines);
	/* count lines > 7 pixels in avg height	*/

	big_line_count = 0;
	for	(i=0;i<long_line_count;i++)
		if (textLines[i].avgHeight > 7)
			big_line_count++;

	/* sort	the	lines by their length so the longest 50	lines can be 
	be selected	*/


	if (iList != NULL)
		free (iList);
}

/*	the	height , width and pixel data for the deskewed image
are	stored in the class	members	*/
_height	= cur_doink->iRows;
_width = cur_doink->iCols;

/*
if (pixelDataFlag >	0)
tbGetDocumentColor(cur_doink,&_pixelData,0,0xff);
else _pixelData	= NULL;
*/

/* compute fisc	zones are return count */

/*
int	fisc_count = countFiscSegments(cur_doink,  &index);
*/

/* compute the SDK2000 zones. results are stored in	a file	*/

int	scansoft_count;
if (_scansoftFlag == 1)
{
	sprintf(system_command,
		"java -DserverHost=galileo r5sdk.SDKGetZones English %s	| grep left	> tmp_scansoft_results\n",
		name_string);
	system(system_command);
	scansoft_count = countScansoftSegments("tmp_scansoft_results");
}
else
scansoft_count = 0;


/*
_objectCount = long_line_count + 1	+ fisc_count + scansoft_count;	
*/
/*
if (big_line_count > MAX_LINES)
line_count = MAX_LINES;
else
line_count = long_line_count;
*/
_lineCount = big_line_count;

_objectCount = big_line_count +	1  +scansoft_count;	 


/* allocate	room for lines,	 script, and a
for	fisc objects*/
imageObjects = (objectInfo *) calloc( _objectCount,	sizeof(objectInfo));

/* store line count	n*/

index =	0;
index =	-1;
/*
imageObjects[index].type = textLineCount;
imageObjects[index].location[0].x =	-1;
imageObjects[index].location[0].y =	-1;
imageObjects[index].location[1].x =	-1;
imageObjects[index].location[1].y =	-1;
imageObjects[index].int_qualifier =	long_line_count;
imageObjects[index].qualifier= (char *)	calloc (25,sizeof(char));
*/
float lineSlopeMean= 0.0;
_lineSlopeVarianceSqr =	0.0;
for	(i=0;i<long_line_count;i++)
{
	if (textLines[i].avgHeight > 7)
	{
		index++;
		imageObjects[index].type = textLine;
		imageObjects[index].qualifier= (char *)	calloc (25,sizeof(char));
		lineSlopeMean =	lineSlopeMean+
			textLines[i].slope;

		/* store line height; lowerExtent is subtracted	because	it
		is a negative number */

		imageObjects[index].int_qualifier= (int) (textLines[i].lineUpperExtent -
			textLines[i].lineLowerExtent);

		/* the line	upper and lower	extent is not being	used in	layout ive
		it was added for use by	Dumpsterdiver.	It allows the bounding box
		informaitno	to be calculated */

		imageObjects[index].upper_ext =	textLines[i].lineUpperExtent;
		imageObjects[index].lower_ext =	textLines[i].lineLowerExtent;
		sprintf(imageObjects[index].qualifier,"%s","test");

		/* store line endpoints	for	locations */

		textLinePtr	= &textLines[i];
		/*	pointPtr = textLinePtr.pointLocation; */
		imageObjects[index].location[0].x =	(int) textLinePtr->xMin;
		imageObjects[index].location[0].y =	(int) (textLinePtr->slope*textLinePtr->xMin	+ 
			textLinePtr->intercept); 

		imageObjects[index].location[1].x =	(int) textLinePtr->xMax;
		imageObjects[index].location[1].y =	(int) (textLinePtr->slope*textLinePtr->xMax	+ 
			textLinePtr->intercept); 
	}
}
lineSlopeMean =	lineSlopeMean/(float) big_line_count;
for	(i=0;i<long_line_count;i++)
{
	if (textLines[i].avgHeight > 7)
	{
		_lineSlopeVarianceSqr =	_lineSlopeVarianceSqr +	
			(textLines[i].slope	- lineSlopeMean) * (textLines[i].slope - lineSlopeMean)	;
	}
}
index++;
tbiFreeLineInfo(textLines,long_line_count);
imageObjects[index].type = script;
imageObjects[index].qualifier= (char *)	calloc 
(20,sizeof(char));
if (_scriptInfo	!= NULL)
{
	_scriptInfo->getScript(cur_doink,_script);
	char *bestFit =	_scriptInfo->getFirst();
	strcpy(_bestFitScript,bestFit);
	_scriptIdOrientation = _scriptInfo->scriptOrientation();
}
else
{
	strcpy(_script,"undetermined");
	strcpy(_bestFitScript,"undetermined");
	_scriptIdOrientation = 0;
}

strcpy(imageObjects[index].qualifier,_script);
/*_scriptInfo->getScript(cur_doink,imageObjects[index].qualifier); */

imageObjects[index].location[0].x =	-1;
imageObjects[index].location[0].y =	-1;
imageObjects[index].location[1].x =	-1;
imageObjects[index].location[1].y =	-1;
index++;

/*
computeFiscSegments(cur_doink, imageObjects, &index);
*/
if (_scansoftFlag == 1)
{
	computeScansoftSegments(cur_doink, imageObjects, &index,
		"tmp_scansoft_results");
	system ("rm	-f tmp_scansoft_results");
}





tbClose(cur_doink);
free(doink);
free(doink1);
free(doink2);
return(imageObjects);

}

/*---------------------------------------------------------------*/


int	objectInfoClass::countFiscSegments(TBdocument *doink,
									   int *index)

{

	/* returns count of	fisc objects to	be used	*/

	char system_command	[500];
	char segType[50];
	int	result;
	int	x1,x2,y1,y2;
	int	count;
	FILE *fp;

	/* write out a copy	of the deskewed	image for FISC */

	tbWriteTiffBinary(doink,"tmp.tif",doink->iRows,	doink->iCols,
		doink->ub1BitImage,COMPRESSION_CCITTFAX4, NULL,0);

	sprintf(system_command,"%s","/proj/vision/src/fisc/fisc3 tmp.tif");
	system (system_command);

	/* now parse the output	(in	tmp.rect) */

	/* first count the number of entries */


	count =	0;
	fp = fopen("tmp.rect","r+");
	result = fscanf(fp,"%d %d %d %d	%s ",
		(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType);
	while (result == 5)
	{
		/* increment count if it is	one	of the zones we	are	interested 
		in Line, pepper, Texty_Logo	 were left out 
		Only count zones > 200 pixel in	height and width*/

		if (	(strcmp(segType,"roman_print") == 0) ||	
			(strcmp(segType,"arab_print") == 0)	||
			(strcmp(segType,"jap_print") ==	0) || 
			(strcmp(segType,"roman_hand") == 0)	|| 
			(strcmp(segType,"jap_hand")	== 0) || 
			(strcmp(segType,"arab_hand") ==	0) || 
			(strcmp(segType,"horizontal_line") == 0) ||	
			(strcmp(segType,"vertical_line") ==	0) )
		{
			if (((y2-y1) > 200)	&& ((x2-x1)	> 200) ) 
			{
				count++;
				//	printf("%s %d %d %d	%d height: %d width: %d\n",segType,	x1,	y1,	x2,	y2,y2-y1,x2-x1);
			}
		}
		result = fscanf(fp,"%d %d %d %d	%s",
			(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType);

	}

	fclose(fp);
	return (count);
	system ("rm	tmp.tif");
	system ("rm	tmp.rect");


}
/*---------------------------------------------------------------*/


int	objectInfoClass::countScansoftSegments(char	*filename)

{

	/* returns count of	scansoft objects to	be used	*/

	char segType[50];
	char segText[50];
	int	result;
	int	x1,x2,y1,y2;
	int	count;
	FILE *fp;

	/* now parse the output	stored in filename */

	count =	0;
	fp = fopen(filename,"r");
	result = fscanf(fp,"%*s	%*s	%*s	%d %*s %d %*s %d %*s %d	%*s	%s %*s %s ",
		(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType,segText);

	while (result == 6)
	{
		count++;
		result = fscanf(fp,"%*s	%*s	%*s	%d %*s %d %*s %d %*s %d	%*s	%s %*s %s ",
			(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType,segText);
	}
	fclose (fp);

	return (count);
}
/*-------------------------------------------------------------------*/
void objectInfoClass::computeScansoftSegments(TBdocument *doink,
											  objectInfo *imageObjects ,
											  int *index,char *filename)

{

	/* returns count of	fisc objects to	be used	*/

	char system_command	[500];
	char segType[50];
	char segText[50];
	int	result;
	int	x1,x2,y1,y2;
	int	count;
	FILE *fp;

	/* scansoft	segmenter has been run and the results are in
	a temporary	file.  Just	parse the results */

	fp = fopen(filename,"r");
	result = fscanf(fp,"%*s	%*s	%*s	%d %*s %d %*s %d %*s %d	%*s	%s %*s %s ",
		(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType,segText);
	while (result == 6)
	{
		/* increment count if it is	one	of the zones we	are	interested 
		in Line, pepper, Texty_Logo	 were left out */

		if (	(strcmp(segType,"flowed_text") == 0) )
		{
			imageObjects[*index].type =	scansoft_flowed_text;
		}
		else if	 ( (strcmp(segType,"table_text") ==	0) )
		{
			imageObjects[*index].type =	scansoft_table;
		}
		else if	 ( (strcmp(segType,"graphics_zones") ==	0) )
		{
			imageObjects[*index].type =	scansoft_graphics;
		}

		imageObjects[*index].int_qualifier = 0;
		imageObjects[*index].location[0].x = x1;
		imageObjects[*index].location[0].y = y1;
		imageObjects[*index].location[1].x = x2;
		imageObjects[*index].location[1].y = y2;
		imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
		sprintf(imageObjects[*index].qualifier,"%s",
			segText);
		*index = *index+1;

		result = fscanf(fp,"%*s	%*s	%*s	%d %*s %d %*s %d %*s %d	%*s	%s %*s %s ",
			(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType,segText);
	}
	fclose(fp);

}


/*-------------------------------------------------------------------*/
void objectInfoClass::computeFiscSegments(TBdocument *doink,objectInfo *imageObjects ,
										  int *index)

{

	/* returns count of	fisc objects to	be used	*/

	char system_command	[500];
	char segType[50];
	int	result;
	int	x1,x2,y1,y2;
	int	count;
	FILE *fp;

	/* fisc	was	already	run	when we	counted	the	fisc segments */


	/* now parse the output	(in	tmp.rect) */


	fp = fopen("tmp.rect","r+");
	result = fscanf(fp,"%d %d %d %d	%s ",
		(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType);
	while (result == 5)
	{
		/* increment count if it is	one	of the zones we	are	interested 
		in Line, pepper, Texty_Logo	 were left out */

		if (		 ((y2-y1) >	200) &&	((x2-x1) > 200)	)
		{
			if (	(strcmp(segType,"roman_print") == 0) )
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_roman_print");
				imageObjects[*index].type =	fisc_roman_print;
				imageObjects[*index].int_qualifier = 0;
				imageObjects[*index].location[0].x = x1;
				imageObjects[*index].location[0].y = y1;
				imageObjects[*index].location[1].x = x2;
				imageObjects[*index].location[1].y = y2;
				*index = *index+1;
			}
			if (		(strcmp(segType,"arab_print") == 0)	)
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_arab_print");
				imageObjects[*index].type =	fisc_arab_print;
				imageObjects[*index].int_qualifier = 0;
				imageObjects[*index].location[0].x = x1;
				imageObjects[*index].location[0].y = y1;
				imageObjects[*index].location[1].x = x2;
				imageObjects[*index].location[1].y = y2;
				*index = *index+1;
			}
			if (		(strcmp(segType,"jap_print") ==	0) )
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_jap_print");
				imageObjects[*index].type =	fisc_jap_print;
				imageObjects[*index].int_qualifier = 0;
				*index = *index+1;
			}
			if (		(strcmp(segType,"roman_hand") == 0)	)
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_roman_hand");
				imageObjects[*index].type =	fisc_roman_hand;
				imageObjects[*index].int_qualifier = 0;
				*index = *index+1;
			}
			if (		(strcmp(segType,"jap_hand")	== 0)  )
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_jap_hand");
				imageObjects[*index].type =	fisc_jap_hand;
				imageObjects[*index].int_qualifier = 0;
				*index = *index+1;
			}
			if (		(strcmp(segType,"arab_hand") ==	0) )
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_arab_hand");
				imageObjects[*index].type =	fisc_arab_hand;
				imageObjects[*index].int_qualifier = 0;
				*index = *index+1;
			}
			if (		(strcmp(segType,"horizontal_line") == 0)  )
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_horizontal_line");
				imageObjects[*index].type =	fisc_horizontal_line;
				imageObjects[*index].int_qualifier = 0;
				*index = *index+1;
			}
			if (		(strcmp(segType,"vertical_line") ==	0) )
			{
				imageObjects[*index].qualifier=	(char *) calloc	(25,sizeof(char));
				sprintf(imageObjects[*index].qualifier,"%s","fisc_vertical_line");
				imageObjects[*index].type =	fisc_vertical_line;
				imageObjects[*index].int_qualifier = 0;
				*index = *index+1;
			}
		}
		result = fscanf(fp,"%d %d %d %d	%s",
			(int *)	&x1, (int *) &y1, (int *) &x2, (int*) &y2, segType);
	}
	fclose(fp);

}

/*-------------------------------------------------------------------*/

void objectInfoClass::printObjectInfo(char *filename)
{
	int	k;
	FILE *fp;

	if (filename ==	NULL)
		for	(k=0;k<_objectCount;k++)
		{
			printf("Type: %d  xmin:	%d	 ymin: %d	xmax: %d   ymax: %d	int_qualifiler:	%d qualifier: %s \n",
				imageObjects[k].type,
				imageObjects[k].location[0].x,
				imageObjects[k].location[0].y,
				imageObjects[k].location[1].x,
				imageObjects[k].location[1].y,
				imageObjects[k].int_qualifier,
				imageObjects[k].qualifier);
		}
	else
	{
		printf("filename: %s\n",filename);
		fp = fopen(filename,"w");
		if (fp != NULL)
		{
			for	(k=0;k<_objectCount;k++)
			{
				fprintf(fp,"Type: %d  xmin:	%d	 ymin: %d	xmax: %d   ymax: %d	int_qualifier: %d qualifier: %s	\n",
					imageObjects[k].type,
					imageObjects[k].location[0].x,
					imageObjects[k].location[0].y,
					imageObjects[k].location[1].x,
					imageObjects[k].location[1].y,
					imageObjects[k].int_qualifier,
					imageObjects[k].qualifier);
			}
			fclose (fp);
		}
		else
		{
			printf("could not open:	%s \n",filename);
		}
	}
}

/**	\fn	void void objectInfoClass::printTextLineInfo(FILE *fp)
* This method prints the text line object information to a file.
* This includes	the	upper right	and	lower left bounding	box	
* information
*/

/*-------------------------------------------------------------------*/

void objectInfoClass::printTextLineInfo(FILE *fp)
{
	int	k;
	float ul_y;
	float lr_y;
	float max_y;
	float min_y;
	int	j;



	for	(k=0;k<_objectCount;k++)
	{
		if (imageObjects[k].type ==	textLine)
		{
			if (imageObjects[k].location[0].y <
				imageObjects[k].location[1].y) /* slope	is positive	*/
			{
				max_y =	imageObjects[k].location[1].y;
				min_y =	imageObjects[k].location[0].y;
			}
			else
			{
				max_y =	imageObjects[k].location[0].y;
				min_y =	imageObjects[k].location[1].y;
			}


			if (min_y >= imageObjects[k].upper_ext)
				ul_y = 
				min_y-imageObjects[k].upper_ext;
			else
				ul_y= 0;

			if ((max_y - imageObjects[k].lower_ext)	
				<= _height)
				lr_y = 
				max_y-imageObjects[k].lower_ext;
			else
				lr_y = _height -1;

			if (fp == NULL)
			{
				printf("TextLine  ur_xmin: %d	ur_ymin: %d	  ll_xmax: %d	ll_ymax: %d	\n",
					imageObjects[k].location[0].x ,
					(int) ul_y,
					imageObjects[k].location[1].x,
					(int) lr_y);
			}
			else
			{
				fprintf(fp,"TextLine  ur_xmin: %d	ur_ymin: %d	  ll_xmax: %d	ll_ymax: %d	\n",
					imageObjects[k].location[0].x,
					(int) ul_y,
					imageObjects[k].location[1].x,
					(int) lr_y);
			}
		}
	}

}

/*-------------------------------------------------------------------*/
/**	\fn	void objectInfoClass::writeG4TiffGray(char *fname)
This method	writes a G4	compressed version of the deskewed 
binary or grayscale	version	of the image.  The skew	angle and
page rotation are passed in	and	are	used to	decide how much	
the	image needs	to be rotated.
**/


void objectInfoClass::writeG4TiffGray(char *fname,
									  float	*skew, int rotation)
{
	TBdocument *doink;
	TBdocument *doink1;
	unsigned char *ptr;
	int	iNewRow, iNewCol;
	unsigned char *output_image_data;
	float rotation_angle;
	int	local_height;
	int	local_width;

	doink =	(TBdocument	*) calloc(1,sizeof(TBdocument));
	doink1 = (TBdocument *)	calloc(1,sizeof(TBdocument));
	doink->fHorizontalRes =	_horRes;
	doink->fVerticalRes	= _verRes;

	if (rotation ==	0)
		rotation_angle = *skew;
	else if	(rotation == 1)	
		rotation_angle = 3.1417*1.5	+ *skew;
	else if	(rotation == 2)	
		rotation_angle = 3.1417	+ *skew;
	else if	(rotation == 3)	
		rotation_angle = 3.1417*0.5	+ *skew;

	if (_grayPixelData != NULL)
	{
		/* grayscale pixel data	has	not	been deskewed.	Do this
		and	take into account the script id	rotation */

		/* grayscale version of	images is available, deskew	it
		and	write it out */

		tbRotate8BitArray(_grayPixelData,_originalWidth, _originalHeight,
			rotation_angle,	&iNewRow, &iNewCol,	 &output_image_data,
			5) ;

		tbiWriteTiff8Bit( doink, fname,	iNewRow,  iNewCol,
			(unsigned char *) output_image_data, 0,
			NULL,COMPRESSION_NONE);
		if (output_image_data != NULL)
			free(output_image_data);

	}
	else
		if (_pixelData != NULL)
		{
			doink->iRows = _height;
			doink->iCols = _width;
			doink->fHorizontalRes= 200;
			doink->fVerticalRes	= 200;
			output_image_data =	NULL;
			tbRotate8BitArray(_pixelData,_originalWidth, _originalHeight,
				rotation_angle,	&iNewRow, &iNewCol,	 &output_image_data,
				5) ;
			tbCompress8BytesTo1Byte(output_image_data, iNewRow,iNewCol,
				&ptr); 
			local_height = iNewRow;
			local_width	= iNewCol;
			tbDocumentFromBitMap(doink,	doink1,	ptr, local_height, local_width);
			tbWriteTiffBinary(doink1,fname,local_height, local_width,
				doink1->ub1BitImage,COMPRESSION_CCITTFAX4, NULL,0);
			if (ptr	!= NULL)
				free(ptr);
			if (output_image_data != NULL)
				free(output_image_data);
		}
		tbClose(doink);
		tbClose(doink1);
		free(doink);
		free(doink1);

}


/*-------------------------------------------------------------------*/
/**	\fn	void objectInfoClass::writeG4Tiff(char *fname)
* This method writes a G4 compressed version of	the	binary image
* The image	is exactly as read.	No enhancement or deskewing	has
* been performed 
*/


void objectInfoClass::writeG4Tiff(char *fname)
{
	TBdocument *doink;
	TBdocument *doink1;
	unsigned char *ptr;

	doink =	(TBdocument	*) calloc(1,sizeof(TBdocument));
	doink1 = (TBdocument *)	calloc(1,sizeof(TBdocument));
	if (_pixelData != NULL)
	{
		doink->iRows = _originalHeight;
		doink->iCols = _originalWidth;
		doink->fHorizontalRes= 200;
		doink->fVerticalRes	= 200;
		tbCompress8BytesTo1Byte(_pixelData,	_originalHeight,_originalWidth,
			&ptr);
		tbDocumentFromBitMap(doink,	doink1,	ptr, _height, _width);
		tbWriteTiffBinary(doink1,fname,doink1->iRows, doink1->iCols,
			doink1->ub1BitImage,(long) COMPRESSION_CCITTFAX4, NULL,0);
		if (ptr	!= NULL)
			free(ptr);
	}
	tbClose(doink);
	tbClose(doink1);
	free(doink);
	free(doink1);

}

/**	\fn	void objectInfoClass::computeInterlineSpacingFeatures(TBdocument *doink, TBlineInfo	*textLines,	int	long_line_count, float *peakValue, float *peakRatio)
* This method computes feature values relating to image
* interline	spacing.  Text line	information	is used	to create a
* input	to a DCT funtion.  This	input represents each text line
* by a projection onto the y axis.	The	y axis values are uniformly
* represented by a triangular window of	width 3.  Once the DCT
* is computed the features values computed are the first peak value.
* and the peak/median ratio	in a window	around the first peak.
*
* Some experimentation was done	with weighting the dct input values
* by the line width	however	there were no signification	benefits shown.
* 
* If no	text lines are present zero	is returned	for	the	peak value
* and peak ratio
*
*/


/*-------------------------------------------------------------------*/

void objectInfoClass::computeInterlineSpacingFeatures(TBdocument *doink,
													  TBlineInfo *textLines, int long_line_count,
													  float	*peakValue,	float *peakRatio)
{

	int	window;
	int	index, i,j;
	float x_intercept;
	double *dct_input;
	double *dct_array;
	int	location, start;
	float max_dct_input;
	int	dct_window_width = 2;

	if (long_line_count	== 0)
	{
		*peakValue = 0;
		*peakRatio = 0;
		return;
	}

	/* the debug code below	will draw the text lines.  Lines
	with avg. component	height <= 7	are	in one color and the
	rest are in	another.  This is legacy code and will probably	
	not	work without a bit of debug	
	#ifdef DBG1


	index =	0;

	for	(i = 0;	i <	long_line_count;i++)
	{
	if (textLines[i].componentCount	> 0)
	{
	x_intercept	= textLines[i].intercept;
	/* draw	the	line using points x	= xmin and x = xmax	
	y1 = (int) (x_intercept	+ textLines[i].xMin	* textLines[i].slope);
	y2 = (int) (x_intercept	+ textLines[i].xMax	* textLines[i].slope);
	if ((y1	> 0) &&	(y2	< doink->iRows - 1)	&& 
	(y1	< doink->iRows - 1)	&& (y2 > 0))
	{
	if (textLines[i].avgHeight > 7)
	color =	TB_IndianRed;
	else
	color =	TB_ForestGreen;
	tbDrawLineColor(doink, pixels, color, y1,
	(int) textLines[i].xMin-(int)avg_width,	y2,	(int) textLines[i].xMax+(int) avg_width);
	tbDrawLineColor(doink, pixels, color, y1-1,	
	(int)  textLines[i].xMin-(int)avg_width,
	y2-1, (int)	 textLines[i].xMax+(int) avg_width);
	tbDrawLineColor(doink, pixels, color, y1+1,
	(int)  textLines[i].xMin -(int)avg_width , 
	y2+1, (int)	 textLines[i].xMax +(int) avg_width);
	}
	}
	}
	/*
	tbiWriteTiff8Bit(doink,"testlines.tif",
	doink->iRows, doink->iCols,	pixels,	TB_COLORCOUNT, tbColorMap, 5);

	#endif */

	/* build array for dct */

	dct_input =	(double	*) calloc(doink->iRows,	sizeof(double));
	for	(i = 0;	i <	long_line_count; i++)
	{
		x_intercept	= textLines[i].intercept;
		if ((x_intercept > dct_window_width) &&	
			(x_intercept < (doink->iRows - dct_window_width)))
		{

			/* weight the dct value	based on the length	of 
			the	line 

			length = (float) ( textLines[i].xMax -	textLines[i].xMin);
			*/
			index =	(int) rint(x_intercept);


			/* right now I am weighting	the	dct	input by 
			the	length of the line.	 The commented out sections
			below are various weighting	methods.  I	think
			we may wan to go back to weighting the lines uniformly.
			Need to	take into account dct window width (currently 2)
			for	(ii	= 1; ii	<= dct_window_width; ii++)
			{

			dct_input[index	- ii + 1] =
			dct_input[index	-ii	+ 1] +
			length/ii;
			dct_input[index	+ ii - 1] =
			dct_input[index	+ ii - 1] +
			length/ii;
			}
			*/				
			/*
			dct_input[index] = 
			dct_input[index] +length;
			dct_input[index	- 1] = 
			dct_input[index	- 1] + length/2;
			dct_input[index	+ 1] = 
			dct_input[index	+ 1] + length/2;
			*/

			/* weight dct uniformly	*/

			dct_input[index] = 50;
			dct_input[index	- 1] = 
				25;
			dct_input[index	+ 1] = 
				25;

			/* weight the dct value	based on the number	of components in 
			the	line */
			/*
			dct_input[index] = 
			dct_input[index] +(float) point_counts[i];
			dct_input[index	- 1] = 
			dct_input[index	-l]	+ (float) point_counts[i] /	2;
			dct_input[index	+ 1] = 
			dct_input[index	+ 1] + (float) point_counts[i] / 2;
			*/
		}
	}

	max_dct_input =	0;
	for	(i = 0;	i <	doink->iRows; i++)
	{
		if (dct_input[i] > max_dct_input)
			max_dct_input =	dct_input[i];
	}

	/* normallize dct to be	between	0 and 1000 */

	for	(i = 0;	i <	doink->iRows; i++)
	{
		dct_input[i] = dct_input[i]/max_dct_input *	1000;
	}

	tbComputeDCT(dct_input,	doink->iRows, &dct_array);
	free(dct_input);

	/* normalize based on total	power (dct_array[0]) */

	for	(i = 1;	i <	doink->iRows; i++)
	{
		if (dct_array[i] < 0.0)
			dct_array[i] = 0.0 - dct_array[i];

		dct_array[i] = dct_array[i]	/ dct_array[0];
	}
	dct_array[0] = 1;

	/* finds max median	and	max	locations in a set of windows across the array */
	/* find_window_parameters( dct_array, doink->h,	15,	&max_values, 
	&med_values, &max_locations);  */

	find_first_peak(dct_array, doink->iRows, 8,	&location);

	/* find	median around peak */

	if (location < doink->iRows/2)
	{
		window = location;
		start =	location / 2;
	}
	else
	{
		window = 2*(doink->iRows - location);
		start =	(location -	(window/2));
	}

	*peakValue = (float) dct_array[location];
	qsort(&dct_array[start], window, sizeof(dct_array[0]), compare_double);

	*peakRatio = (float) (*peakValue/dct_array[location]);

	/*
	sum	= 0;
	classifier_inputs[0] = (double)	 mean;
	classifier_inputs[1] = (double)	 stddev	/ mean;
	classifier_inputs[2] = (double)	stddev1	/ mean1;
	classifier_inputs[3] = (double)	(end - start + 1);
	classifier_inputs[4] = (double)	 slope_stddev /	slope_mean;
	classifier_inputs[5] = (double)	peak_value / dct_array[location];
	classifier_inputs[6] = (double)	long_line_count;
	classifier_inputs[7] = (double)	peak_value;
	classifier_inputs[8] = (double)	avg_height/avg_width;
	printf("inputs:	");
	for	(i = 0;i <=	7;i++)
	printf("%f ",classifier_inputs[i]);

	printf("\n");
	*/


	if (dct_array != NULL)
		free (dct_array);

}
/*-------------------------------------------------------------------*/

/**	\fn	void void objectInfoClass::computeLineStatistics( TBlineInfo *textLines, int long_line_count)
* This method computes various statistics relating to the text
* lines	on the page.  These	currently include normalized line
* height, width, left indent, and right	indent variance.  These
* statistics may be	used as	features to	algorithms to detect
* text images
*
*Potential improvements:
*
*  Right now all lines are being used for all calculations.
*  It would	be better to remove	outlier	values prior to	calculation
*  to prevent a	few	odd	values from	negating the potential benefit
*  of the features.
*
*  In the case of indent values	it would be	better to look at
*  a the histogram of values and determine if values are
*  concentrated	in a few discrete values.  This	would allow
*  for multicolumn document	images.	The	information	calculated by
*  this	method is stored in	the	class instance and can be accessed via
*
* \sa objectInfoClass::getNormLineHeightVar
*	  objectInfoClass::getNormLineWidthVar
*	  objectInfoClass::getNormLineLeftIndentVar
*	  objectInfoClass::getNormLineRightIndentVar
*/



void objectInfoClass::computeLineStatistics( TBlineInfo	*textLines,	int	long_line_count)
{
	int	height_sum;
	int	width_sum;
	int	left_sum;
	int	right_sum;
	int	i;
	float mean;
	float stddev;
	float *data_array;

	_peakValue = 0;
	/* compute left	indent var */

	tbStructureComputeMeanStddev(&textLines[0].xMin, long_line_count,
		sizeof(TBlineInfo),	&mean, &stddev);

	_normLineLeftIndentVar = stddev/mean;

	/* compute right indent	var	*/

	tbStructureComputeMeanStddev(&textLines[0].xMax, long_line_count,
		sizeof(TBlineInfo),	&mean, &stddev);

	_normLineRightIndentVar	= stddev/mean;

	/* compute line	width var */

	data_array = (float	*) calloc(long_line_count,sizeof(int));
	for	(i = 0;i < long_line_count;i++)
		data_array[i]=(float) (textLines[i].xMax - textLines[i].xMin);

	tbComputeMeanStddev	(data_array, long_line_count,
		&mean, &stddev);

	_normLineWidthVar =	mean/stddev;


	/* compute line	height var */

	for	(i = 0;i < long_line_count;i++)
		/* lower extent	value is negative to subtract to
		make sure the height is	positive */

		data_array[i]=(float) (textLines[i].lineUpperExtent	-
		textLines[i].lineLowerExtent);

	tbComputeMeanStddev	(data_array, long_line_count,
		&mean, &stddev);

	_avgLineHeight = mean;
	_normLineHeightVar = mean/stddev;

	if (data_array != NULL)
		free(data_array);
}

/****************************************************************/

void objectInfoClass::find_first_peak(double *input_array,int length,
									  int offset, int *location)
{

	int	i;
	double max;

	max	= 0;
	for	(i = offset; i < length;i++)
	{
		if (input_array[i] > max)
		{
			max	= input_array[i];
			*location =	i;
		}
	}
}


/*-------------------------------------------------------------------*/
/**	\fn	void objectInfoClass::getSkewRotationCorrectedImageData(char *fname,float *skew, int rotation,unsigned char	**ptr, int *new_height,	int	*new_width)
This method	creates	a deskewed,rotated version of the 
image pixel	data The skew angle	and
page rotation are passed in	and	are	used to	decide how much	
the	image needs	to be rotated.
**/

/*
void objectInfoClass::getSkewRotationCorrectedImageData(char *fname,
float *skew, int rotation,unsigned char	**ptr, int *new_height,	int	*new_width)
{
int	iNewRow, iNewCol;
unsigned char *output_image_data;
float rotation_angle;
int	local_height;
int	local_width;


if (rotation ==	0)
rotation_angle = *skew;
else if	(rotation == 1)	
rotation_angle = 3.1417*1.5	+ *skew;
else if	(rotation == 2)	
rotation_angle = 3.1417	+ *skew;
else if	(rotation == 3)	
rotation_angle = 3.1417*0.5	+ *skew;

if (_grayPixelData != NULL)
{
/* grayscale pixel data	has	not	been deskewed.	Do this
and	take into account the script id	rotation 

/* grayscale version of	images is available, deskew	it
and	write it out 

tbRotate8BitArray(_grayPixelData,_originalWidth, _originalHeight,
rotation_angle,	new_height,	new_width,	*ptr,
5) ;

}
else
if (_pixelData != NULL)
{
tbRotate8BitArray(_pixelData,_originalWidth, _originalHeight,
rotation_angle,	new_height,	new_width,	*ptr,
5) ;
}
}
}
*/



