
#include <cstdio>
#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <string.h>
#include <vector>
#include <algorithm>
#include <objectInfoClass.h>
#include <getLines.h>
#include <DLBitsPerPixelConverter.h>
#include <DLSkew.h>

//#include <sys/param.h>
#include <cstdlib>

#define	MAX_LINES 50 

/*extern "C" 
{
#include <TB.h>
#include <TBColors.h>
}
*/

#include <JScript.h>

#define	SKEW_THRESH	.0017

static int compare_double(const	void *entry1, 
						  const	void *entry2)
{
	double *i,*j;

	i =	(double	*) entry1;
	j =	(double	*) entry2;
	if (*i > *j)
		return (1);
	if (*i < *j)
		return (-1);
	return (0);


}

/****************************************************/

static int sortLines(const void	*entry1, const void	*entry2)
{

	/* note	this is	a reverse order	sort */


	DLlineInfo *i =	(DLlineInfo	*) entry1;
	DLlineInfo *j =	(DLlineInfo	*) entry2;
	float l1;
	float l2;

	l1 = (float) ((i->loc[1].x - i->loc[0].x)*
		(i->loc[1].x - i->loc[1].x)) -
		((i->loc[1].y -	i->loc[0].y)*
		(i->loc[1].y - i->loc[0].y));


	//l1 = ((i->xMax - i->xMin)*
	//					 (i->xMax -	i->xMin)) -
	//					 ((i->yMax - i->yMin) *
	//(i->yMax - i->yMin));
	//l2 = ((j->xMax - j->xMin)*
	//					 (j->xMax -	j->xMin)) -
	//					 ((j->yMax - j->yMin) *
	//						(j->yMax - j->yMin));
	l2 = (float) ((j->loc[1].x - j->loc[0].x)*
		(j->loc[1].x - j->loc[0].x)) -
		((j->loc[1].y -	j->loc[0].y) *
		(j->loc[1].y - j->loc[0].y));
	if (l1 > l2)
		return(-1);
	if (l1 < l2)
		return(1);
	return (0);



}

/****************************************************/


objectInfoClass::~objectInfoClass()
{
	int	i;


	for	(i=0;i<_objectCount;i++)
	{
		if (imageObjects[i].qualifier != NULL)
		{
			//if (i == 99) 			printf("test");
			
			free(imageObjects[i].qualifier);
			imageObjects[i].qualifier=NULL;
		}
	}
	if (_pixelData != NULL)
	{
		free(_pixelData);
		_pixelData = NULL;
	}
	if (_grayPixelData != NULL)
	{
		free(_grayPixelData);
		_grayPixelData=NULL;
	}
	if (imageObjects !=	NULL)
	{
		free (imageObjects);
		imageObjects= NULL;
	}

}

/*********************************************************/
objectInfoClass::objectInfoClass(std::string fname,
								 JScript *scriptInfo, int line_count_limit,
								 char *output_directory,int	pixelDataFlag,int scansoftFlag,
								 int dctFlag)
{

	//const char *name_string;
	string name_string;

	int	index1;
	char path [FILENAME_MAX+1];
	FILE *fp;
	int	cnt;
	int	result;
	int	i;
	DLImage	*doink;
	int	line_count;
	int	delta;
	int	data_type;


	line_count = 0;
	_objectCount = 0;
	_grayPixelData = NULL;
	_threshold = .5;
	_scansoftFlag =	scansoftFlag;
	_dctFlag = dctFlag;
//	name_string	= fname.c_str();
	name_string = fname;

	_scriptInfo	= scriptInfo;
	_pixelData = NULL;

	/* 
	see	if an output file already exist.  If so	read the
	data from the file.	 Otherwise call	method to compute 
	info.
	*/

    // updated by hm, Jun. 19, 2005
	
	if(output_directory != NULL)
	{
		index1 = (int) fname.rfind("/"); 
		if (index1 >= 0)
			sprintf(path,"%s/%s.dat", output_directory,
				name_string.substr(index1+1, 
						   name_string.size()-index1).c_str());
		else
			sprintf(path,"%s/%s.dat", output_directory, name_string.c_str());
	}

	fp = fopen(path,"r");
	
   if (output_directory == NULL || fp == NULL)
	{
		imageObjects = computeObjectInfo(fname,pixelDataFlag);
	}
	else
	{
		/* count entries */

		cnt	= 0;
		result = fscanf(fp,"%*s	%d %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s",
			&data_type);
		while (result >= 0)
		{
			if (data_type == textLine)
				line_count++;
			cnt	++;
			result = fscanf(fp,"%*s	%d %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s",
				&data_type);
		}
		if ((line_count_limit >= 0)	&& (line_count > line_count_limit))
			delta =	line_count - line_count_limit;
		else
		{
			delta =	0;
		}
		_objectCount = cnt-delta;
		imageObjects = (objectInfo *) calloc( _objectCount,	sizeof(objectInfo));
		fseek(fp,0,SEEK_SET);
		line_count = 0;
		for	(i=0;i<_objectCount;i++)
		{
			imageObjects[i].qualifier= (char *)	calloc (25,sizeof(char));
			fscanf (fp,"%*s	%d %*s %d %*s %d %*s %d	%*s	%d %*s %d %*s %s",
				(int *)	&imageObjects[i].type,
				&imageObjects[i].location[0].x,
				&imageObjects[i].location[0].y,
				&imageObjects[i].location[1].x,
				&imageObjects[i].location[1].y,
				&imageObjects[i].int_qualifier,
				imageObjects[i].qualifier);

			if (imageObjects[i].type ==	textLine)
				line_count++;

			if ((line_count_limit >= 0)	&& (line_count > line_count_limit) && (imageObjects[i].type	== textLine))

			{
				/* we already have enought lines.  don't include this one */

				free(imageObjects[i].qualifier);
				i =	i-1;
			}	

		}
		fclose(fp);

		/* need	to open	the	image to get the height, width,	
		and	pixel data */

		doink =	new	DLImage(name_string.c_str());
		//	result=	tbOpen((char *)	name_string, doink,	1,
		//		DISREPLACENEARESTGOOD, 0, NULL,	0, 0);
		_horRes	= doink->dlGetHorizontalResolution();
		_verRes	= doink->dlGetVerticalResolution();
		_originalHeight	= doink->dlGetHeight();
		_originalWidth = doink->dlGetWidth();
/*
		if (doink->dlGetDepth()	== DL_BITDEPTH_8)
			*doink = DLBitsPerPixelConverter::dlDownscaleGray2Binary_global(*doink);
		else if	(doink->dlGetDepth() ==	DL_BITDEPTH_24)
		{
			*doink = DLBitsPerPixelConverter::dlDownscaleColor2Gray_global(*doink);

		}*/


		//if (doink->ub8BitImage !=	NULL)
		//{
		/* this	is a grayscale.	Copy it	to object instance to
		save data, and binarize	it before proceeding */

		//	int	data_size =	doink->iRows*doink->iCols;
		//	_grayPixelData = (unsigned char	*) calloc(data_size,
		//		sizeof(unsigned	char));

		//	memcpy(_grayPixelData, doink->ub8BitImage,data_size);

		//	tbThresholdGlobal8Bit(doink,&_threshold, (char **) &new_array);
		//	tbCompress8BytesTo1Byte(new_array, doink->iRows, doink->iCols, 
		//		&doink->ub1BitImage);
		//doink->iColBytes =(doink->iCols+7)/8;

		//	doink->iImageLength	= tbiPixelToRunStart(doink->ub1BitImage,
		//doink->iCols,
		//(doink->iCols+7)/8,
		//doink->iRows,
		//&doink->image);
		//doink->dSkewAngle	= tbiGetSkew(doink,doink->image, doink->iImageLength);

		//	free(new_array);
		//}


		//tbCalcConnectedComponents(doink, 1, 0);
		if (pixelDataFlag >	0)
			_pixelData = doink->dlGetImageData();
		//tbGetDocumentColor(doink,&_pixelData,0,0xff);
		else _pixelData	= NULL;
		delete doink;


	}


} /* create	method */


/*********************************************************/
objectInfoClass::objectInfoClass(std::string filename,JScript *scriptInfo,
								 int scansoftFlag,int dctFlag)
{


	_objectCount = 0;
	_grayPixelData = NULL;
	_threshold = .5;
	_scansoftFlag =	scansoftFlag;
	_scriptInfo	= scriptInfo;
	_pixelData = NULL;
	_dctFlag = dctFlag;
	imageObjects = computeObjectInfo(filename,1);
} /* create	method */


/*********************************************************/


struct objectInfo *objectInfoClass::computeObjectInfo(std::string fname,
	int	pixelDataFlag)
	/*vector<objectInfo> *objectPairMatrix::computeObjectInfo(std::string fname) */
{
	objectInfo *imageObjects ;
	unsigned char *pixels, *pixels1=NULL;
	
	DLlineInfo				*textLinePtr;
	unsigned char			*newr_image=NULL;
	
	int	long_line_count=0;
	int	*iList=NULL;
	int			   *line_segs =	NULL;
	int	i;
	int	index;
	int	big_line_count;
	double abs_skew;

	
	pixels = NULL;
	_lineCount = 0;
	_lineSlopeVarianceSqr =	0.0;
	_peakValue = 0.0;
	_peakRatio = 0.0;

	/* compute the text	lines and store	info. */

	//doink	= (TBdocument *) calloc(1,sizeof(TBdocument));
	//memset (doink,0, sizeof(doink));
	//name_string =	fname.c_str();
	DLImage	initialImage(fname.c_str());
	//result= tbOpen((char *) name_string, doink, 1, 
	//	DISREPLACENEARESTGOOD, 0, NULL,	0, 0);
	//if (result < 0)
	//{
	//	free(doink);
	//	return(NULL);
	//
	//}

	/* binarize	the	image */

	DLImage	binarizedImage;
	if (initialImage.dlGetDepth() == DL_BITDEPTH_8)
	{
		binarizedImage = DLBitsPerPixelConverter::dlDownscaleGray2Binary_global(initialImage);
		_grayPixelData = initialImage.dlGetSafeImageData();
	}
	else if	(initialImage.dlGetDepth()	== DL_BITDEPTH_24)
	{
		binarizedImage = DLBitsPerPixelConverter::dlDownscaleGray2Binary_niblack(initialImage);
	}
	else binarizedImage	= initialImage;

	/* TBD - add code to store pixel data or gray pixel data in the class */

	
	_horRes =	binarizedImage.dlGetHorizontalResolution();
	_verRes =	binarizedImage.dlGetVerticalResolution();
	//
	_originalHeight	= initialImage.dlGetHeight();
	_originalWidth = initialImage.dlGetWidth();
	

/* store off original pixel	data */

if (pixelDataFlag >	0)
_pixelData = binarizedImage.dlGetImageData();
else _pixelData	= NULL;

_originalImageSkew = DLSkew::dlDetectSkew(binarizedImage, 20, 30, 1);
//_originalImageSkew = binarizedImage.dlDetectSkew();
if (_originalImageSkew >	0)
abs_skew = _originalImageSkew ;
else
abs_skew = 0.0 - _originalImageSkew ;

DLImage deskewedImage;
if (abs_skew > SKEW_THRESH)	
{
	deskewedImage = binarizedImage.dlRotateImage(_originalImageSkew);
	/* deskew based	on .. */
/*
	result = tbGetDocument(cur_doink, &pixels1);
	if (pixels1	== NULL)
		printf("could not tbGetDocument(cur_doink, &pixels1) \n");
	tbRotateUCArray(pixels1, cur_doink->iCols,
		cur_doink->iRows, (double) cur_doink->dSkewAngle, &new_rows, &new_cols,	&newr_image,
		5);


	if (newr_image == NULL)
		printf("error: null	newr_image\n");

	/* generate	new	document based on deskewed pixmap 
	tbDocumentFromBitMap(cur_doink,	doink1,	newr_image,	new_rows, new_cols);
	if (newr_image != NULL)
	{
		free(newr_image);
		newr_image = NULL;
	}

	if (pixels1	!= NULL)
	{
		free(pixels1);
		pixels1	= NULL;
	}
	tbClose(doink);
	cur_doink =	doink1;
	tbCalcConnectedComponents(cur_doink, 0,	0);*/
}
else
deskewedImage = binarizedImage;

// TBD - add code to compute and correct for line orientation
//debug lynn
//binarizedImage.dlSaveImage("binarized_image.tif");
 getLines lineInfo(binarizedImage);

	
 /* TBD add code to get interline spacing features
	if (_dctFlag)
		computeInterlineSpacingFeatures(cur_doink,
		textLines, long_line_count,
		&_peakValue, &_peakRatio);*/

	_lineCount = lineInfo.dlGetLineCount();

	cout << "LineCount: " << _lineCount << endl;

	DLlineInfo *textLines = lineInfo.dlGetInfo();
	
	/* TBD - the DLlineInfo class allows for specification of hte mininimum
	average connected component height for lines (effectively filtering).  Right
	now the minimum average height is set to 7, appropriate for this applications, however
	this code will have to be modified to assure the correct value is used once the
	methods are available */

	/* sort	the	lines by their length so the longest 50	lines can be 
	be selected	*/

	//qsort(textLines,_lineCount,sizeof (textLines[0]),
	//	sortLines);
	/* count lines > 7 pixels in avg height	*/

	//big_line_count = 0;
	//for	(i=0;i<_lineCount;i++)
	//	if (textLines[i].avgHeight > 7)
	//		big_line_count++;

	

/*	the	height , width and pixel data for the deskewed image
are	stored in the class	members	*/
_height	= binarizedImage.dlGetHeight();
_width = binarizedImage.dlGetWidth();

//_lineCount = lineInfo.dlGetLineCount();
//DLlineInfo *textLines = lineInfo.dlGetInfo();
//qsort(lines, _lineCount,sizeof(DLlineInfo),sortLines);



/* TBD - way to sort lines by lenght */

//_lineCount = big_line_count;


_objectCount = _lineCount +	1;	 


/* allocate	room for lines,	 script, etc. */
imageObjects = (objectInfo *) calloc( _objectCount,	sizeof(objectInfo));
for (i=0;i<_objectCount;i++)
{
	imageObjects[i].qualifier = NULL;


}

/* store line count	n*/

index =	0;
index =	-1;
/*
imageObjects[index].type = textLineCount;
imageObjects[index].location[0].x =	-1;
imageObjects[index].location[0].y =	-1;
imageObjects[index].location[1].x =	-1;
imageObjects[index].location[1].y =	-1;
imageObjects[index].int_qualifier =	long_line_count;
imageObjects[index].qualifier= (char *)	calloc (25,sizeof(char));
*/
float lineSlopeMean= 0.0;
_lineSlopeVarianceSqr =	0.0;

/* tbd ADD code to make sure lines are limited by MAX_LINES */

for	(i=0;i<_lineCount;i++)
{
	
		index++;
		imageObjects[index].type = textLine;
		imageObjects[index].qualifier= (char *)	calloc (25,sizeof(char));
		lineSlopeMean =	lineSlopeMean+
			textLines[i].slope;

		/* store line height; lowerExtent is subtracted	because	it
		is a negative number */

		imageObjects[index].int_qualifier= (int) (textLines[i].upperExt -
			textLines[i].lowerExt);

		/* the line	upper and lower	extent is not being	used in	layout ive
		it was added for use by	Dumpsterdiver.	It allows the bounding box
		informaitno	to be calculated */

		imageObjects[index].upper_ext =	textLines[i].upperExt;
		imageObjects[index].lower_ext =	textLines[i].lowerExt;
		sprintf(imageObjects[index].qualifier,"%s","test");

		/* store line endpoints	for	locations */

		textLinePtr	= &textLines[i];
		/*	pointPtr = textLinePtr.pointLocation; */
		imageObjects[index].location[0].x =	(int) textLinePtr->loc[2].x;
		imageObjects[index].location[0].y =	(int) (textLinePtr->slope*textLinePtr->loc[2].y	+ 
			textLinePtr->yIntercept); 

		imageObjects[index].location[1].x =	(int) textLinePtr->loc[3].x;
		imageObjects[index].location[1].y =	(int) (textLinePtr->slope*textLinePtr->loc[3].y	+ 
			textLinePtr->yIntercept); 
	
}
lineSlopeMean =	lineSlopeMean/(float) _lineCount;
for	(i=0;i<_lineCount;i++)
{
	
		_lineSlopeVarianceSqr =	_lineSlopeVarianceSqr +	
			(textLines[i].slope	- lineSlopeMean) * (textLines[i].slope - lineSlopeMean)	;
	
}
index++;
//tbiFreeLineInfo(textLines,long_line_count);
imageObjects[index].type = script;
imageObjects[index].qualifier= (char *)	calloc 
(20,sizeof(char));

if (_scriptInfo	!= NULL)
{
	//_scriptInfo->getScript(cur_doink,_script);
	char *bestFit = _scriptInfo->getScript(binarizedImage);
	
	//char *bestFit =	_scriptInfo->getFirst();
	strcpy(_bestFitScript,bestFit);
	strcpy(_script, _bestFitScript);
	_scriptIdOrientation = _scriptInfo->getOrientation();
}
else
{
	strcpy(_script,"undetermined");
	strcpy(_bestFitScript,"undetermined");
	_scriptIdOrientation = 0;
}


sprintf(imageObjects[index].qualifier,"%s",_script);
/*_scriptInfo->getScript(cur_doink,imageObjects[index].qualifier); */

imageObjects[index].location[0].x =	-1;
imageObjects[index].location[0].y =	-1;
imageObjects[index].location[1].x =	-1;
imageObjects[index].location[1].y =	-1;
index++;



return(imageObjects);

}




/*-------------------------------------------------------------------*/

void objectInfoClass::printObjectInfo(char *filename)
{
	int	k;
	FILE *fp;

	if (filename ==	NULL)
		for	(k=0;k<_objectCount;k++)
		{
			printf("Type: %d  xmin:	%d	 ymin: %d	xmax: %d   ymax: %d	int_qualifiler:	%d qualifier: %s \n",
				imageObjects[k].type,
				imageObjects[k].location[0].x,
				imageObjects[k].location[0].y,
				imageObjects[k].location[1].x,
				imageObjects[k].location[1].y,
				imageObjects[k].int_qualifier,
				imageObjects[k].qualifier);
		}
	else
	{
		printf("filename: %s\n",filename);
		fp = fopen(filename,"w");
		if (fp != NULL)
		{
			for	(k=0;k<_objectCount;k++)
			{
				fprintf(fp,"Type: %d  xmin:	%d	 ymin: %d	xmax: %d   ymax: %d	int_qualifier: %d qualifier: %s	\n",
					imageObjects[k].type,
					imageObjects[k].location[0].x,
					imageObjects[k].location[0].y,
					imageObjects[k].location[1].x,
					imageObjects[k].location[1].y,
					imageObjects[k].int_qualifier,
					imageObjects[k].qualifier);
			}
			fclose (fp);
		}
		else
		{
			printf("could not open:	%s \n",filename);
		}
	}
}

/**	\fn	void void objectInfoClass::printTextLineInfo(FILE *fp)
* This method prints the text line object information to a file.
* This includes	the	upper right	and	lower left bounding	box	
* information
*/

/*-------------------------------------------------------------------*/

void objectInfoClass::printTextLineInfo(FILE *fp)
{
	int	k;
	float ul_y;
	float lr_y;
	float max_y;
	float min_y;

	for	(k=0;k<_objectCount;k++)
	{
		if (imageObjects[k].type ==	textLine)
		{
			if (imageObjects[k].location[0].y <
				imageObjects[k].location[1].y) /* slope	is positive	*/
			{
				max_y =	(float) imageObjects[k].location[1].y;
				min_y =	(float) imageObjects[k].location[0].y;
			}
			else
			{
				max_y =	(float) imageObjects[k].location[0].y;
				min_y =	(float) imageObjects[k].location[1].y;
			}


			if (min_y >= imageObjects[k].upper_ext)
				ul_y = 
				min_y-imageObjects[k].upper_ext;
			else
				ul_y= 0;

			if ((max_y - imageObjects[k].lower_ext)	
				<= _height)
				lr_y = 
				max_y-imageObjects[k].lower_ext;
			else
				lr_y = (float) (_height -1);

			if (fp == NULL)
			{
				printf("TextLine  ur_xmin: %d	ur_ymin: %d	  ll_xmax: %d	ll_ymax: %d	\n",
					imageObjects[k].location[0].x ,
					(int) ul_y,
					imageObjects[k].location[1].x,
					(int) lr_y);
			}
			else
			{
				fprintf(fp,"TextLine  ur_xmin: %d	ur_ymin: %d	  ll_xmax: %d	ll_ymax: %d	\n",
					imageObjects[k].location[0].x,
					(int) ul_y,
					imageObjects[k].location[1].x,
					(int) lr_y);
			}
		}
	}

}

/*-------------------------------------------------------------------*/
/**	\fn	void objectInfoClass::writeG4TiffGray(char *fname)
This method	writes a G4	compressed version of the deskewed 
binary or grayscale	version	of the image.  The skew	angle and
page rotation are passed in	and	are	used to	decide how much	
the	image needs	to be rotated.
**/


void objectInfoClass::writeG4TiffGray(char *fname,
									  float	*skew, int rotation)
{
	
	double rotation_angle;
	
	/* use the gray or binary data stored to output a copy of the image */

	DLImage *outImage;
	if (_grayPixelData != NULL)
	{
		outImage = new DLImage(_width, _height, DL_BITDEPTH_8);
	}
	else if (_pixelData != NULL)
		outImage = new DLImage(_width, _height, DL_BITDEPTH_1);

	outImage->dlSetHorizontalResolution(_horRes);
	outImage->dlSetVerticalResolution(_verRes);

	
	if (rotation ==	0)
		rotation_angle = *skew;
	else if	(rotation == 1)	
		rotation_angle = 3.1417*1.5	+ *skew;
	else if	(rotation == 2)	
		rotation_angle = 3.1417	+ *skew;
	else if	(rotation == 3)	
		rotation_angle = 3.1417*0.5	+ *skew;

	outImage->dlRotateImage(rotation_angle);
	outImage->dlSaveImage(fname);
	delete outImage;

}


/*-------------------------------------------------------------------*/
/**	\fn	void objectInfoClass::writeG4Tiff(char *fname)
* This method writes a G4 compressed version of	the	binary image
* The image	is exactly as read.	No enhancement or deskewing	has
* been performed 
*/


void objectInfoClass::writeG4Tiff(char *fname)
{
	

	DLImage *outImage;
	if (_grayPixelData != NULL)
	{
		outImage = new DLImage(_width, _height, DL_BITDEPTH_8);
	}
	else if (_pixelData != NULL)
		outImage = new DLImage(_width, _height, DL_BITDEPTH_1);

	outImage->dlSetHorizontalResolution(_horRes);
	outImage->dlSetVerticalResolution(_verRes);
	outImage->dlSaveImage(fname);

	delete outImage;


}

/**	\fn	void objectInfoClass::computeInterlineSpacingFeatures(TBdocument *doink, TBlineInfo	*textLines,	int	long_line_count, float *peakValue, float *peakRatio)
* This method computes feature values relating to image
* interline	spacing.  Text line	information	is used	to create a
* input	to a DCT funtion.  This	input represents each text line
* by a projection onto the y axis.	The	y axis values are uniformly
* represented by a triangular window of	width 3.  Once the DCT
* is computed the features values computed are the first peak value.
* and the peak/median ratio	in a window	around the first peak.
*
* Some experimentation was done	with weighting the dct input values
* by the line width	however	there were no signification	benefits shown.
* 
* If no	text lines are present zero	is returned	for	the	peak value
* and peak ratio
*
*/


/*-------------------------------------------------------------------*/

void objectInfoClass::computeInterlineSpacingFeatures(DLImage *doink,
													  DLlineInfo *textLines, int long_line_count,
													  float	*peakValue,	float *peakRatio)
{

	int	window;
	int	index, i;
	double x_intercept;
	double *dct_input;
	double *dct_array;
	int	location, start;
	double max_dct_input;
	int	dct_window_width = 2;

	if (long_line_count	== 0)
	{
		*peakValue = 0;
		*peakRatio = 0;
		return;
	}

	/* the debug code below	will draw the text lines.  Lines
	with avg. component	height <= 7	are	in one color and the
	rest are in	another.  This is legacy code and will probably	
	not	work without a bit of debug	
	#ifdef DBG1


	index =	0;

	for	(i = 0;	i <	long_line_count;i++)
	{
	if (textLines[i].componentCount	> 0)
	{
	x_intercept	= textLines[i].intercept;
	/* draw	the	line using points x	= xmin and x = xmax	
	y1 = (int) (x_intercept	+ textLines[i].xMin	* textLines[i].slope);
	y2 = (int) (x_intercept	+ textLines[i].xMax	* textLines[i].slope);
	if ((y1	> 0) &&	(y2	< doink->iRows - 1)	&& 
	(y1	< doink->iRows - 1)	&& (y2 > 0))
	{
	if (textLines[i].avgHeight > 7)
	color =	TB_IndianRed;
	else
	color =	TB_ForestGreen;
	tbDrawLineColor(doink, pixels, color, y1,
	(int) textLines[i].xMin-(int)avg_width,	y2,	(int) textLines[i].xMax+(int) avg_width);
	tbDrawLineColor(doink, pixels, color, y1-1,	
	(int)  textLines[i].xMin-(int)avg_width,
	y2-1, (int)	 textLines[i].xMax+(int) avg_width);
	tbDrawLineColor(doink, pixels, color, y1+1,
	(int)  textLines[i].xMin -(int)avg_width , 
	y2+1, (int)	 textLines[i].xMax +(int) avg_width);
	}
	}
	}
	/*
	tbiWriteTiff8Bit(doink,"testlines.tif",
	doink->iRows, doink->iCols,	pixels,	TB_COLORCOUNT, tbColorMap, 5);

	#endif */

	/* build array for dct */

	dct_input =	(double	*) calloc(doink->dlGetHeight(),	sizeof(double));
	int rows = doink->dlGetHeight();
	int cols = doink->dlGetWidth();
	for	(i = 0;	i <	long_line_count; i++)
	{
		x_intercept	= textLines[i].yIntercept;
		if ((x_intercept > dct_window_width) &&	
			(x_intercept < (rows - dct_window_width)))
		{

			/* weight the dct value	based on the length	of 
			the	line 

			length = (float) ( textLines[i].xMax -	textLines[i].xMin);
			*/
			/* round intercept */
			index =	(int) (x_intercept+.5);


			/* right now I am weighting	the	dct	input by 
			the	length of the line.	 The commented out sections
			below are various weighting	methods.  I	think
			we may wan to go back to weighting the lines uniformly.
			Need to	take into account dct window width (currently 2)
			for	(ii	= 1; ii	<= dct_window_width; ii++)
			{

			dct_input[index	- ii + 1] =
			dct_input[index	-ii	+ 1] +
			length/ii;
			dct_input[index	+ ii - 1] =
			dct_input[index	+ ii - 1] +
			length/ii;
			}
			*/				
			/*
			dct_input[index] = 
			dct_input[index] +length;
			dct_input[index	- 1] = 
			dct_input[index	- 1] + length/2;
			dct_input[index	+ 1] = 
			dct_input[index	+ 1] + length/2;
			*/

			/* weight dct uniformly	*/

			dct_input[index] = 50;
			dct_input[index	- 1] = 
				25;
			dct_input[index	+ 1] = 
				25;

			/* weight the dct value	based on the number	of components in 
			the	line */
			/*
			dct_input[index] = 
			dct_input[index] +(float) point_counts[i];
			dct_input[index	- 1] = 
			dct_input[index	-l]	+ (float) point_counts[i] /	2;
			dct_input[index	+ 1] = 
			dct_input[index	+ 1] + (float) point_counts[i] / 2;
			*/
		}
	}

	max_dct_input =	0;
	for	(i = 0;	i <	rows; i++)
	{
		if (dct_input[i] > max_dct_input)
			max_dct_input =	dct_input[i];
	}

	/* normallize dct to be	between	0 and 1000 */

	for	(i = 0;	i <	rows; i++)
	{
		dct_input[i] = dct_input[i]/max_dct_input *	1000;
	}

	tbComputeDCT(dct_input,	rows, &dct_array);
	free(dct_input);

	/* normalize based on total	power (dct_array[0]) */

	for	(i = 1;	i <	rows; i++)
	{
		if (dct_array[i] < 0.0)
			dct_array[i] = 0.0 - dct_array[i];

		dct_array[i] = dct_array[i]	/ dct_array[0];
	}
	dct_array[0] = 1;

	/* finds max median	and	max	locations in a set of windows across the array */
	/* find_window_parameters( dct_array, doink->h,	15,	&max_values, 
	&med_values, &max_locations);  */

	find_first_peak(dct_array, rows, 8,	&location);

	/* find	median around peak */

	if (location < rows/2)
	{
		window = location;
		start =	location / 2;
	}
	else
	{
		window = 2*(rows - location);
		start =	(location -	(window/2));
	}

	*peakValue = (float) dct_array[location];
	qsort(&dct_array[start], window, sizeof(dct_array[0]), compare_double);

	*peakRatio = (float) (*peakValue/dct_array[location]);

	/*
	sum	= 0;
	classifier_inputs[0] = (double)	 mean;
	classifier_inputs[1] = (double)	 stddev	/ mean;
	classifier_inputs[2] = (double)	stddev1	/ mean1;
	classifier_inputs[3] = (double)	(end - start + 1);
	classifier_inputs[4] = (double)	 slope_stddev /	slope_mean;
	classifier_inputs[5] = (double)	peak_value / dct_array[location];
	classifier_inputs[6] = (double)	long_line_count;
	classifier_inputs[7] = (double)	peak_value;
	classifier_inputs[8] = (double)	avg_height/avg_width;
	printf("inputs:	");
	for	(i = 0;i <=	7;i++)
	printf("%f ",classifier_inputs[i]);

	printf("\n");
	*/


	if (dct_array != NULL)
		free (dct_array);

}
/*-------------------------------------------------------------------*/

/**	\fn	void void objectInfoClass::computeLineStatistics( TBlineInfo *textLines, int long_line_count)
* This method computes various statistics relating to the text
* lines	on the page.  These	currently include normalized line
* height, width, left indent, and right	indent variance.  These
* statistics may be	used as	features to	algorithms to detect
* text images
*
*Potential improvements:
*
*  Right now all lines are being used for all calculations.
*  It would	be better to remove	outlier	values prior to	calculation
*  to prevent a	few	odd	values from	negating the potential benefit
*  of the features.
*
*  In the case of indent values	it would be	better to look at
*  a the histogram of values and determine if values are
*  concentrated	in a few discrete values.  This	would allow
*  for multicolumn document	images.	The	information	calculated by
*  this	method is stored in	the	class instance and can be accessed via
*
* \sa objectInfoClass::getNormLineHeightVar
*	  objectInfoClass::getNormLineWidthVar
*	  objectInfoClass::getNormLineLeftIndentVar
*	  objectInfoClass::getNormLineRightIndentVar
*/



void objectInfoClass::computeLineStatistics( DLlineInfo	*textLines,	int	long_line_count)
{
	
	int	i;
	double mean;
	double stddev;
	double *data_array;

	_peakValue = 0;
	/* compute left	indent var */

	double val = textLines[0].loc[2].x;
	tbStructureComputeMeanStddev(&val, long_line_count,
		sizeof(DLlineInfo),	&mean, &stddev);

	_normLineLeftIndentVar = stddev/mean;

	/* compute right indent	var	*/

	val = textLines[0].loc[3].x;
	tbStructureComputeMeanStddev(&val, long_line_count,
		sizeof(DLlineInfo),	&mean, &stddev);

	_normLineRightIndentVar	= stddev/mean;

	/* compute line	width var */

	data_array = (double	*) calloc(long_line_count,sizeof(int));
	for	(i = 0;i < long_line_count;i++)
		data_array[i]=(float) (textLines[i].loc[3].x - textLines[i].loc[2].x);

	tbStructureComputeMeanStddev	(data_array, long_line_count,sizeof(double),
		&mean, &stddev);

	_normLineWidthVar =	mean/stddev;


	/* compute line	height var */

	for	(i = 0;i < long_line_count;i++)
		/* lower extent	value is negative to subtract to
		make sure the height is	positive */

		data_array[i]=(double) (textLines[i].upperExt	-
		textLines[i].lowerExt);

	tbStructureComputeMeanStddev	(data_array, long_line_count,sizeof(double),
	&mean, &stddev);

	_avgLineHeight = mean;
	_normLineHeightVar = mean/stddev;

	if (data_array != NULL)
		free(data_array);
}

/****************************************************************/

void objectInfoClass::find_first_peak(double *input_array,int length,
									  int offset, int *location)
{

	int	i;
	double max;

	max	= 0;
	for	(i = offset; i < length;i++)
	{
		if (input_array[i] > max)
		{
			max	= input_array[i];
			*location =	i;
		}
	}
}


/*-------------------------------------------------------------------*/
/**	\fn	void objectInfoClass::getSkewRotationCorrectedImageData(char *fname,float *skew, int rotation,unsigned char	**ptr, int *new_height,	int	*new_width)
This method	creates	a deskewed,rotated version of the 
image pixel	data The skew angle	and
page rotation are passed in	and	are	used to	decide how much	
the	image needs	to be rotated.
**/

/*
void objectInfoClass::getSkewRotationCorrectedImageData(char *fname,
float *skew, int rotation,unsigned char	**ptr, int *new_height,	int	*new_width)
{
int	iNewRow, iNewCol;
unsigned char *output_image_data;
float rotation_angle;
int	local_height;
int	local_width;


if (rotation ==	0)
rotation_angle = *skew;
else if	(rotation == 1)	
rotation_angle = 3.1417*1.5	+ *skew;
else if	(rotation == 2)	
rotation_angle = 3.1417	+ *skew;
else if	(rotation == 3)	
rotation_angle = 3.1417*0.5	+ *skew;

if (_grayPixelData != NULL)
{
/* grayscale pixel data	has	not	been deskewed.	Do this
and	take into account the script id	rotation 

/* grayscale version of	images is available, deskew	it
and	write it out 

tbRotate8BitArray(_grayPixelData,_originalWidth, _originalHeight,
rotation_angle,	new_height,	new_width,	*ptr,
5) ;

}
else
if (_pixelData != NULL)
{
tbRotate8BitArray(_pixelData,_originalWidth, _originalHeight,
rotation_angle,	new_height,	new_width,	*ptr,
5) ;
}
}
}
*/
int objectInfoClass::tbComputeDCT(double *input, int winsize, double **dct_array)
{
  double          dct_sum, cos_val, cooef, angle;
  unsigned char   bval;
  int             x, u;


  *dct_array = (double *) malloc(winsize * sizeof(double));

  for (u = 0; u < winsize; u++)
  {
    dct_sum = 0.0;
    for (x = 0; x < winsize; x++)
    {
      bval = *(input + x);
      if (bval != 0)
      {
	cooef = ((2 * x + 1) * u);
	angle = ((double) cooef) * 1.570796326 / ((double) winsize);
	cos_val = (double) cos(angle);
	dct_sum += ((double) bval) * cos_val;
      }
    }				/* for x */
    (*dct_array)[u] = dct_sum;
  }				/* for u */

  return (1);
}


void objectInfoClass::tbStructureComputeMeanStddev(double *values, int value_count,
			int separation,
			 double *mean,
			 double *stddev) 
{
  int i;
  double sum;
  double f_val;
	double *value_ptr;
	char *char_ptr;

value_ptr = values;
char_ptr = (char *) value_ptr;
sum = 0;
for (i=0;i<value_count;i++) 
{
	sum = sum + *value_ptr;
	char_ptr = char_ptr + separation;
	value_ptr = (double *) char_ptr;
}
*mean = sum/value_count;


value_ptr = values;
char_ptr = (char *) value_ptr;
sum = 0;
for (i=0;i<value_count;i++) 
{
	f_val = *value_ptr - *mean;
	sum = sum + (f_val*f_val);
	char_ptr = char_ptr + separation;
	value_ptr = (double *) char_ptr;
}
*stddev = (float) sqrt( (double)(sum/(float) value_count));
}


void tbComputeMeanStddev(double *values, int value_count,
			 double *mean,
			 double *stddev) {
  int i;
  double sum;
  double f_val;
  
  sum = 0;
  for (i=0;i<value_count;i++) {
    sum = sum + values[i];
  }
  *mean = sum/value_count;
  sum = 0;
  for (i=0;i<value_count;i++) {
    f_val = values[i] - *mean;
    sum = sum + (f_val*f_val);
  }
  *stddev = (float) sqrt( (double)(sum/(float) value_count));
}

