
#include <cstdio>
#include <iostream.h>
#include <fstream.h>
#include <fstream>
#include <string>
#include <cstring>
#include <string.h>
#include <vector>
#include <algorithm>
#include <objectPairClass.h>
#include <stdlib.h>

#define CALLOC_BLOCK_SIZE 20000
#define DOCLIST_INIT  500
#define AREA_MATCH_THRESHOLD  .1
#define AREA_MATCH_THRESHOLD_PIXEL_AREA  .1
#define POLY_MATCH_THRESHOLD  .5
#define LINE_MATCH_THRESHOLD_PERCENT  .1

/* 50 pixels equates to about 1/4 inch */

#define LINE_MATCH_THRESHOLD_PIXEL_DISTANCE 50



/***************************************************/
objectPairClass::~objectPairClass()
{

	int i;

	if (_objectPairs != NULL)
	{
		free(_objectPairs);
		_objectPairs = NULL;
	}
}
/***************************************************/

void objectPairClass::scoreImage(objectPairClass *objectPairs,
	float *score,int storeScoreFlag)
{
int i,j,k;
int cnt;
int best_fit_count;
float best_fit_score;
int near_count;
int result;
int best_fit_index;

/* foreach object on the image find the best matching 
object pair (if there is a match ).  Increment cummulative
score by teh score of hte best match */


*score = 0.0;

cnt = objectPairs->getPairCount();
objectPairInfo *pairs = objectPairs->getPairs();

for (i = 0; i < cnt; i++)
{
	best_fit_score = 0;
	for (j=0;j < _numPairsAfterPrune; j++)
	{
  result = matches(&pairs[i],
   &_objectPairs[j]);
		if ((result > 0) && 
				(_objectPairs[j].score > best_fit_score))
		{
			best_fit_score = _objectPairs[j].score;
			best_fit_index = j;
		}
	}
	if (storeScoreFlag > 0)
	{
		pairs[i].score = best_fit_score;
		/*	fprintf(fp,"pair: %d score: %f \n",best_fit_index, best_fit_score); */
	}
	*score = *score + best_fit_score;
}

}

objectPairInfo *other_struct;
/***************************************************/

void objectPairClass::dumpHighScoringObjects(struct objectInfo *obj1,
	float *threshold)
{
FILE *fp;
int i;

fp = fopen("tmpscore.dat","w");
for (i=0;i<_numPairs;i++)
{
	if (_objectPairs[i].score >= *threshold)
	{
		printf("dumping to tmpscore threshold: %f pair: %d score: %f\n",
			*threshold, i, _objectPairs[i].score );
		fprintf(fp,"%d \n",_objectPairs[i].object1);
		fprintf(fp,"%d \n",_objectPairs[i].object2);
		obj1[_objectPairs[i].object1].occuranceCount =
			obj1[_objectPairs[i].object1].occuranceCount+1;
		obj1[_objectPairs[i].object2].occuranceCount =
			obj1[_objectPairs[i].object2].occuranceCount+1;
	}
}
fclose(fp);

}
/***************************************************/

void objectPairClass::assignScore(objectPairClass *otherClass)
{
int i,j,k;
int other_cnt;
int near_count;
int result;

objectPairInfo *other_struct;

other_struct = otherClass->getPairs();
other_cnt = otherClass->getPairCount();

for (i=0;i<_numPairs;i++)
{
	if (( i > 54) && (i < 59))
		k = 1;

	near_count = 0;
	for (j=0;j<other_cnt;j++)
	{
		result = matches(&_objectPairs[i],
			&other_struct[j]);
		if (result > 0)
		{
			near_count = near_count + other_struct[j].totalInstanceCount;
		}
	}
	if (near_count > 0)
		_objectPairs[i].score = (float) (_objectPairs[i].totalInstanceCount)/
			((float) _objectPairs[i].totalInstanceCount + (float) near_count);
	else
		_objectPairs[i].score = 1.0;
	printf("pair: %d score: %f count: %d near_count: %d\n",i ,_objectPairs[i].score,
		_objectPairs[i].totalInstanceCount,near_count);

}

}
/***************************************************/

objectPairClass::objectPairClass(FILE *coref_file)
{
int i;

_frequencyPrunedLevel = 0;
_coref_file = coref_file;
_numPairs = 0;
_availableEntries = CALLOC_BLOCK_SIZE;
_objectPairs = 
		(objectPairInfo *) calloc 
			( CALLOC_BLOCK_SIZE, sizeof(objectPairInfo));

/* initialize list of documents containing pair */

for (i=0;i<CALLOC_BLOCK_SIZE;i++)
{
	_objectPairs[i].docsCount = 0;
}
_numPairsAfterPrune = 0;

}


/**********************************************/
void objectPairClass::readDataWithScores(FILE *fp)
{

int i;
int result;
polyMatchClass pm;

_frequencyPrunedLevel = 0;
i = 0;
result = fscanf(fp,"%*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s  %*s  %*s  %*s ");
while (result == 0)
{
 i++;
 result = fscanf(fp,"%*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s ");
}

fseek(fp,0,SEEK_SET);

_numPairs = i;
_objectPairs =
  (objectPairInfo *) calloc
   ( _numPairs, sizeof(objectPairInfo));

/* initialize list of documents containing pair */

for (i=0;i<_numPairs;i++)
{
 result = fscanf(fp,"%*s %*s %*s %d %*s %d %*s %d %*s %f %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %f %*s %s %*s %s %*s %d %*s %d",
  &_objectPairs[i].type1,
  &_objectPairs[i].type2,
  &_objectPairs[i].crossing,
  &_objectPairs[i].area,
  &_objectPairs[i].pageInstanceCount,
  &_objectPairs[i].totalInstanceCount,
  &_objectPairs[i].docsCount,
  &_objectPairs[i].vertices[0].x,
  &_objectPairs[i].vertices[0].y,
  &_objectPairs[i].vertices[1].x,
  &_objectPairs[i].vertices[1].y,
  &_objectPairs[i].vertices[2].x,
  &_objectPairs[i].vertices[2].y,
  &_objectPairs[i].vertices[3].x,
  &_objectPairs[i].vertices[3].y,
  &_objectPairs[i].score,
		_objectPairs[i].obj1_qualifier,
		_objectPairs[i].obj2_qualifier,
		&_objectPairs[i].obj1_int_qualifier,
		&_objectPairs[i].obj2_int_qualifier);

  /* store turning representation to speed up later matching */
  pm.poly_to_turn_rep(_objectPairs[i].vertices,4,
   &_objectPairs[i].t);
}
}




/***************************************************/

objectPairClass::objectPairClass(char *pair_data_file,
	FILE *coref_file)
{
int i,k;
int result;
FILE *fp;
polyMatchClass pm;
char string_val[200];

_availableEntries = 0;
_frequencyPrunedLevel = 0;
_coref_file = coref_file;
fp = fopen(pair_data_file,"r");
result = fscanf(fp,"%*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %s %*s %*s %*s %*s %*s %*s %*s",
string_val); 

if (strcmp(string_val,"score:") == 0)
{
	fseek(fp,0,SEEK_SET);
	readDataWithScores(fp);
}
else
{
i = 0;
	fseek(fp,0,SEEK_SET);
	result = fscanf(fp,"%*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s"); 
while (result == 0)
{
	i++;
	result = fscanf(fp,"%*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s %*s"); 
}
	
fseek(fp,0,SEEK_SET);

_numPairs = i;
_objectPairs = 
		(objectPairInfo *) calloc 
			( _numPairs, sizeof(objectPairInfo));

/* initialize list of documents containing pair */

for (i=0;i<_numPairs;i++)
{
/*
	result = fscanf(fp,"%*s %*s %*s %d %*s %d %*s %d %*s %f %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %s %*s %s %*s %d %*s %d",
		&_objectPairs[i].type1,
		&_objectPairs[i].type2,
		&_objectPairs[i].crossing,
		&_objectPairs[i].area,
		&_objectPairs[i].pageInstanceCount,
		&_objectPairs[i].totalInstanceCount,
		&_objectPairs[i].docsCount,
		&_objectPairs[i].vertices[0].x,
		&_objectPairs[i].vertices[0].y,
		&_objectPairs[i].vertices[1].x,
		&_objectPairs[i].vertices[1].y,
		&_objectPairs[i].vertices[2].x,
		&_objectPairs[i].vertices[2].y,
		&_objectPairs[i].vertices[3].x,
		&_objectPairs[i].vertices[3].y,
		_objectPairs[i].obj1_qualifier,
		_objectPairs[i].obj2_qualifier,
		&_objectPairs[i].obj1_int_qualifier,
		&_objectPairs[i].obj2_int_qualifier);
*/

	result = fscanf(fp,"%*s %*s %*s %d %*s %d %*s %d %*s %f %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %d %*s %s %*s %s %*s %d %*s %d",
		&_objectPairs[i].type1,
		&_objectPairs[i].type2,
		&_objectPairs[i].crossing,
		&_objectPairs[i].area,
		&_objectPairs[i].pageInstanceCount,
		&_objectPairs[i].totalInstanceCount,
		&_objectPairs[i].docsCount,
		&_objectPairs[i].vertices[0].x,
		&_objectPairs[i].vertices[0].y,
		&_objectPairs[i].vertices[1].x,
		&_objectPairs[i].vertices[1].y,
		&_objectPairs[i].vertices[2].x,
		&_objectPairs[i].vertices[2].y,
		&_objectPairs[i].vertices[3].x,
		&_objectPairs[i].vertices[3].y,
		_objectPairs[i].obj1_qualifier,
		_objectPairs[i].obj2_qualifier,
		&_objectPairs[i].obj1_int_qualifier,
		&_objectPairs[i].obj2_int_qualifier);

		/* store turning representation to speed up later matching */

		if (_objectPairs[i].totalInstanceCount == 0)
			k = 1;
		pm.poly_to_turn_rep(_objectPairs[i].vertices,4,
			&_objectPairs[i].t);
}
}
fclose(fp);
_numPairsAfterPrune  = _numPairs;
}


/***************************************************/
objectPairClass::objectPairClass(struct objectInfo *obj1,
	int object_count, int documentId, FILE *coref_file)
{
int k;
int index,i,j;
polyMatchClass pm;

/* this class creates an array of object pair structures
based on the objects received as a parameter */


_frequencyPrunedLevel = 0;
_coref_file = coref_file;

/* number of object pairs = (n*(n-1)! + 1)  */


if (object_count < 1)
	_numPairs = 0;
else
	_numPairs = object_count*(object_count-1)/2;

_numPairsAfterPrune = _numPairs;
int cnt;
cnt = _numPairs;
_availableEntries = 0;
/*
if (_numPairs > CALLOC_BLOCK_SIZE)
{
	_availableEntries = 0;
}
else
{
	cnt = CALLOC_BLOCK_SIZE;
	_availableEntries = CALLOC_BLOCK_SIZE-_numPairs;
}
*/
_objectPairs = (objectPairInfo *) calloc
		(cnt, sizeof(objectPairInfo));

/* initialize list of documents containing pair */

for (i=0;i<cnt;i++)
{

	/* initialized document entries for those
	entries which will be used at this time */

	if (i < _numPairs)
	{
		_objectPairs[i].docsCount = 1;
	}
}




index=0;
for (i=0;i<=object_count-2;i++)
{
	for (j=i+1;j<=object_count-1;j++)
	{


		/* store info in pairs structure */


		_objectPairs[index].type1 = obj1[i].type;
		sprintf(_objectPairs[index].obj1_qualifier,"%s",
			obj1[i].qualifier);
		_objectPairs[index].type2 = obj1[j].type;
		sprintf(_objectPairs[index].obj2_qualifier,"%s",
			obj1[j].qualifier);

		_objectPairs[index].obj1_int_qualifier = 
				obj1[i].int_qualifier;
		_objectPairs[index].obj2_int_qualifier = 
				obj1[j].int_qualifier;

		_objectPairs[index].object1 = i;
		_objectPairs[index].object2 = j;
		_objectPairs[index].pageInstanceCount = 1;
		_objectPairs[index].totalInstanceCount = 1;

		_objectPairs[index].vertices[0].x =
					obj1[i].location[0].x;
		_objectPairs[index].vertices[0].y =
					obj1[i].location[0].y;
		_objectPairs[index].vertices[1].x =
					obj1[i].location[1].x;
		_objectPairs[index].vertices[1].y =
					obj1[i].location[1].y;

		_objectPairs[index].vertices[2].x =
					obj1[j].location[0].x;
		_objectPairs[index].vertices[2].y =
					obj1[j].location[0].y;
		_objectPairs[index].vertices[3].x =
					obj1[j].location[1].x;
		_objectPairs[index].vertices[3].y =
					obj1[j].location[1].y;


		/* create a vector of the 4 points defining 
			the 2 objects */

		vector<pointLocation> pvector(4);
		pvector[0] =  _objectPairs[index].vertices[0];
		pvector[1] =  _objectPairs[index].vertices[1];
		pvector[2] =  _objectPairs[index].vertices[2];
		pvector[3] =  _objectPairs[index].vertices[3];
		polyClass *poly = new polyClass(pvector);
		_objectPairs[index].crossing = poly->linesIntersect();
		if (_objectPairs[index].crossing >= 0)
		{
			_objectPairs[index].area = poly->getArea();
		}
		else
		{
			_objectPairs[index].area = 0;
		}
		delete poly;

		/* store turning representation to speed up later matching */

		pm.poly_to_turn_rep(_objectPairs[index].vertices,4,
			&_objectPairs[index].t);

		index++;
	}
}

prune();


} /* create method */

/************************************************************/

void objectPairClass::printInfoSummary(char *filename)
{
	int i;
	FILE *fp;

if (filename == NULL)
	printf("_numPairsAfterPrune: %d availableEntries: %d numPairs: %d afterPrune: %d\n",_numPairsAfterPrune,
	_availableEntries,_numPairs,  _numPairsAfterPrune);
else
{
	fp = fopen (filename,"w+");
	fprintf(fp, "_numPairsAfterPrune: %d availableEntries: %d numPairs: %d afterPrune: %d\n",_numPairsAfterPrune,
	_availableEntries,_numPairs,  _numPairsAfterPrune);
	fclose (fp);
}
}
/************************************************/
void objectPairClass::printScoreInfo(char *filename)
{
	int i,k;
	FILE *fp;

if (filename == NULL)
for (i=0;i<_numPairsAfterPrune;i++)
{
		printf("pair: %d type1: %d type2: %d  crossing: %d area: %f pageInst: %d  totalInst: %d docCount: %dv1x: %d v1y: %d v2x: %d v2y: %d v3x: %d v3y: %d v4x: %d v4y: %d score: %f qual1: %s qual2: %s intqual1: %d intqual2: %d\n",
		i,
		_objectPairs[i].type1,
		_objectPairs[i].type2,
		_objectPairs[i].crossing,
		_objectPairs[i].area,	
		_objectPairs[i].pageInstanceCount,
		_objectPairs[i].totalInstanceCount,
		_objectPairs[i].docsCount,
		_objectPairs[i].vertices[0].x,
		_objectPairs[i].vertices[0].y,
		_objectPairs[i].vertices[1].x,
		_objectPairs[i].vertices[1].y,
		_objectPairs[i].vertices[2].x,
		_objectPairs[i].vertices[2].y,
		_objectPairs[i].vertices[3].x,
		_objectPairs[i].vertices[3].y,
		_objectPairs[i].score,
		_objectPairs[i].obj1_qualifier,
		_objectPairs[i].obj2_qualifier,
		_objectPairs[i].obj1_int_qualifier,
		_objectPairs[i].obj2_int_qualifier);
}
else
{
fp = fopen (filename,"w+");
for (i=0;i<_numPairsAfterPrune;i++)
{
	fprintf(fp,"pair: %d type1: %d type2: %d  crossing: %d area: %f pageInst: %d  totalInst: %d docCount: %d v1x: %d v1y: %d v2x: %d v2y: %d v3x: %d v3y: %d v4x: %d v4y: %d score: %f qual1: %s qual2: %s intqual1: %d intqual2: %d\n",
		i,
		_objectPairs[i].type1,
		_objectPairs[i].type2,
		_objectPairs[i].crossing,
		_objectPairs[i].area,	
		_objectPairs[i].pageInstanceCount,
		_objectPairs[i].totalInstanceCount,
		_objectPairs[i].docsCount,
		_objectPairs[i].vertices[0].x,
		_objectPairs[i].vertices[0].y,
		_objectPairs[i].vertices[1].x,
		_objectPairs[i].vertices[1].y,
		_objectPairs[i].vertices[2].x,
		_objectPairs[i].vertices[2].y,
		_objectPairs[i].vertices[3].x,
		_objectPairs[i].vertices[3].y,
		_objectPairs[i].score,
		_objectPairs[i].obj1_qualifier,
		_objectPairs[i].obj2_qualifier,
		_objectPairs[i].obj1_int_qualifier,
		_objectPairs[i].obj2_int_qualifier);
}
fclose(fp);
}
}
/************************************************************/


/************************************************************/

void objectPairClass::printInfo(char *filename)
{

	/* the printInfo and printScoreInfo routines are virtually identical
	except the printScoreInfo includes the score field in the 
	output */


	int i,k;
	FILE *fp;

if (filename == NULL)
for (i=0;i<_numPairsAfterPrune;i++)
{
		printf("pair: %d type1: %d type2: %d  crossing: %d area: %f pageInst: %d  totalInst: %d docCount: %dv1x: %d v1y: %d v2x: %d v2y: %d v3x: %d v3y: %d v4x: %d v4y: %d qual1: %s qual2: %s intqual1: %d intqual2: %d\n",
		i,
		_objectPairs[i].type1,
		_objectPairs[i].type2,
		_objectPairs[i].crossing,
		_objectPairs[i].area,	
		_objectPairs[i].pageInstanceCount,
		_objectPairs[i].totalInstanceCount,
		_objectPairs[i].docsCount,
		_objectPairs[i].vertices[0].x,
		_objectPairs[i].vertices[0].y,
		_objectPairs[i].vertices[1].x,
		_objectPairs[i].vertices[1].y,
		_objectPairs[i].vertices[2].x,
		_objectPairs[i].vertices[2].y,
		_objectPairs[i].vertices[3].x,
		_objectPairs[i].vertices[3].y,
		_objectPairs[i].obj1_qualifier,
		_objectPairs[i].obj2_qualifier,
		_objectPairs[i].obj1_int_qualifier,
		_objectPairs[i].obj2_int_qualifier);
}
else
{
fp = fopen (filename,"w+");
for (i=0;i<_numPairsAfterPrune;i++)
{
	/* fprintf(fp */
	fprintf(fp,"pair: %d type1: %d type2: %d  crossing: %d area: %f pageInst: %d  totalInst: %d docCount: %d v1x: %d v1y: %d v2x: %d v2y: %d v3x: %d v3y: %d v4x: %d v4y: %d qual1: %s qual2: %s intqual1: %d intqual2: %d \n",
		i,
		_objectPairs[i].type1,
		_objectPairs[i].type2,
		_objectPairs[i].crossing,
		_objectPairs[i].area,	
		_objectPairs[i].pageInstanceCount,
		_objectPairs[i].totalInstanceCount,
		_objectPairs[i].docsCount,
		_objectPairs[i].vertices[0].x,
		_objectPairs[i].vertices[0].y,
		_objectPairs[i].vertices[1].x,
		_objectPairs[i].vertices[1].y,
		_objectPairs[i].vertices[2].x,
		_objectPairs[i].vertices[2].y,
		_objectPairs[i].vertices[3].x,
		_objectPairs[i].vertices[3].y,
		_objectPairs[i].obj1_qualifier,
		_objectPairs[i].obj2_qualifier,
		_objectPairs[i].obj1_int_qualifier,
		_objectPairs[i].obj2_int_qualifier);
}
fclose(fp);
}
}
/************************************************************/

void objectPairClass::printVertices()
{
	int i;
	int j;

for (i=0;i<_numPairs;i++)
{
	for(j=0;j<4;j++)
	{
		printf("%d %d \n",
		_objectPairs[i].vertices[j].x,
		_objectPairs[i].vertices[j].y);
	}
	printf("\n");
}
}



/************************************************************/
int objectPairClass::matches(objectPairInfo *pair1,
		objectPairInfo *pair2)
{
	float delta_area;
	float percent_dif;
	double score;
	polyMatchClass pm;
	pointLocation *pt1;
	pointLocation *pt2;
	pointLocation *pt3;
	pointLocation *pt4;
	int i;
	float length1,length2;


	/* if objects pairs don't have area it is only necessary for
	the types to agree and, if either object has point
	identifiers the length of the segment connecting must be
	within a threshold 

	Right now this is coded to assume they don't match*/

	/* make sure types, string, and integer qualifiers agree */

	/* the only integer qualifiler used right now is the line
	height.  It has to match within 5 pixels. */

	i = abs(10-5);
	if (((pair1->type1 == pair2->type1) &&
		(pair1->type2 == pair2->type2) &&
		(strcmp(pair1->obj1_qualifier,pair2->obj1_qualifier) == 0) &&
		(strcmp(pair1->obj2_qualifier,pair2->obj2_qualifier) == 0) &&
		(abs(pair1->obj1_int_qualifier - pair2->obj1_int_qualifier) <= 5) &&
		(abs(pair1->obj2_int_qualifier - pair2->obj2_int_qualifier) <= 5)) ||
	((pair1->type1 == pair2->type2) &&
	(pair1->type2 == pair2->type1)  &&
		(strcmp(pair1->obj1_qualifier,pair2->obj2_qualifier) == 0) &&
		(strcmp(pair1->obj2_qualifier,pair2->obj1_qualifier) == 0) &&
		(abs(pair1->obj1_int_qualifier - pair2->obj1_int_qualifier) <= 5) &&
		(abs(pair1->obj2_int_qualifier - pair2->obj2_int_qualifier) <= 5)  ) )
	{


	/* one of the items has no length */

	if ((pair1->area <= 0) || (pair2->area<=0 ))
	{

		/* see if there is a line segment present */

			pt1 = NULL;
			pt2 = NULL;
			for (i=0;i<4;i++)
			{
				if (pair1->vertices[i].x >= 0)
				{
					if (pt1 == NULL)
						pt1 = &pair1->vertices[i];
					else 
						pt2 = &pair1->vertices[i];
				}
			}

			pt3 = NULL;
			pt4 = NULL;
			for (i=0;i<4;i++)
			{
				if (pair2->vertices[i].x > 0)
				{
					if (pt3 == NULL)
						pt3 = &pair2->vertices[i];
					else 
						pt4 = &pair2->vertices[i];
				}
			}

			/* if any of the points are null the compare can't
			be done  assume a match */

			if ((pt1 == NULL) || (pt2 == NULL) ||(pt3 == NULL) ||
				(pt4 == NULL))
				return (1);
			length1 = (float) (pt1->x - pt2->x)*(pt1->x - pt2->x) +
						(pt1->y - pt2->y)*(pt1->y - pt2->y) ;
			length2 = (float) (pt3->x - pt4->x)*(pt3->x - pt4->x) +
						(pt3->y - pt4->y)*(pt3->y - pt4->y) ;

			if (pt1 == NULL)
			/* match if length is withing threshold
			percentage  This needs to be modified to take into account
			absolute differences*/	
			if (length1 > length2)
			{
				delta_area = length1-length2;
				percent_dif = (float) delta_area/(float) length1;
			}
			else
			{
				delta_area = length2-length1;
				percent_dif = (float) delta_area/(float) length2;
			}
			if (delta_area >  LINE_MATCH_THRESHOLD_PIXEL_DISTANCE)
				return(-1);
			else return (1);
		}

	/* objects are declared a match if the shapes match and
	the difference in area is less then AREA_MATCH_THRESHOLD
	percent of the larger of the areas */



	/* if objects match in type, area, and in shape return 
		a true value */

	if (pair1->area > pair2->area)
	{
		delta_area = pair1->area - pair2->area;
		percent_dif = (float) delta_area/(float) pair1->area;
	}
	else
	{
		delta_area = pair2->area - pair1->area;
		percent_dif = (float) delta_area/(float) pair2->area;
	}

	/* don't bother with the shape match if the areas
		are too different */

	/* tbd add code to use the larger of the areas as a basis */

/*
	if ((pair1->area > pair2->area_lower_thresh) &&
		(pair1->area < pair2->area_upper_thresh) &&
*/
		if (percent_dif < AREA_MATCH_THRESHOLD)
	{
		score = pm.matchPoly(&pair1->t,
         &pair2->t, 4);
		if (score < POLY_MATCH_THRESHOLD)
			return(1);
		else 
			return(-1);

	}
	else
		return(-1);

	}
	else 
	{
		/* objects have no area */

		return (-1);
	}
}
/************************************************************/
void objectPairClass::merge(objectPairClass *mergeData,int document_number)
{
int i,j,k;
int ii;
int kk;
int result;
int index,index1;
int merged;
polyMatchClass pm;
int found;
int new_count;
int match_index;

int source_count = mergeData->getPairCount();
new_count = 0;
objectPairInfo *sourceDataStruct=mergeData->getPairs();
if (_numPairsAfterPrune > 0)
	index = _numPairsAfterPrune;
else
	index = 0;

for (i=0;i<_numPairsAfterPrune;i++)
	_objectPairs[i].tag = 0;

for (i = 0;i<source_count; i++)
{
	/* see if entry can be merged into an
		existing entry */

	merged = 0;
	for (j = 0;j<_numPairsAfterPrune;j++)
	{
		result  = matches(&_objectPairs[j],
			&sourceDataStruct[i]);
		if (result > 0)
		{ /* add to this entry */


			/* 
			tagging type1 as null will signify
			to the destruction instance that he 
			space for the documentIdList can be 
			freed 
			*/

			merged = 1;
			match_index = j;
			_objectPairs[j].totalInstanceCount =
				_objectPairs[j].totalInstanceCount +
				sourceDataStruct[i].pageInstanceCount;

			fprintf(_coref_file,"%d %d\n",
				j,document_number);
			j = _numPairsAfterPrune; /* drop out of loop */
		}
		
	}
	if (merged == 1)
	{ /* up the count of documents this relationship occured on */
			if (_objectPairs[match_index].tag == 0)
			_objectPairs[match_index].docsCount = 
				_objectPairs[match_index].docsCount + 1;
			
			/* set tag to prevent multiple increments */

			_objectPairs[match_index].tag = 1;
	}

	/* if this entry was not merged create a new entry */

	if (merged == 0)
	{	
		if (_availableEntries == 0)
		{
			/* out of room; allocate space for another block
			of entries */

				_availableEntries = CALLOC_BLOCK_SIZE;
				_objectPairs = 
				(objectPairInfo *) realloc (_objectPairs,
				 (CALLOC_BLOCK_SIZE + _numPairsAfterPrune 
					+ new_count)*
					sizeof(objectPairInfo));

		}
		fprintf(_coref_file,"%d %d\n", index,
			document_number);
		new_count = new_count + 1;
		_availableEntries = _availableEntries-1;
		memcpy(&_objectPairs[index],
			&sourceDataStruct[i],sizeof(sourceDataStruct[i]));

		index = index+1;
	}
}
_numPairsAfterPrune  = _numPairsAfterPrune + new_count;
}

/************************************************************/
void objectPairClass::frequencyBasedPrune(int threshold,FILE *coref_file)
{
int i,j,pruned_count;
int result;
int index;
objectPairInfo tmpPair;


/* this method is used when doing scoring based on the 
polygon frequency of occurance */
/*
  It prunes the object pair list down to only those
pairs whose occurance count is greater then a threshold.  This will
allow the scoring to run much faster 

At this point pruning occurs on the first 1/2 of the polygons 
created since the last pruning */


int cnt = _numPairsAfterPrune - 
	_frequencyPrunedLevel;

cnt = cnt/2;

pruned_count = 0;

cout << "Frequency Based Prune " << "Threshold: " << threshold << endl;
cout << "numPairs before: " << _numPairsAfterPrune << endl;
/* tag all pairs with scores below the threshold for
deletion */

int upper_limit = _frequencyPrunedLevel+ cnt;
cout << "_frequencyPrunedLevel: " << _frequencyPrunedLevel <<
	" cnt: " << cnt << "  upper_limit: " << upper_limit << endl;
for (i=_frequencyPrunedLevel;i<=upper_limit;i++)
{
	if (_objectPairs[i].totalInstanceCount <= threshold)
	{
/*		cout << "pruning: " << i << endl; */
			_objectPairs[i].type1 = nullObject;
			pruned_count++;
	}
}

/* now collapse the entries to that less space is used */

index = 0;
for (i=0;i<_numPairsAfterPrune;i++)
{
	if (i == upper_limit)
			_frequencyPrunedLevel = index;
	if (_objectPairs[i].type1 != nullObject)
	{

		if (coref_file != NULL)
			fprintf(coref_file,"oldPolyNumb: %d  newPolyNumb: %d\n",
			i,index); 

		/* copy to next index */

			if (i != index)
			{

				/* make sure not to overwrite entries and swap
				correctly since each entry has space allocated
				for a document occurance list */

/*
				memcpy(&tmpPair,&_objectPairs[index],
					sizeof(objectPairInfo));
*/
		
				memcpy(&_objectPairs[index], 
				&_objectPairs[i],sizeof(objectPairInfo));

/*
				memcpy(&_objectPairs[i],
					&tmpPair,
					sizeof(objectPairInfo));
				_objectPairs[index].totalInstanceCount = 
					_objectPairs[index].pageInstanceCount;
*/
			}
			index++;
	}
	else
	{
		if (coref_file != NULL)
		fprintf(coref_file,"deletedPoly: %d\n",i);
	}
}
/*_frequencyPrunedLevel = upper_limit; */
_numPairsAfterPrune = index;
_availableEntries = _availableEntries + pruned_count;
cout << "numPairs afteR: " << _numPairsAfterPrune << endl;

}


/************************************************************/
void objectPairClass::frequencyBasedPruneForScoring(int threshold)
{
int i,j,pruned_count;
int result;
int index;
objectPairInfo tmpPair;


/* this method is used when doing scoring based on the 
polygon frequency of occurance */
/*
  It prunes the object pair list down to only those
pairs whose occurance count is greater then a threshold.  This will
allow the scoring to run much faster 

At this point pruning occurs on the first 1/2 of the polygons 
created since the last pruning */



pruned_count = 0;

cout << "Frequency Based Prune " << "Threshold: " << threshold << endl;
cout << "numPairs before: " << _numPairsAfterPrune << endl;
/* tag all pairs with scores below the threshold for
deletion */

int upper_limit = _numPairsAfterPrune;
cout << "_frequencyPrunedLevel: " << _frequencyPrunedLevel <<
	"  upper_limit: " << upper_limit << endl;
for (i=_frequencyPrunedLevel;i<=upper_limit;i++)
{
	if (_objectPairs[i].totalInstanceCount <= threshold)
	{
/*		cout << "pruning: " << i << endl; */
			_objectPairs[i].type1 = nullObject;
			pruned_count++;
	}
}

/* now collapse the entries to that less space is used */

index = 0;
for (i=0;i<_numPairsAfterPrune;i++)
{
	if (i == upper_limit)
			_frequencyPrunedLevel = index;
	if (_objectPairs[i].type1 != nullObject)
	{


		/* copy to next index */

			if (i != index)
			{

				/* make sure not to overwrite entries and swap
				correctly since each entry has space allocated
				for a document occurance list */

/*
				memcpy(&tmpPair,&_objectPairs[index],
					sizeof(objectPairInfo));
*/
		
				memcpy(&_objectPairs[index], 
				&_objectPairs[i],sizeof(objectPairInfo));

/*
				memcpy(&_objectPairs[i],
					&tmpPair,
					sizeof(objectPairInfo));
				_objectPairs[index].totalInstanceCount = 
					_objectPairs[index].pageInstanceCount;
*/
			}
			index++;
	}
	else
	{
		/*
		if (coref_file != NULL)
		fprintf(coref_file,"deletedPoly: %d\n",i);
		*/
	}
}
/*_frequencyPrunedLevel = upper_limit; */
_numPairsAfterPrune = index;
_availableEntries = _availableEntries + pruned_count;
cout << "numPairs afteR: " << _numPairsAfterPrune << endl;

}






/************************************************************/
void objectPairClass::scoreBasedPrune(float *threshold)
{
int i,j,pruned_count;
int result;
int index;
objectPairInfo tmpPair;


/* this method is used when doing scoring based on object
pairs.  It prunes the object pair list down to only those
pairs whose "score" is greater then a threshold.  This will
allow the scoring to run much faster */


pruned_count = 0;
/* tag all pairs with scores below the threshold for
deletion */

for (i=0;i<_numPairsAfterPrune;i++)
{
	if (_objectPairs[i].score < *threshold)
	{

			/* if the object pairs match combine them */

			_objectPairs[i].type1 = nullObject;
	}
}

/* now collapse the entries to that less space is used */

index = 0;
for (i=0;i<_numPairsAfterPrune;i++)
{
	if (_objectPairs[i].type1 != nullObject)
	{
		/* copy to next index */

			if (i != index)
			{

				/* make sure not to overwrite entries and swap
				correctly since each entry has space allocated
				for a document occurance list */

/*
				memcpy(&tmpPair,&_objectPairs[index],
					sizeof(objectPairInfo));
*/
		
				memcpy(&_objectPairs[index], 
				&_objectPairs[i],sizeof(objectPairInfo));

/*
				memcpy(&_objectPairs[i],
					&tmpPair,
					sizeof(objectPairInfo));
				_objectPairs[index].totalInstanceCount = 
					_objectPairs[index].pageInstanceCount;
*/
			}
			index++;
	}
}
_numPairsAfterPrune = index;
_availableEntries = _availableEntries + pruned_count;

}

/************************************************************/
void objectPairClass::prune()
{
int i,j,pruned_count;
int result;
int index;
objectPairInfo tmpPair;

pruned_count = 0;

/* first combine like entries */

for (i=0;i<_numPairs-2;i++)
{
	/* skip pruned entries */
	if (_objectPairs[i].type1 != nullObject)
	for (j=i+1;j<_numPairs-1;j++)
	{

		if (_objectPairs[j].type1 != nullObject)  /* skip pruned entries */
		{
		/* if the object pairs match combine them */

		result = matches(&_objectPairs[i],&_objectPairs[j]) ;
		if (result > 0)
		{
			/* combine the second into the first and nullify
			the second entry */

			_objectPairs[i].pageInstanceCount = 
					_objectPairs[i].pageInstanceCount+1;

			_objectPairs[j].type1 = nullObject;
			pruned_count = pruned_count+1;
		}
		}
	}

}

/* now collapse the entries to that less space is used */

index = 0;
for (i=0;i<_numPairs;i++)
{
	if (_objectPairs[i].type1 != nullObject)
	{
		/* copy to next index */

			if (i != index)
			{

				/* make sure not to overwrite entries and swap
				correctly since each entry has space allocated
				for a document occurance list */

				memcpy(&tmpPair,&_objectPairs[index],
					sizeof(objectPairInfo));
		
				memcpy(&_objectPairs[index], 
				&_objectPairs[i],sizeof(objectPairInfo));

				memcpy(&_objectPairs[i],
					&tmpPair,
					sizeof(objectPairInfo));
				_objectPairs[index].totalInstanceCount = 
					_objectPairs[index].pageInstanceCount;
			}
			index++;
	}
}
_numPairsAfterPrune = _numPairs - pruned_count;

/* adjust the number of available entries */

_availableEntries = _availableEntries + pruned_count;
}
