#include <cstdio>
#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <string.h>
#include <vector>
#include <algorithm>
#include <objectPairClass.h>


#include <JScript.h>

#define SKEW_THRESH .0017



objectPairMatrix::objectPairMatrix(vector<std::string> inputVector,
                                   FILE *coref_file,char *output_directory, char *final_stats_file,JScript *scriptInfo)
{

   objectInfo *imageObjects;
   int cnt;
   char infile[FILENAME_MAX+1];
   char outfilename1[FILENAME_MAX+1];
   int index1;


   vector<std::string>::iterator index = inputVector.begin ();
   vector<std::string>::iterator end = inputVector.end ();

   /* for each file calculate the object information and then
      the object pair information */

   /* create a script id instance */
//
//	JScript *scriptInfo = new JScript("/home/lmgoleb/for_daniel/Jargon/data/language_list" );

   /* create object Pair for total training set.  It
      will initially be empty */

   objectPairClass *masterPairList = 
      new objectPairClass(coref_file);


   cnt = 0;
   while (index < end)
   { /* for each training file compute all information 
        about objects on the page */

      //cout << *index << "  " ;
      cout << "output_directory: " << output_directory << endl;
      objectInfoClass *objects = new objectInfoClass(*index,
                                                     scriptInfo,50, output_directory,0,1,0);
					
      imageObjects = objects->objectStructure();

      sprintf(infile,"%s",index->c_str());
      index1 = (int) index->rfind("/");

      if (output_directory != NULL)
      {
         /* store results for each training file in an output
            file */

         sprintf(outfilename1,"%s%s.dat",output_directory,
                 &infile[index1]);
         // objects->printObjectInfo(outfilename1);
      }
			

      /* allocate room for the object pair information 
         and create the array of data structures */


      objectPairClass *objectPairs = new objectPairClass(
         &imageObjects[0],objects->getObjectCount(),cnt,coref_file);

      objectPairs->printInfoSummary(NULL);
/*
  objectPairs->printInfo(NULL);
  objectPairs->printVertices();
*/

/*
  Outputs copy of image with lines drawn 


  cout << "filename: " << *index << endl;
  sprintf(outfilename,"%s.bmp",index->c_str ());
  outputImage *outImage = new outputImage
  (objects->getImageHeight(), 
  objects->getImageWidth(), objectPairs, outfilename);

  printf("printing output image \n");
  sprintf(outfilename,"%s.bmp",index->c_str ());
  outputImage *outImage1 = new outputImage
  (objects->getPixelData(),
  objects->getImageHeight(), 
  objects->getImageWidth(), objectPairs, outfilename);
  printf("done output image \n");
*/

      /* now merge the object pairs computed for this image
         with the master list */

      masterPairList->merge(&objectPairs[0],cnt);
      delete objectPairs;		
      printf ("master stats   ");
      masterPairList->printInfoSummary(NULL);

      /* every 501 document prune off entries in
         with low frequency */

      if ((fmod((float) cnt,(float) 200) < 1.0) && (cnt != 0) && (cnt > 500))
      {
         masterPairList->frequencyBasedPrune(1, coref_file);	
         printf ("master stats after freq prune  ");
         masterPairList->printInfoSummary(NULL);
      }
/*
  masterPairList->printInfo("interim_stats");
*/
      delete objects;		

      cnt++;	
      index++;
   } /* while  */

   printf("final status   ");
   masterPairList->printInfo(final_stats_file);
   delete scriptInfo;
   delete masterPairList;

} /* create method */





