#include <unistd.h>
#include <cstdio>
#include <iostream.h>
#include <fstream.h>
#include <fstream>
#include <string>
#include <cstring>
#include <string.h>
#include <vector>
#include <objectPairClass.h>
#include <objectInfoClass.h>
#include <outputImageClass.h>

extern "C"
{
#include <magick/api.h>
#include <magick/magick.h>
#include <magick/define.h>
}



outputImage::outputImage(unsigned long height, unsigned long width, objectPairClass *objectPairs,
                         char *filename,float *threshold)
{
   ExceptionInfo exceptions;
   DrawInfo *drawingObjects;
   unsigned char *imageData;

   imageData = (unsigned char *) calloc(3*height*width, sizeof(char));
   outputImage(imageData,height, width, objectPairs,filename,threshold);
   free(imageData);

}



outputImage::outputImage(unsigned char *imageData, unsigned long height, unsigned long width, objectPairClass *objectPairs,
                         char *filename,float *pairScoreThreshold)
{
   ExceptionInfo exceptions;
   DrawInfo *drawingObjects;
   Image *newImage;
   ImageInfo *imageInfoStruct;
   int result;
   unsigned long width1;
   PixelPacket strokeColor;
   int i;
   unsigned char *imageData1;
   unsigned long pixelCount;
   int index;
   int colorIndex;

   width1 = width;

/* RGB data */

   imageData1  = (unsigned char *) calloc(3*height*width, sizeof(char));
   pixelCount = height*width;
   for (i=1;i<=pixelCount;i++)
   {
      index=3*i-3;
      if ((imageData[i-1] == 0) || (imageData[i-1] == 255))
      {
         /* assume grey scale */

         imageData1[index] = 255 - imageData[i-1];
         imageData1[index+1] = 255 - imageData[i-1];
         imageData1[index+2] = 255 - imageData[i-1];
      }
      else
      {
         /* set color to TB color */

         /* 248 is the number of TB colormap entries */

         colorIndex = imageData[i-1];

         imageData1[index] = tbColorMap[colorIndex];
         imageData1[index+1] = tbColorMap[248 + colorIndex];
         imageData1[index+2] = tbColorMap[2*248 + colorIndex];
/*
  imageData1[index] = tbColorMap[colorIndex*3];
  imageData1[index+1] = tbColorMap[colorIndex*3+1];
  imageData1[index+2] = tbColorMap[colorIndex*3+2];
*/
      }
   }
/* create image and other needed data structures */

   imageInfoStruct = CloneImageInfo((ImageInfo *) NULL);
   GetExceptionInfo(&exceptions);
   newImage = ConstituteImage(width1, (unsigned long) height, 
                              "RGB",CharPixel, imageData1, &exceptions);
   free (imageData1);
   sprintf(newImage->filename,"%s",filename);
   printf("new iamge filename: %s\n",filename);

   SetImageInfo(imageInfoStruct,FALSE,&newImage->exception);

/* set the drawing color */
   drawingObjects = CloneDrawInfo(imageInfoStruct,NULL);

   strokeColor.red = 250;
   strokeColor.green = 0;
   strokeColor.blue= 0;
   strokeColor.opacity= 0;
   drawingObjects->stroke = strokeColor;

/* draw on image */

   objectPairInfo *object_pairs = objectPairs->getPairs();

/*  one big draw primitive  */

   int primitive_string_size = 50*objectPairs->getPairCount();
   drawingObjects->primitive = (char *) calloc(primitive_string_size
                                               ,sizeof(char));
   for (i = 0; i<objectPairs->getPairCount(); i++)
   {
      if ((object_pairs[i].type1 != nullObject) && (object_pairs[i].area > 0) 
          && (object_pairs[i].score >= *pairScoreThreshold))
      {
         printf("drawing pair: %d \n",i);
         sprintf(drawingObjects->primitive,"%s polygon %d,%d %d,%d %d,%d %d,%d \n",
                 drawingObjects->primitive,
                 object_pairs[i].vertices[0].x,
                 object_pairs[i].vertices[0].y,
                 object_pairs[i].vertices[1].x,
                 object_pairs[i].vertices[1].y,
                 object_pairs[i].vertices[3].x,
                 object_pairs[i].vertices[3].y,
                 object_pairs[i].vertices[2].x,
                 object_pairs[i].vertices[2].y);
      }
   }
   printf("about to call DrawImage \n");
   DrawImage(newImage,drawingObjects);
   printf("done calling DrawImage \n");

/*

int primitive_string_size = 50*objectPairs->getPairCount();
drawingObjects->primitive = (char *) calloc(primitive_string_size
,sizeof(char));
for (i = 0; i<objectPairs->getPairCount(); i++)
{
if ((object_pairs[i].type1 != nullObject) && (object_pairs[i].area > 0) )
{
   printf("i: %d color: %d\n",i, object_pairs[i].pageInstanceCount*40);
   strokeColor.blue = object_pairs[i].pageInstanceCount*40;
   strokeColor.green = object_pairs[i].pageInstanceCount*40;
   drawingObjects->stroke = strokeColor;
   sprintf(drawingObjects->primitive,"%s polygon %d,%d %d,%d %d,%d %d,%d \n",
           drawingObjects->primitive,
           object_pairs[i].vertices[0].x,
           object_pairs[i].vertices[0].y,
           object_pairs[i].vertices[1].x,
           object_pairs[i].vertices[1].y,
           object_pairs[i].vertices[3].x,
           object_pairs[i].vertices[3].y,
           object_pairs[i].vertices[2].x,
           object_pairs[i].vertices[2].y);
   DrawImage(newImage,drawingObjects);
}
}
*/

result =WriteImage(imageInfoStruct,newImage);

/* cleanup */

DestroyImageInfo(imageInfoStruct);
DestroyImage(newImage);
DestroyDrawInfo(drawingObjects);

;
;

} /* create method */


outputImage::outputImage(unsigned char *imageData, unsigned long height, unsigned long width, objectInfoClass *objectInfo,
                         char *filename)
{

/**** This method draws the objects (via lines) on the image ******/

/*** Currently the text lines are draw in read and all other objects are drawn i
     blue ***/


   ExceptionInfo exceptions;
   DrawInfo *drawingObjects;
   Image *newImage;
   ImageInfo *imageInfoStruct;
   int result;
   unsigned long width1;
   PixelPacket strokeColor;
   PixelPacket strokeColor1;
   int i;
   unsigned char *imageData1;
   unsigned long pixelCount;
   int index;
   int colorIndex;
   struct objectInfo *object_info;

   width1 = width;

/* RGB data */

   imageData1  = (unsigned char *) calloc(3*height*width, sizeof(char));
   pixelCount = height*width;
   for (i=1;i<=pixelCount;i++)
   {
      index=3*i-3;
      if ((imageData[i-1] == 0) || (imageData[i-1] == 255))
      {
         /* assume grey scale */

         imageData1[index] = 255 - imageData[i-1];
         imageData1[index+1] = 255 - imageData[i-1];
         imageData1[index+2] = 255 - imageData[i-1];
      }
      else
      {
         /* set color to TB color */

         /* 248 is the number of TB colormap entries */

         colorIndex = imageData[i-1];

         imageData1[index] = tbColorMap[colorIndex];
         imageData1[index+1] = tbColorMap[248 + colorIndex];
         imageData1[index+2] = tbColorMap[2*248 + colorIndex];
/*
  imageData1[index] = tbColorMap[colorIndex*3];
  imageData1[index+1] = tbColorMap[colorIndex*3+1];
  imageData1[index+2] = tbColorMap[colorIndex*3+2];
*/
      }
   }
/* create image and other needed data structures */

   imageInfoStruct = CloneImageInfo((ImageInfo *) NULL);
   GetExceptionInfo(&exceptions);
   newImage = ConstituteImage(width1, (unsigned long) height, 
                              "RGB",CharPixel, imageData1, &exceptions);
   free (imageData1);
   sprintf(newImage->filename,"%s",filename);
   printf("new iamge filename: %s\n",filename);

   SetImageInfo(imageInfoStruct,FALSE,&newImage->exception);

/* set the drawing color */
   drawingObjects = CloneDrawInfo(imageInfoStruct,NULL);

   drawingObjects->stroke_width= 3.0;
   strokeColor.red = 250;
   strokeColor.green = 0;
   strokeColor.blue= 0;
   strokeColor.opacity= 0;
   drawingObjects->stroke = strokeColor;

/* draw on image */

   object_info= objectInfo->objectStructure();

/*  one big draw primitive  */

   int primitive_string_size = 50*objectInfo->getObjectCount();
   drawingObjects->primitive = (char *) calloc(primitive_string_size
                                               ,sizeof(char));
   for (i = 0; i<objectInfo->getObjectCount(); i++)
   {
      if (object_info[i].type != nullObject) 
      {
         if (object_info[i].type == textLine)
         {
            sprintf(drawingObjects->primitive,"%s line %d,%d %d,%d \n",
                    drawingObjects->primitive,
                    object_info[i].location[0].x,
                    object_info[i].location[0].y,
                    object_info[i].location[1].x,
                    object_info[i].location[1].y);
         }
      }
   }
   DrawImage(newImage,drawingObjects);
   strokeColor.red = 0;
   strokeColor.green = 0;
   strokeColor.blue= 250;
   strokeColor.opacity= 0;
   drawingObjects->stroke = strokeColor;
   sprintf(drawingObjects->primitive,"%s"," ");
   for (i = 0; i<objectInfo->getObjectCount(); i++)
   {
      if (object_info[i].type != nullObject) 
      {
         if (object_info[i].type != textLine)
            sprintf(drawingObjects->primitive,"%s line %d,%d %d,%d \n",
                    drawingObjects->primitive,
                    object_info[i].location[0].x,
                    object_info[i].location[0].y,
                    object_info[i].location[1].x,
                    object_info[i].location[1].y);
	
      }
   }
   DrawImage(newImage,drawingObjects);

   result =WriteImage(imageInfoStruct,newImage);

/* cleanup */

   DestroyImageInfo(imageInfoStruct);
   DestroyImage(newImage);
   DestroyDrawInfo(drawingObjects);

}
