//#include <unistd.h>
#include <cstdio>
/*#include <iostream>
/*#include <iostream.h>
#include <fstream.h>
*/
#include <fstream>
#include <string>
#include <cstring>
#include <string.h>
#include <vector>
#include <polyClass.h>
#include <math.h>


struct ptInfo {
   int index;
   float angle;
};

polyClass::~polyClass()
{
   free (_polyStruct);

}

/*********************************************************/

polyClass::polyClass()
{

   /* tbd add code to orient polygon points in one direction */


   //orderVertices(_polyPoints);


} /* create method */

/*********************************************************/
polyClass::polyClass(vector<pointLocation> pts)
{

   vector<pointLocation>::iterator index = pts.begin ();
   vector<pointLocation>::iterator end = pts.end ();

/* store points in a polygon structure  - right now
   the polygons always have 4 points */

   _polyStruct= (pointLocation *) calloc(pts.size(),sizeof(pointLocation)) ;
   _polygonSideCount = pts.size();
   int i = 0;
   while (index != end)
   {
      _polyStruct[i].x = index->x;
      _polyStruct[i].y = index->y;
      i++;
      index++;
   }

   /* tbd add code to orient polygon points in one direction */


   int result = linesIntersect();
   orderVertices();

} /* create method */

/*********************************************************/
int polyClass::get_upper_area_delta()
{

/* This routine calculates threshold values for the 
   polygon area.  These thresholds will be used by the object
   pair matching algorithm to decide if a shape match is
   necessary.  If the area is outside the threshold values
   there is no reason to to the match 

   Current values reflect a quarter inch delta on the 
   "sides" of the 4 sided polygon used.
*/

   double x2,y2;
   double area_delta;
   int i;
   int index1,index2;
   double length;
   double longest;

   area_delta = 0;
   longest = 0;
   for (i=0;i<(_polygonSideCount);i++)
   {
      if (i == (_polygonSideCount-1))
      {
         index1 = 3;
         index2 = 0;
      }
      else
      {
         index1 = i;
         index2 = i+1;
      }
      x2 = (_polyStruct[index1].x -
            _polyStruct[index2].x);
      x2 = x2*x2;
      y2 = (_polyStruct[index1].y -
            _polyStruct[index2].y);
      y2 = y2*y2;
      length = sqrt(x2+y2);


      if (length  > longest)
         longest = length;
	
   }
/* add 100 pixels to length - - 
   equates to .25 inches on each side */

   area_delta = (50.0*longest);
   return((int) area_delta);


} /* create method */
/*********************************************************/
int polyClass::get_lower_area_delta()
{

/* This routine calculates threshold values for the 
   polygon area.  These thresholds will be used by the object
   pair matching algorithm to decide if a shape match is
   necessary.  If the area is outside the threshold values
   there is no reason to to the match 

   Current values reflect a quarter inch delta on the 
   "sides" of the 4 sided polygon used.
*/

   double x2,y2;
   double area_delta;
   int i;
   int index1,index2;
   double length;
   double longest;

   area_delta = 0;
   longest = 0;
   for (i=0;i<(_polygonSideCount);i++)
   {
      if (i == (_polygonSideCount-1))
      {
         index1 = 3;
         index2 = 0;
      }
      else
      {
         index1 = i;
         index2 = i+1;
      }
      x2 = (_polyStruct[index1].x -
            _polyStruct[index2].x);
      x2 = x2*x2;
      y2 = (_polyStruct[index1].y -
            _polyStruct[index2].y);
      y2 = y2*y2;
      length = sqrt(x2+y2);
      if (length > longest)
         longest = length;

   }
	
   area_delta = 50.0*longest;
   return((int) area_delta);
}

/*********************************************************/

int polyClass::linesIntersect()
{

/* refer to  notes.fm for description of equations
   used to determine if the two line segments intersect*/

/* line segments are AB and CD  where entries map:
   0 - A
   1 - B
   2 - C
   3 - D */

/* if any of the point values < 0 the "feature" was
   a page level thing.  The concept of intersection is not
   applicable */

   if (( _polyStruct[0].x < 0) ||
       ( _polyStruct[1].x < 0) ||
       ( _polyStruct[2].x < 0) ||
       ( _polyStruct[3].x < 0) )
   {
      return(non_object);
   }

	
   float r;
   float s;
   int rdenominator;
   int rnumerator;
   int result;

   rdenominator = (int)(((float)(_polyStruct[1].x-_polyStruct[0].x) *
                         (float)(_polyStruct[3].y-_polyStruct[2].y)) -
                        ((float)(_polyStruct[1].y-_polyStruct[0].y) *
                         (float)(_polyStruct[3].x-_polyStruct[2].x)));
   rnumerator = (int)(((float)(_polyStruct[0].y-_polyStruct[2].y) *
                       (float)(_polyStruct[3].x-_polyStruct[2].x)) -
                      ((float)(_polyStruct[0].x-_polyStruct[2].x) *
                       (float)(_polyStruct[3].y-_polyStruct[2].y)));

   if ((rdenominator == 0) && (rnumerator == 0))
   {
      result = coincident;
   }
   else
      if (rdenominator == 0)
      {
         result = parallel;
      }
      else
      {
         r = (float) rnumerator/(float) rdenominator;
         s = (((_polyStruct[0].y-_polyStruct[2].y) *
               (_polyStruct[1].x-_polyStruct[0].x) ) -
              ((_polyStruct[0].x-_polyStruct[2].x) *
               (_polyStruct[1].y-_polyStruct[0].y) ))/
            rdenominator;
         if ((r>=0) && (r<=1) && (s>= 0) && (s <= 1))
         {
            result = intersect; 
         }
         else
         {
            result = no_intersection; 
         }
      }


/*
  r = (((float)(_polyStruct[0].y-_polyStruct[2].y) *
  (float)(_polyStruct[3].x-_polyStruct[2].x) ) -
  ((float)(_polyStruct[0].x-_polyStruct[2].x) *
  (float)(_polyStruct[3].y-_polyStruct[2].y) ))/
  (((float)(_polyStruct[1].x-_polyStruct[0].x) *
  (float)(_polyStruct[3].y-_polyStruct[2].y) ) -
  ((float)(_polyStruct[1].y-_polyStruct[0].y) *
  (float)(_polyStruct[3].x-_polyStruct[2].x) ));
			
  s = (((_polyStruct[0].y-_polyStruct[2].y) *
  (_polyStruct[1].x-_polyStruct[0].x) ) -
  ((_polyStruct[0].x-_polyStruct[2].x) *
  (_polyStruct[1].y-_polyStruct[0].y) ))/
  (((_polyStruct[1].x-_polyStruct[0].x) *
  (_polyStruct[3].y-_polyStruct[2].y) ) -
  ((_polyStruct[1].y-_polyStruct[0].y) *
  (_polyStruct[3].x-_polyStruct[2].x) ));
*/


				
   return (0);

}

/*********************************************************/


float polyClass::getArea()
{

/* see notes.fm file for info on how the area is computed */

   int i;
   float sum;
   float sum1;

   sum1=0;
   sum=0;
   for (i=0;i<(_polygonSideCount-1);i++)
   {
      sum1 = (float) 
         ((_polyStruct[i].x*_polyStruct[i+1].y) -
          (_polyStruct[i].y*_polyStruct[i+1].x) );
      if (sum1 >= 0)
         sum = sum + sum1;
      else sum = sum - sum1;
   }
   return( sum/(float)2.0);


}

/*********************************************************/

static int sortStruct(const void *entry1, const void *entry2)
{
   ptInfo *ent1;
   ptInfo *ent2;

   ent1 = (ptInfo *) entry1;
   ent2 = (ptInfo *) entry2;
   if (ent1->angle > ent2->angle)
      return(1);
   else if ( ent2->angle > ent1->angle)
      return(-1);
   else
      return(0);

}
/*********************************************************/

void polyClass::orderVertices( )
{

   int i;
   float xMean;
   float yMean;
   float deltaX;
   float deltaY;
   ptInfo *points;
   int save_x;
   int save_y;
   int new_x;
   int new_y;

/* to order the vertices compute the centroid, then
   compute the angle each vertice forms with the x
   axis through the centroid.  Finally order the point
   according to the angle */

/* create a mini-structure to aid in sorting later */

   points = (ptInfo *) calloc(_polygonSideCount,
                              sizeof(points[0]));

   xMean = 0;
   yMean = 0;

   for (i = 0;i< _polygonSideCount;i++)
   {
      xMean = xMean + (float) _polyStruct[i].x;
      yMean = yMean + (float) _polyStruct[i].y;
   }


   for (i = 0;i< _polygonSideCount;i++)
   {
      deltaX = (float) _polyStruct[i].x - xMean;
      deltaY = (float) _polyStruct[i].y - yMean;
      points[i].index = i;
      points[i].angle = atan(deltaY/deltaX);
   }

   qsort(points, _polygonSideCount, sizeof(points[0]), 
         sortStruct);

/* now rearrage the order of points in the data structure */

/*
  for (i=0;i<_polygonSideCount;i++)
  {
  printf("unsorted x: %d   y: %d \n",
  _polyStruct[i].x,
  _polyStruct[i].y);
  }
*/

   for (i=0;i<_polygonSideCount;i++)
   {
      /* save existing entry */
	
      save_x = _polyStruct[i].x;
      save_y = _polyStruct[i].y;

      new_x = _polyStruct[points[i].index].x;
      new_y = _polyStruct[points[i].index].y;

      _polyStruct[i].x = new_x;
      _polyStruct[i].y = new_y;

      _polyStruct[points[i].index].x = save_x;
      _polyStruct[points[i].index].y = save_y;

/*
  printf("i: %d  index: %d \n",i, points[i].index);
*/
	
   }

/*
  for (i=0;i<_polygonSideCount;i++)
  {
  printf("sorted x: %d   y: %d \n",
  _polyStruct[i].x,
  _polyStruct[i].y);
  }
*/

/* free tmp data area */

   free(points);

}


