#include <cstdio>
#include <iostream>
#include <fstream>
#include <fstream>
#include <string>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>


#include <scriptClass.h>


#define SKEW_THRESH .0017


/*********************************************/

scriptClass::~scriptClass()
{

int k;
language_profile *lang_ptr;

free (randoms);
free (hamming_lookup);
lang_ptr = (language_profile *) first_lang;
for (k = 0; k < language_count; k++)
	{
		/* need to call this x times for each lang */

		free(lang_ptr->cluster32);
		free(lang_ptr->cluster_data);
		free(lang_ptr->first_cluster);

		lang_ptr++;
	};
free (first_lang);
free (symbol_distribution);
}


/*********************************************/

scriptClass::scriptClass(char *language_list_file)
{

	/* class instance */

	language_profile *lang_ptr;	
	int k;
	int result;
	char *name_ptr;

	/* string language_list_file( "/proj/vision/data/Jargon/Jargon/data/language_list.nt.release3_3"); */

	/* don't change these vals */

	symbol_count = 200;
	rescale_height = 20;
	rescale_width = 20;
	min_comp_size = 20;
	max_height = 500;
	max_width = 500;
	min_height = 6;
	min_width = 6;
	min_symbol_count = 20;
	blob_percent = 75.0;
	rescale_height = 20;
	rescale_width = 20;
	upper_offset = 100;
	lower_offset = 10;
	left_offset = 10;
	hamming = 111;
	right_offset = 10;
	reliability_threshold = .8;
	separation_threshold = .75;
	template_threshold = .67;
	mlp_thresh = .6;
	for (k=0;k<13;k++)
	{
		probs[k] = 1;
	}
	for (k=0;k<4;k++)
	{
		_directions[k] = 1;
	}
	


	/*name_ptr = (char *) language_list_file.c_str(); */
	ReadScriptData(language_list_file, &first_lang, &language_count,
		rescale_height, rescale_width, &template_threshold, NULL);
	symbol_distribution = (float *) calloc(language_count, sizeof(float));

	lang_ptr = (language_profile *) first_lang;
	for (k = 0; k < language_count; k++)
	{
		/* need to call this x times for each lang */

		ConvertData32Bit(lang_ptr, rescale_height, 
			rescale_width, &lang_ptr->cluster32);

		/* advance to the next language */

		lang_ptr++;
	};


  /* generate random number array and hamming lookup tableused by jargon */

  randoms = (float *) calloc(5000, sizeof(float));
  generate_random_number_array(randoms, 5000);
  hamming_lookup = (unsigned int*)calloc(sizeof(unsigned int),65536);
  CreateHammingLUT32((int *) hamming_lookup,65536);


} /* create method */


/****************************************************************/
void scriptClass::getScript(TBdocument *strDocument,char *ptr)
{
	char *name_ptr;
	int result;
/*
	TBdocument strDocument;
*/
	int symbols_used_for_id;
	int symbols_scanned;
	int symbols_filtered;
	float stddev;
	float separation;
	char orientation[2];
	char script_identified[100];
	int i;	
	


/*
	name_ptr = (char *) image_file_path.c_str();

	result = tbOpen(name_ptr, &strDocument,
		1, 4, 0, NULL, 0, 0);
	if (result < 0)
	{
		printf("could not open file: %s\n", name_ptr);
	}
*/
	for (i =0;i< language_count; i++)
		symbol_distribution[i] = 0.0;

	identify_and_orient(hamming, min_comp_size, max_height,
		max_width, min_height, min_width, min_symbol_count,
		&blob_percent, symbol_count, rescale_height,
		rescale_width, upper_offset, lower_offset,
		left_offset, right_offset, &reliability_threshold,
		strDocument, language_count, first_lang,
		script_identified, &symbols_used_for_id,
		&symbols_scanned, &symbols_filtered,
		randoms, 5000, &separation_threshold, best_fit_script,
		second_best_script, &stddev, &separation, 1,
		symbol_distribution,
		hamming_lookup, probs, &mlp_thresh, orientation,
		_directions);

	_orientation = atoi(orientation);

	strcpy(ptr,script_identified);

}

/****************************************************************/
void scriptClass::changeBorders(int top, int left, int bottom,
	int right)
{

	upper_offset = top;
	lower_offset = bottom;
	right_offset = right;
	left_offset = left;

}

/****************************************************************/
void scriptClass::setDirections(int newdirections[4] )
{
	int i;

	for (i=0;i<4;i++)
		_directions[i] = newdirections[i];

}

/****************************************************************/
void scriptClass::enableScript(int scriptNo)
{

	probs[scriptNo]=1;
}
/****************************************************************/
void scriptClass::disableScript(int scriptNo)
{

	probs[scriptNo]=0;
}


