/* TestingClass.h
 */

#include "utility.h"
#include "../PageLayoutLib/objectPairClass.h"
#include "../Layout_hm/layout.h"
#include "../PairVector_hm/pairshape.h"
#include "../Utility_hm/TArray.h"

class TestingClass
{
   public:
   //TestingClass();
   TestingClass(string sourcedataset, string outputfile, int method);
   ~TestingClass();

   void	LoadTrainingResults(string trainrstfile);
	
   void	Run();
   void	Reset();
	
   // parameter setting routines
   void	SetSortFlag(bool flag) { m_sortflag = flag; }
   void	SetMaxNbTextlines(int m) { m_maxNbTxline = m; }	
   void	SetPairStyle( int m) { m_psv_style = m; }
   void	SetScoringMethod(int m) { m_neighbor = m; } //choices are: BEST_NEIGHBOR, NEAREST_NEIGHBOR and GAUSS_NEIGHBORHOOD
   // default is NEAREST_NEIGHBOR	
   private:
   string				m_sDataPath;		// filefolder that holds the testing document images
   string				m_outputFname;		// file for output testing scores
   cstring_array		m_FnameList;		// testing file name list
   int					m_nTestDoc;	

   CTArray<double>     m_scoreList;        // testing results/scores
   bool				m_sortflag;			// if true, then sort the scores

   int					m_method;
   int					m_psv_style; 
   int					m_neighbor;			// methods to determine the neighbor of a testing polygon
	
   int					m_maxNbTxline;	    // maximum number of textlines to be detected in the given document image 
	

   // parameters used with different training method
   pairshape_cluster_list *	m_wanted_pairshape_cluster;
   Clayout	*					m_wanted_objcluster;
   objectPairClass *			m_wanted_objPairClass;

   void	SortScores(cstring_array & source, CTArray<double> & scorearray, FILE *fp);
	
   /* trainig routines called with different m_method */
   void	RunPairGeneric();

   void	RunPairVector();
	
   void	RunObjVector();

};
