/* TrainingClass.h
 */
#include "../ObjectVector_hm/objcluster.h"
#include "../Layout_hm/layout.h"
#include "../PageLayoutLib/objectPairClass.h"
#include "utility.h"


class TrainingClass
{
   public:	
   //TrainingClass();
   TrainingClass(char * wantedfiles, char* unwantedfiles, char* wantedoutput, char * unwantedoutput, int method = PAIR_GENERIC);
   ~TrainingClass();

   void	Run();
   void	Reset();
	
   // parameter setting routines
   void	SetMethod(int m){ m_method = m; }
   void	SetMergyStyle(int m) { m_mergy_style = m; }
   void	SetMaxNbTextlines(int m) { m_maxNbTxline = m; }

   // for kmeans clustering for SINGLE_VECTOR_XXX methods only
   void	SetNbIterations(int m) {m_maxIter = m; }
   void	SetWantedObjClusterNumber(int m) { m_nWantedObjCluster = m;}
   void	SetUnwantedObjClusterNumber(int m) { m_nUnwantedObjCluster = m;}
   void	SetPairStyle( int m) { m_psv_style = m; }

   private:
   string			m_sWanted_input_path;
   string			m_sUnwanted_input_path;
   string			m_sWanted_output_fname;
   string			m_sUnwanted_output_fname;

   int				m_method;				// training method
   int				m_mergy_style;          // mergy method used in PairGeneric training process 

   cstring_array	m_WantedFnameList;	    // training filename list (wanted)
   int				m_nWantedDoc;

   cstring_array	m_UnwantedFnameList;    // training filename list (unwanted)
   int				m_nUnwantedDoc;

   int				m_maxNbTxline;         // maximum number of textlines to be detected in the given document image 
   int				m_nWantedObjCluster;   // Targeted number of wanted object(5d textline description vector) cluter
   int				m_nUnwantedObjCluster; // .....              unwanted

   int				m_maxIter;             // maximum interations in Kmeans clustering    

   int				m_psv_style;		   // for PAIR_VECTOR_XXXX method, choices are :PSV_N_1 and PSV_N_2	

   private:
	
   // mergy objPairs from one or multiple documents into several clusters
   // called in PairGeneric method, with mergy style DYN_APPROXIMATED.
   void	MergePairs(objectPairClass *dest, objectPairClass** source, int nDoc); 

   /* training routines called with different m_method */
	
   void	RunPairGeneric();
	
   void    RunPairVRoutines();
	
   void	RunObjVRoutines();

};
