
#ifndef UTILITY_H_HM_2005_06_16
#define UTILITY_H_HM_2005_06_16

#include "../PageLayoutLib/objectPairClass.h"
#include "../PairVector_hm/pairshape.h"
#include "../ObjectVector_hm/objcluster.h"
#include "../Layout_hm/layout.h"
#include <string>
#include <deque>
typedef deque<string> cstring_array;


// training methods
#define PAIR_GENERIC            0		// using Arkin's turning function to represent a polygon formed by textline pair
#define PAIR_VECTOR_BOTH		1       // using 5D vectors to describe the polygon shape formed by textline pair
#define SINGLE_VECTOR_BOTH      2		// using 5D vectors to describe the single textline properties
#define PAIR_VECTOR_WANTED		3       // same as 1, but without use of unwanted training samples
#define SINGLE_VECTOR_WANTED    4		// same as 2, but without use of unwanted training samples

//// for pairshape vector method, which uses a virtue textline and each textline to form a pair
//#define PAIR_VECTOR_BOTH_N_1	5        
//#define PAIR_VECTOR_WANTED_N_1	6  

#define PSV_N_1					1
#define PSV_N_2					0

// mergy style 
#define FIRST_CENTROID		    0		// used in method 0, choose the first polygon as cluster centroid
#define DYN_APPROXIMATED		1		// used in method 0, dynamically changing the centroid as the one with minimum sum of distance to all cluster members
#define KMEANS_MERGY            2	    // for all vector based methods


// definitions used for TestingClass::m_neighbor
// scoring methods in testing process, valid only in PAIR_GENERIC method
// all methods are to choose training clusters within fixed similarity range to a testing polygon(cluster)
#define BEST_NEIGHBOR		    0		// choose the training cluster with the hightest training score, 
#define NEAREST_NEIGHBOR		1		// choose the training cluster with the hightest similiary to the testing polygon, 
#define GAUSS_NEIGHBORHOOD		2       // use sum of all the training clusters within the whole range,weighted by similarity distance 


// find filenames whose suffix match "file_attr" in the folder of "path" including subfolders,
// and put all entries into "filearray"
void	FindFile(string path, char * file_attr, cstring_array * filearray);

// load all tiff images' filenames under the folder of "filefolder" into "retSet".
// this function is a simple call to "FindFile()"
int		LoadTiffImageSet(cstring_array &retSet, string filefolder);

// routine used for extract textlines from the document "fname" 
// and form textline pairs for PairGeneric method
objectPairClass* ExtractObjPair(string fname, int maxNbTxline = 128);

// routine used for extract textlines from the document "fname" 
// and form 5D textline pair vectors for Pair_VECTOR_XX method
pairshape_cluster_list* ExtractObjPairVector(string fname, int style , int nline = 128, int docID = 0);

// local function used in TestingClass::SortScores();
int		MyCmp(const void * arg1, const void * arg2);

// compute the probability that a testing layout belongs to the training class
// used in 5D SINGLE_VECTOR_XX method
double  BelongProb(objcluster *pClusters, int nCluster, Clayout *pTest);

#endif
