// TArray.h: interface for the CTArray class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TARRAY_H__5C18C5F4_170D_4D56_BFDA_B5173B41596D__INCLUDED_)
#define AFX_TARRAY_H__5C18C5F4_170D_4D56_BFDA_B5173B41596D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



template <class TYPE> class CTArray  
{
	
   private:
   TYPE* m_memory;      
   bool  m_isAllocated; 
   long  m_dimension;   
   long  m_activeIndex; 
     
   public:
   CTArray();                                                     
   CTArray( long dimension );                                     
   CTArray( TYPE* memory, long dimension, long activeIndex = 0 ); 
   CTArray( const CTArray< TYPE >& array );                       
   ~CTArray();                                                    

   public:
   void Construction( long dimension );                                     
   void Construction( TYPE* memory, long dimension, long activeIndex = 0 ); 
   void Construction( const CTArray< TYPE >& array );                      
   void Destruction();                                                      

   void ImportFrom( const void* source );    
   void ExportTo( void* destination ) const; 
	
   TYPE& operator[]( long index ) const;                         
   TYPE& operator*() const;                                      

   CTArray< TYPE >& operator= ( const CTArray< TYPE >& array );  
   CTArray< TYPE >& operator&=( const CTArray< TYPE> & array );  

   //bool operator==( const CTArray< TYPE >& array ) const;        
   //bool operator!=( const CTArray< TYPE >& array ) const;        
   //bool operator>=( const CTArray< TYPE >& array ) const;        
   //bool operator> ( const CTArray< TYPE >& array ) const;        
   //bool operator<=( const CTArray< TYPE >& array ) const;        
   //bool operator< ( const CTArray< TYPE >& array ) const;        

   //CTArray< TYPE >& operator+ ( long step ) const;               
   //CTArray< TYPE >& operator+=( long step );                     

   //CTArray< TYPE >& operator- ( long step ) const;               
   //CTArray< TYPE >& operator-=( long step );                     

   //CTArray< TYPE >& operator++();                                
   //CTArray< TYPE >& operator++( int );                           

   //CTArray< TYPE >& operator--();                                
   //CTArray< TYPE >& operator--( int );                           

   //long operator-( const CTArray< TYPE >& array ) const;         
	
   bool Is_index_valid( long index ) const;                        

	
   public:
   bool IsNull() const;         
   bool IsNotNull() const;      
   long GetDimension() const;   
   long GetSizeInBytes() const; 

   long GetLowerBound() const; 
   long GetUpperBound() const;  
	
   TYPE * GetMemoryPointer() const;  

   private:
   void Verification( char* message ) const; 

};

#ifndef _TARRAY_CPP_BY_MAY_HUANG_28_SEPT_2005_
#define _TARRAY_CPP_BY_MAY_HUANG_28_SEPT_2005_
#include "TArray.cpp"
#endif

#endif // !defined(AFX_TARRAY_H__5C18C5F4_170D_4D56_BFDA_B5173B41596D__INCLUDED_)
