// TMatrix.h: interface for the CTMatrix class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TMATRIX_H__D0F25BB1_AE4C_42ED_BFD4_89FECA42E86A__INCLUDED_)
#define AFX_TMATRIX_H__D0F25BB1_AE4C_42ED_BFD4_89FECA42E86A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TArray.h"


template <class TYPE> class CTMatrix  
{	
   private:
   TYPE* m_memory;  
   long  m_rows;    
   long  m_columns; 

	
   public:
   CTMatrix();                                  
   CTMatrix( long rows, long columns );         
   CTMatrix( const CTMatrix< TYPE >& matrix );  
   ~CTMatrix();                                 

   public:
   void Construction( long rows, long columns );        
   void Construction( const CTMatrix< TYPE >& matrix ); 
   void Destruction();                                  

   void ImportFrom( const void* source );   
   void ExportTo( void* destination ) const; 

   CTMatrix< TYPE >& operator=( const CTMatrix< TYPE >& matrix ) ; 

#ifdef _DEBUG
   CTArray< TYPE >& operator[]( long index ) const;               
#else // _DEBUG
   TYPE*            operator[]( long index ) const;                
#endif // _DEBUG

//	TYPE&            operator[]( const CImagePoint& point ) const; 

   //bool Is_point_valid( const CImagePoint& point ) const; 
   bool Is_row_valid( long row ) const;                   
   bool Is_column_valid( long column ) const;             

   public:
   bool IsNull() const;              
   bool IsNotNull() const;           

   long GetRows() const;            
   long GetColumns() const;          

   long Get_height() const;         
   long Get_width() const;          

   /*long GetRowUpperBound() const;    
     long GetColumnUpperBound() const; */

   long GetElements() const;         
   long GetSizeInBytes() const;      

   TYPE * GetMemoryPointer() const;  

//	CImagePoint Get_size() const;     

	
   private:
   void Initialization(); 

   void Verification( char* message ) const; 

};


#ifndef WIN32
#include "TMatrix.cpp"
#endif

#endif // !defined(AFX_TMATRIX_H__D0F25BB1_AE4C_42ED_BFD4_89FECA42E86A__INCLUDED_)
