// doclibPageLayoutDriver.cpp : Defines the entry point for the console application.
//

/// The example below shows the usage of pagelayout classification functions. 

#include "../TrainingTesting_Classes_hm/TrainingClass.h"
#include "../TrainingTesting_Classes_hm/TestingClass.h"


int main()
{
   //......

   /********* training ***********************************/
   // construct a TrainingClass instance
   TrainingClass	train( "..\\..\\..\\data\\driver_data\\tmp_wanted", 			 // wanted training file folder, cannot be null
                               "..\\..\\..\\data\\driver_data\\tmp_unwanted", 			 // wanted training file folder, can be null if method is XXXX_XXX_WANTED
                               "..\\..\\..\\data\\driver_data\\wanted.txt",			     // outpute file for recording training result of wanted samples, can be null
                               "..\\..\\..\\data\\driver_data\\unwanted.txt",			 // outpute file for recording training result of wanted samples, can be null 
                               PAIR_VECTOR_BOTH);										 // training method, choices are: PAIR_GENERIC, PAIR_VECTOR_BOTH, SINGLE_VECTOR_BOTH, PAIR_VECTOR_WANTED, SINGLE_VECTOR_WANTED
   // PAIR_GENERIC is default value

   // set parameters for Training, in the form of train.SetXXXXXXX();
   // you can set training methods if not specified in the above constructor;
   // you can specify mergy style for PAIR_GENERIC method, default is DYN_APPROXIMATED
   // you can specify maximum number of textlines to be detected for a training document
   // you can specify targeted number of textline clusters for (un)wanted training samples if you are using SINGLE_VECTOR_XXX method
   // you can specify the maximum number of iterations for Kmeans clustering if you use SINGLE_VECTOR_XXX method
    
   train.Run();  // you can add timer functions around this line to record the training time 
 
   /********* end of training **************************/


   /**********testing ***********************************/
   /* Note: it is NOT necessary to put training and testing process inside one function */
    
   // construct a TestingClass instance
   TestingClass  test("..\\..\\..\\data\\driver_data\\test", 			  // filefolder that holds the testing document image set
                      "..\\..\\..\\data\\driver_data\\rst.txt",		  // output file for recording the score of each testing image
                      PAIR_VECTOR_BOTH);								  // testing method, same definition as training method, PAIR_GENERIC is default value  

   // Loading training results from disk, 
   // Note the filename will indicate the method used in training, and
   // the function will examine whether this method matches the testing method
   // specified in the constructor above.
   // "_n" in the filename indicate the training method.
   test.LoadTrainingResults("..\\..\\..\\data\\driver_data\\wanted_1.txt"); 
	
	
   // set parameters for testing, in the form of test.SetXXXXXXX();
   // Note: SetPairStyle() should be called before LoadTrainigResults();
   // you can choose whether to sort the testing scores of all testing images descendenly ;
   // you can specify scoring method (see utility.h for detail), NEAREST_NEIGHBOR is the default value
   // you can specify maximum number of textlines to be detected for a testing document image;
    
   test.Run(); 
	
   /********* end of testing **************************/
	
   //......

   return 0;
}
